
# Library configuration makefile
# Look for the *** Edit here *** comments.
# Commit this file into the repository when you've finished.

#------------------------------------------------------------------------------

# *** Edit here ***
# Substitute CONFIGNAME for your chosen configuration name.
# Name of configuration (ie name of output library)
export CONFIG = parse_mk5

#------------------------------------------------------------------------------

# Name of this file
MAKEFILE = $(CONFIG).mak

#------------------------------------------------------------------------------

# *** Edit here ***
# Libraries on which this depends
#TARGETDEFS += 

# You may also need to edit ...

# Add the external packages we need here
#XLIBLIST += 

#------------------------------------------------------------------------------

# Where to find sources - $(MODULE) is inherited from calling Makefile
vpath %.C $(SRCPATH)/$(MODULE)
# Where to find headers
vpath %.h $(INCLPATH)/$(MODULE)

#------------------------------------------------------------------------------

# Participating sources - all of them
# SOURCES := $(notdir $(wildcard $(SRCPATH)/$(MODULE)/*.C))
SOURCES := parse_mk5.C

# *** Edit here ***
# You may need to filter out some files for this configuration
#SOURCES := $(filter-out unwanted_junk.C, $(SOURCES))

# If you're using QT, specify any .C files that are going to be
# generated using MOC. Assumption is that they will take the name of the
# input header file, prefixed with 'MOC_'.
#SRCMETA	=	MOC_select_expt_widget.C MOC_expt_widget.C
#SOURCES += $(SRCMETA)

# Headers of primary interest - all of them
#HDRS := $(notdir $(wildcard $(INCLPATH)/$(MODULE)/*.h))
HDRS := $(SOURCES:.C=.h)

# Objects needed for library build
OBJS := $(SOURCES:.C=.o)

#------------------------------------------------------------------------------

# bodgebodgebodge ... would like these somewhere central, but they're no use
# in the preferences file (need unexporting and/or overriding for the
# $(CONFIG) to take effect. So have to put them here in all library
# configurations for the time being, seeing that's the simplest.

export LIBNAME       := $(LIBPATH)/lib$(CONFIG)

# Archive library name
export LIBRARY       := $(LIBNAME).a

# Shared library name
export SHLIB         := $(LIBNAME).$(SHLIBEXT)

#------------------------------------------------------------------------------

# Targets ...

# Point of this makefile
all: $(LIBRARY) $(SHLIB)
.PHONY: all

# Standard rules
include $(workarea)/make/rules.mak

# Regenerate & include dependencies - GNU make specific
include $(SOURCES:.C=.d)

$(MAKEFILE):	$(BASEPATH)/build/$(MODULE)/$(MAKEFILE)
		$(config_fragment)

$(LIBRARY):	$(OBJS) $(MAKEFILE)
		$(closed_archive)

$(SHLIB):	$(OBJS) $(MAKEFILE)
		$(closed_shlib)

# Kneecap the install rule
install:
		@echo "Library is already installed"
.PHONY: install

# And here's a nice set of override commands

# make archive library only
archiveonly:	$(LIBRARY)
.PHONY: archiveonly

# regenerate closed archive from existing objects
# (will run dummy link)
rearchive:
		@rm -f $(LIBRARY)
		$(closed_archive)
.PHONY: rearchive

# recreate closed shlib from existing objects
# (no dummy link)
relink:
		@rm -f $(SHLIB)
		$(closed_shlib)
.PHONY: relink

# make open versions of library 
# (defer template instantiation until final program link)
openlibs:
		@rm -f $(LIBRARY) $(SHLIB)
		$(open_archive)
		$(open_shlib)
.PHONY: openlibs

# recreate open archive from existing objects
rearchiveopen:
		@rm -f $(LIBRARY)
		$(open_archive)
.PHONY: rearchiveopen

# recreate open shlib from existing objects
relinkopen:
		@rm -f $(SHLIB)
		$(closed_shlib)
.PHONY: relinkopen

#------------------------------------------------------------------------------

