
# Program configuration Makefile
# Look for the *** Edit here *** comments.
# Commit this file into the repository when you've finished.

#------------------------------------------------------------------------------

# *** Edit here ***
# Set the name of this makefile - substitute CONFIGNAME for 
# your chosen configuration name
MAKEFILE = test_mark5b.mak

#------------------------------------------------------------------------------

# *** Edit here ***
# Change inherited definitions as appropriate.

# Augment C++ flags if need be

# Augment linker flags if needed
#
TARGETDEFS +=  MARK5B_BUILD

export MARK5B_CONTROLLIBS = m
XLIBLIST += MARK5B_CONTROL

# Add the external packages we need here
XLIBLIST += MYSQL

#------------------------------------------------------------------------------

# *** Edit here ***
# Edit this so that your required libraries are listed

TARGETLIBS += jive_message_sets job_descr \
		jive_msgs message_base std_threads herbert \
		socket++ controllers jccs_util store_classes \
		jive_locations location_client errors \
		persist polynomials hw_sw_setup_db \
		COF 


#------------------------------------------------------------------------------

# Where to find sources - $(MODULE) is inherited from calling Makefile
vpath %.C $(SRCPATH)/$(MODULE)
vpath %.l $(SRCPATH)/$(MODULE)
# Where to find headers
vpath %.h $(INCLPATH)/$(MODULE)

#------------------------------------------------------------------------------

# *** Edit here ***
# You may need to exclude certain programs from a configuration,
# generate source files from lex sources, etc.
# If so, edit this section.

# Participating sources
CXXSOURCES := mark5b_connection.C ndbg_mark5b.C generated_mess.C test_mark5b.C

# If you're using QT, specify any .C files that are going to be
# generated using MOC. Assumption is that they will take the name of the
# input header file, prefixed with 'MOC_'.
#SRCMETA = MOC_select_expt_widget.C MOC_expt_widget.C
#CXXSOURCES += $(SRCMETA)

# Example of filtering out a program
#CXXSOURCES := $(filter-out awkward_prog.C, $(CXXSOURCES))

# Example of using lex ...
# Find all lex sources
#LEXSOURCES := $(notdir $(wildcard $(SRCPATH)/$(MODULE)/*.l))
# And add generated C++ files to list of source files
#ALLSOURCES := $(CXXSOURCES) $(LEXSOURCES:.l=.C)

# No lex files - use this.
ALLSOURCES := $(CXXSOURCES)

#------------------------------------------------------------------------------

# Headers of primary interest
HDRS := $(CXXSOURCES:.C=.h)
HDRS := $(filter-out test_mark5b.h generated_mess.h, $(HDRS)) message_structs.h message_codes.h message_defs.h generated_mess_headers.h generated_mess_templates.h message_structs_constructors.h

# Objects needed for building programs
OBJS := $(ALLSOURCES:.C=.o)

#------------------------------------------------------------------------------

# *** Edit here ***
# List your output program(s)

PROGRAMS = test_mark5b

#------------------------------------------------------------------------------

# Point of this makefile
all:	$(PROGRAMS)
.PHONY: all

# Standard rules
include $(workarea)/make/rules.mak

# Regenerate & include dependencies
include $(CXXSOURCES:.C=.d)

# *** Edit here *** if you're using lex or doing something odd like that.
#include $(LEXSOURCES:.l=.d)

# Get a newer copy of this makefile, if necessary
$(MAKEFILE):	$(BASEPATH)/build/$(MODULE)/$(MAKEFILE)
		$(config_fragment)

# Install modified programs
install:	$(PROGRAMS)
		$(prog_install)
.PHONY: install

#------------------------------------------------------------------------------

# *** Edit here ***
# Program -> object file mappings, and call to command sequence.

test_mark5b:	$(OBJS)
		$(prog_build)

#------------------------------------------------------------------------------


