#ifndef MARK5B_STATUS_H
#define MARK5B_STATUS_H

#include <fundamental/ccc_constants.h>
#include <su_control/message_defs.h>
#include <string>

class Mark5B_Status {
 public:
  Mark5B_Status();

  std::string get_mounted_vsn() const ;
  std::string get_mounted_vsn(int bank) const;

  void set_mounted_vsn(const std::string& vsn, int bank = 0);

  inline int get_bank() const;

  void process_m5_status(const M5_Status& msg);
  void process_mounted_msg(const Mount_Change& msg);
  bool enquire_vsn(const std::string& vsn);
  U32 get_status_word();

 protected:
  std::string _mounted_vsn[MAX_NR_BANKS];
  int _bank_enquired; // will be -1 for no bank enquired, MAX_NR_BANKS for a wildcard enquire, otherwise 0 means bank A, 1 means bank B
  U32 _last_status;

};

int Mark5B_Status::get_bank() const {
  return _bank_enquired;
}

#endif
