#ifndef MESSAGE_STRUCTS_EXTENDED_H
#define MESSAGE_STRUCTS_EXTENDED_H
#include <su_control/message_structs.h>
#include <su_control/message_codes.h>
#include <iostream>
struct Ext_Generate_Root : public Generate_Root {
  Ext_Generate_Root(int job_id) {
    bin_head.msg_code = GENERATE_ROOT;
    bin_head.task_id = job_id;
  }
 public:
  friend std::ostream& operator<< (std::ostream& out, const Ext_Generate_Root&  msg) {
    out 
    << "ekey ";
    out << std::endl; 
    for (int dim0 = 0; dim0 < sizeof(msg.ekey)/sizeof(msg.ekey[0]); dim0++) {
      out << msg.ekey[dim0] << " ";
    }
    out  << std::endl 
    << "scan_id ";
    out << std::endl; 
    for (int dim0 = 0; dim0 < sizeof(msg.scan_id)/sizeof(msg.scan_id[0]); dim0++) {
      out << msg.scan_id[dim0] << " ";
    }
    out  << std::endl 
    << "init_key ";
    out << std::endl; 
    for (int dim0 = 0; dim0 < sizeof(msg.init_key)/sizeof(msg.init_key[0]); dim0++) {
      out << msg.init_key[dim0] << " ";
    }
    out  << std::endl 
    << "corr_mode ";
    out << std::endl; 
    for (int dim0 = 0; dim0 < sizeof(msg.corr_mode)/sizeof(msg.corr_mode[0]); dim0++) {
      out << msg.corr_mode[dim0] << " ";
    }
    out  << std::endl 
    << "stations ";
    out << std::endl; 
    for (int dim0 = 0; dim0 < sizeof(msg.stations)/sizeof(msg.stations[0]); dim0++) {
      out << msg.stations[dim0] << " ";
    }
    out  << std::endl 
    << "ap_length " << msg.ap_length << std::endl 
    << "mirror_flags " << msg.mirror_flags << std::endl 
    << std::endl;
    return out;
  }
};
struct Ext_Root_Complete : public Root_Complete {
  Ext_Root_Complete(int job_id) {
    bin_head.msg_code = ROOT_COMPLETE;
    bin_head.task_id = job_id;
  }
 public:
  friend std::ostream& operator<< (std::ostream& out, const Ext_Root_Complete&  msg) {
    out 
    << "root_filename ";
    out << std::endl; 
    for (int dim0 = 0; dim0 < sizeof(msg.root_filename)/sizeof(msg.root_filename[0]); dim0++) {
      out << msg.root_filename[dim0] << " ";
    }
    out  << std::endl 
    << std::endl;
    return out;
  }
};
struct Ext_Root_Failure : public Root_Failure {
  Ext_Root_Failure(int job_id) {
    bin_head.msg_code = ROOT_FAILURE;
    bin_head.task_id = job_id;
  }
 public:
  friend std::ostream& operator<< (std::ostream& out, const Ext_Root_Failure&  msg) {
    out 
    << "return_code " << msg.return_code << std::endl 
    << std::endl;
    return out;
  }
};
struct Ext_Initialize_Correlator : public Initialize_Correlator {
  Ext_Initialize_Correlator(int job_id) {
    bin_head.msg_code = INITIALIZE_CORRELATOR;
    bin_head.task_id = job_id;
  }
 public:
  friend std::ostream& operator<< (std::ostream& out, const Ext_Initialize_Correlator&  msg) {
    out 
    << "ivex_key ";
    out << std::endl; 
    for (int dim0 = 0; dim0 < sizeof(msg.ivex_key)/sizeof(msg.ivex_key[0]); dim0++) {
      out << msg.ivex_key[dim0] << " ";
    }
    out  << std::endl 
    << "su_list ";
    out << std::endl; 
    for (int dim0 = 0; dim0 < sizeof(msg.su_list)/sizeof(msg.su_list[0]); dim0++) {
      out << (int)msg.su_list[dim0] << " ";
    }
    out  << std::endl 
    << std::endl;
    return out;
  }
};
struct Ext_Correlator_Initialized : public Correlator_Initialized {
  Ext_Correlator_Initialized(int job_id) {
    bin_head.msg_code = CORRELATOR_INITIALIZED;
    bin_head.task_id = job_id;
  }
 public:
  friend std::ostream& operator<< (std::ostream& out, const Ext_Correlator_Initialized&  msg) {
    out 
    << "link_status ";
    out << std::endl; 
    for (int dim0 = 0; dim0 < sizeof(msg.link_status)/sizeof(msg.link_status[0]); dim0++) {
      out << std::endl; 
      for (int dim1 = 0; dim1 < sizeof(msg.link_status[0])/sizeof(msg.link_status[0][0]); dim1++) {
        out << (int)msg.link_status[dim0][dim1] << " ";
      }
    }
    out  << std::endl 
    << std::endl;
    return out;
  }
};
struct Ext_Configure_Correlator : public Configure_Correlator {
  Ext_Configure_Correlator(int job_id) {
    bin_head.msg_code = CONFIGURE_CORRELATOR;
    bin_head.task_id = job_id;
  }
 public:
  friend std::ostream& operator<< (std::ostream& out, const Ext_Configure_Correlator&  msg) {
    out 
    << "root_filename ";
    out << std::endl; 
    for (int dim0 = 0; dim0 < sizeof(msg.root_filename)/sizeof(msg.root_filename[0]); dim0++) {
      out << msg.root_filename[dim0] << " ";
    }
    out  << std::endl 
    << "ref_station_order ";
    out << std::endl; 
    for (int dim0 = 0; dim0 < sizeof(msg.ref_station_order)/sizeof(msg.ref_station_order[0]); dim0++) {
      out << msg.ref_station_order[dim0] << " ";
    }
    out  << std::endl 
    << "configure_cot " << msg.configure_cot << std::endl 
    << "stream " << (int)msg.stream << std::endl 
    << "slice_pool " << (int)msg.slice_pool << std::endl 
    << std::endl;
    return out;
  }
};
struct Ext_Cu_Configuration : public Cu_Configuration {
  Ext_Cu_Configuration(int job_id) {
    bin_head.msg_code = CU_CONFIGURATION;
    bin_head.task_id = job_id;
  }
 public:
  friend std::ostream& operator<< (std::ostream& out, const Ext_Cu_Configuration&  msg) {
    out 
    << std::endl;
    return out;
  }
};
struct Ext_Cu_Resource_Error : public Cu_Resource_Error {
  Ext_Cu_Resource_Error(int job_id) {
    bin_head.msg_code = CU_RESOURCE_ERROR;
    bin_head.task_id = job_id;
  }
 public:
  friend std::ostream& operator<< (std::ostream& out, const Ext_Cu_Resource_Error&  msg) {
    out 
    << "return_code " << msg.return_code << std::endl 
    << std::endl;
    return out;
  }
};
struct Ext_Correlator_Abort : public Correlator_Abort {
  Ext_Correlator_Abort(int job_id) {
    bin_head.msg_code = CORRELATOR_ABORT;
    bin_head.task_id = job_id;
  }
 public:
  friend std::ostream& operator<< (std::ostream& out, const Ext_Correlator_Abort&  msg) {
    out 
    << "abort_flags " << msg.abort_flags << std::endl 
    << "station " << msg.station << std::endl 
    << std::endl;
    return out;
  }
};
struct Ext_Corrtask_Complete : public Corrtask_Complete {
  Ext_Corrtask_Complete(int job_id) {
    bin_head.msg_code = CORRTASK_COMPLETE;
    bin_head.task_id = job_id;
  }
 public:
  friend std::ostream& operator<< (std::ostream& out, const Ext_Corrtask_Complete&  msg) {
    out 
    << "slice_count " << msg.slice_count << std::endl 
    << "error_flags " << msg.error_flags << std::endl 
    << std::endl;
    return out;
  }
};
struct Ext_Realtime_Display : public Realtime_Display {
  Ext_Realtime_Display(int job_id) {
    bin_head.msg_code = REALTIME_DISPLAY;
    bin_head.task_id = job_id;
  }
 public:
  friend std::ostream& operator<< (std::ostream& out, const Ext_Realtime_Display&  msg) {
    out 
    << "baseline ";
    out << std::endl; 
    for (int dim0 = 0; dim0 < sizeof(msg.baseline)/sizeof(msg.baseline[0]); dim0++) {
      out << msg.baseline[dim0] << " ";
    }
    out  << std::endl 
    << "chan_name ";
    out << std::endl; 
    for (int dim0 = 0; dim0 < sizeof(msg.chan_name)/sizeof(msg.chan_name[0]); dim0++) {
      out << msg.chan_name[dim0] << " ";
    }
    out  << std::endl 
    << "enable " << (int)msg.enable << std::endl 
    << std::endl;
    return out;
  }
};
struct Ext_Realtime_Data : public Realtime_Data {
  Ext_Realtime_Data(int job_id) {
    bin_head.msg_code = REALTIME_DATA;
    bin_head.task_id = job_id;
  }
 public:
  friend std::ostream& operator<< (std::ostream& out, const Ext_Realtime_Data&  msg) {
    out 
    << "chan_name ";
    out << std::endl; 
    for (int dim0 = 0; dim0 < sizeof(msg.chan_name)/sizeof(msg.chan_name[0]); dim0++) {
      out << msg.chan_name[dim0] << " ";
    }
    out  << std::endl 
    << std::endl;
    return out;
  }
};
struct Ext_Correlator_Stats : public Correlator_Stats {
  Ext_Correlator_Stats(int job_id) {
    bin_head.msg_code = CORRELATOR_STATS;
    bin_head.task_id = job_id;
  }
 public:
  friend std::ostream& operator<< (std::ostream& out, const Ext_Correlator_Stats&  msg) {
    out 
    << "su ";
    out << std::endl; 
    for (int dim0 = 0; dim0 < sizeof(msg.su)/sizeof(msg.su[0]); dim0++) {
      out << (int)msg.su[dim0] << " ";
    }
    out  << std::endl 
    << "numChannels " << (int)msg.numChannels << std::endl 
    << "ChnData ";
    out << std::endl; 
    for (int dim0 = 0; dim0 < sizeof(msg.ChnData)/sizeof(msg.ChnData[0]); dim0++) {
      out << (int)msg.ChnData[dim0] << " ";
    }
    out  << std::endl 
    << std::endl;
    return out;
  }
};
struct Ext_Initialize_Sus : public Initialize_Sus {
  Ext_Initialize_Sus(int job_id) {
    bin_head.msg_code = INITIALIZE_SUS;
    bin_head.task_id = job_id;
  }
 public:
  friend std::ostream& operator<< (std::ostream& out, const Ext_Initialize_Sus&  msg) {
    out 
    << "ivex_key ";
    out << std::endl; 
    for (int dim0 = 0; dim0 < sizeof(msg.ivex_key)/sizeof(msg.ivex_key[0]); dim0++) {
      out << msg.ivex_key[dim0] << " ";
    }
    out  << std::endl 
    << "su_list ";
    out << std::endl; 
    for (int dim0 = 0; dim0 < sizeof(msg.su_list)/sizeof(msg.su_list[0]); dim0++) {
      out << (int)msg.su_list[dim0] << " ";
    }
    out  << std::endl 
    << std::endl;
    return out;
  }
};
struct Ext_Sus_Initialized : public Sus_Initialized {
  Ext_Sus_Initialized(int job_id) {
    bin_head.msg_code = SUS_INITIALIZED;
    bin_head.task_id = job_id;
  }
 public:
  friend std::ostream& operator<< (std::ostream& out, const Ext_Sus_Initialized&  msg) {
    out 
    << "su_init_flags ";
    out << std::endl; 
    for (int dim0 = 0; dim0 < sizeof(msg.su_init_flags)/sizeof(msg.su_init_flags[0]); dim0++) {
      out << msg.su_init_flags[dim0] << " ";
    }
    out  << std::endl 
    << std::endl;
    return out;
  }
};
struct Ext_Configure_Sus : public Configure_Sus {
  Ext_Configure_Sus(int job_id) {
    bin_head.msg_code = CONFIGURE_SUS;
    bin_head.task_id = job_id;
  }
 public:
  friend std::ostream& operator<< (std::ostream& out, const Ext_Configure_Sus&  msg) {
    out 
    << "root_filename ";
    out << std::endl; 
    for (int dim0 = 0; dim0 < sizeof(msg.root_filename)/sizeof(msg.root_filename[0]); dim0++) {
      out << msg.root_filename[dim0] << " ";
    }
    out  << std::endl 
    << "stream " << (int)msg.stream << std::endl 
    << "chan_mask " << msg.chan_mask << std::endl 
    << "realtime_mode " << (int)msg.realtime_mode << std::endl 
    << std::endl;
    return out;
  }
};
struct Ext_Sus_Configured : public Sus_Configured {
  Ext_Sus_Configured(int job_id) {
    bin_head.msg_code = SUS_CONFIGURED;
    bin_head.task_id = job_id;
  }
 public:
  friend std::ostream& operator<< (std::ostream& out, const Ext_Sus_Configured&  msg) {
    out 
    << std::endl;
    return out;
  }
};
struct Ext_Su_Config_Error : public Su_Config_Error {
  Ext_Su_Config_Error(int job_id) {
    bin_head.msg_code = SU_CONFIG_ERROR;
    bin_head.task_id = job_id;
  }
 public:
  friend std::ostream& operator<< (std::ostream& out, const Ext_Su_Config_Error&  msg) {
    out 
    << "return_code " << msg.return_code << std::endl 
    << std::endl;
    return out;
  }
};
struct Ext_Cant_Mount_Tape : public Cant_Mount_Tape {
  Ext_Cant_Mount_Tape(int job_id) {
    bin_head.msg_code = CANT_MOUNT_TAPE;
    bin_head.task_id = job_id;
  }
 public:
  friend std::ostream& operator<< (std::ostream& out, const Ext_Cant_Mount_Tape&  msg) {
    out 
    << "return_code " << msg.return_code << std::endl 
    << "station " << msg.station << std::endl 
    << std::endl;
    return out;
  }
};
struct Ext_All_Mounted : public All_Mounted {
  Ext_All_Mounted(int job_id) {
    bin_head.msg_code = ALL_MOUNTED;
    bin_head.task_id = job_id;
  }
 public:
  friend std::ostream& operator<< (std::ostream& out, const Ext_All_Mounted&  msg) {
    out 
    << std::endl;
    return out;
  }
};
struct Ext_Pos_To_Tot : public Pos_To_Tot {
  Ext_Pos_To_Tot(int job_id) {
    bin_head.msg_code = POS_TO_TOT;
    bin_head.task_id = job_id;
  }
 public:
  friend std::ostream& operator<< (std::ostream& out, const Ext_Pos_To_Tot&  msg) {
    out 
    << std::endl;
    return out;
  }
};
struct Ext_Repos_To_Tot : public Repos_To_Tot {
  Ext_Repos_To_Tot(int job_id) {
    bin_head.msg_code = REPOS_TO_TOT;
    bin_head.task_id = job_id;
  }
 public:
  friend std::ostream& operator<< (std::ostream& out, const Ext_Repos_To_Tot&  msg) {
    out 
    << "su " << (int)msg.su << std::endl 
    << "location " << (int)msg.location << std::endl 
    << std::endl;
    return out;
  }
};
struct Ext_Valid_Time : public Valid_Time {
  Ext_Valid_Time(int job_id) {
    bin_head.msg_code = VALID_TIME;
    bin_head.task_id = job_id;
  }
 public:
  friend std::ostream& operator<< (std::ostream& out, const Ext_Valid_Time&  msg) {
    out 
    << "first_useable_tot " << msg.first_useable_tot << std::endl 
    << "su " << (int)msg.su << std::endl 
    << std::endl;
    return out;
  }
};
struct Ext_Cant_Find_Time : public Cant_Find_Time {
  Ext_Cant_Find_Time(int job_id) {
    bin_head.msg_code = CANT_FIND_TIME;
    bin_head.task_id = job_id;
  }
 public:
  friend std::ostream& operator<< (std::ostream& out, const Ext_Cant_Find_Time&  msg) {
    out 
    << "bad_tot " << msg.bad_tot << std::endl 
    << "failure_code " << msg.failure_code << std::endl 
    << "station " << msg.station << std::endl 
    << "su " << (int)msg.su << std::endl 
    << std::endl;
    return out;
  }
};
struct Ext_Synchronize_Tapes : public Synchronize_Tapes {
  Ext_Synchronize_Tapes(int job_id) {
    bin_head.msg_code = SYNCHRONIZE_TAPES;
    bin_head.task_id = job_id;
  }
 public:
  friend std::ostream& operator<< (std::ostream& out, const Ext_Synchronize_Tapes&  msg) {
    out 
    << "tape_start_rot ";
    out << std::endl; 
    for (int dim0 = 0; dim0 < sizeof(msg.tape_start_rot)/sizeof(msg.tape_start_rot[0]); dim0++) {
      out << msg.tape_start_rot[dim0] << " ";
    }
    out  << std::endl 
    << std::endl;
    return out;
  }
};
struct Ext_Send_Tape_Info : public Send_Tape_Info {
  Ext_Send_Tape_Info(int job_id) {
    bin_head.msg_code = SEND_TAPE_INFO;
    bin_head.task_id = job_id;
  }
 public:
  friend std::ostream& operator<< (std::ostream& out, const Ext_Send_Tape_Info&  msg) {
    out 
    << "interval " << msg.interval << std::endl 
    << std::endl;
    return out;
  }
};
struct Ext_Tape_Info : public Tape_Info {
  Ext_Tape_Info(int job_id) {
    bin_head.msg_code = TAPE_INFO;
    bin_head.task_id = job_id;
  }
 public:
  friend std::ostream& operator<< (std::ostream& out, const Ext_Tape_Info&  msg) {
    out 
    << std::endl;
    return out;
  }
};
struct Ext_End_Task : public End_Task {
  Ext_End_Task(int job_id) {
    bin_head.msg_code = END_TASK;
    bin_head.task_id = job_id;
  }
 public:
  friend std::ostream& operator<< (std::ostream& out, const Ext_End_Task&  msg) {
    out 
    << std::endl;
    return out;
  }
};
struct Ext_Transmit_Ffs : public Transmit_Ffs {
  Ext_Transmit_Ffs(int job_id) {
    bin_head.msg_code = TRANSMIT_FFS;
    bin_head.task_id = job_id;
  }
 public:
  friend std::ostream& operator<< (std::ostream& out, const Ext_Transmit_Ffs&  msg) {
    out 
    << std::endl;
    return out;
  }
};
struct Ext_Initialize_Mk5 : public Initialize_Mk5 {
  Ext_Initialize_Mk5(int job_id) {
    bin_head.msg_code = INITIALIZE_MK5;
    bin_head.task_id = job_id;
  }
 public:
  friend std::ostream& operator<< (std::ostream& out, const Ext_Initialize_Mk5&  msg) {
    out 
    << "cf_length " << msg.cf_length << std::endl 
    << "bocf_stretch " << (int)msg.bocf_stretch << std::endl 
    << "su_id " << (int)msg.su_id << std::endl 
    << "send_mounts " << (int)msg.send_mounts << std::endl 
    << "realtime " << (int)msg.realtime << std::endl 
    << "packet_size " << msg.packet_size << std::endl 
    << std::endl;
    return out;
  }
};
struct Ext_Mount_Change : public Mount_Change {
  Ext_Mount_Change(int job_id) {
    bin_head.msg_code = MOUNT_CHANGE;
    bin_head.task_id = job_id;
  }
 public:
  friend std::ostream& operator<< (std::ostream& out, const Ext_Mount_Change&  msg) {
    out 
    << "vsn ";
    out << std::endl; 
    for (int dim0 = 0; dim0 < sizeof(msg.vsn)/sizeof(msg.vsn[0]); dim0++) {
      out << std::endl; 
      for (int dim1 = 0; dim1 < sizeof(msg.vsn[0])/sizeof(msg.vsn[0][0]); dim1++) {
        out << msg.vsn[dim0][dim1] << " ";
      }
    }
    out  << std::endl 
    << "serno ";
    out << std::endl; 
    for (int dim0 = 0; dim0 < sizeof(msg.serno)/sizeof(msg.serno[0]); dim0++) {
      out << std::endl; 
      for (int dim1 = 0; dim1 < sizeof(msg.serno[0])/sizeof(msg.serno[0][0]); dim1++) {
        out << std::endl; 
        for (int dim2 = 0; dim2 < sizeof(msg.serno[0][0])/sizeof(msg.serno[0][0][0]); dim2++) {
          out << msg.serno[dim0][dim1][dim2] << " ";
        }
      }
    }
    out  << std::endl 
    << "su_id " << (int)msg.su_id << std::endl 
    << std::endl;
    return out;
  }
};
struct Ext_Send_M5_Status : public Send_M5_Status {
  Ext_Send_M5_Status(int job_id) {
    bin_head.msg_code = SEND_M5_STATUS;
    bin_head.task_id = job_id;
  }
 public:
  friend std::ostream& operator<< (std::ostream& out, const Ext_Send_M5_Status&  msg) {
    out 
    << "interval " << msg.interval << std::endl 
    << std::endl;
    return out;
  }
};
struct Ext_M5_Status : public M5_Status {
  Ext_M5_Status(int job_id) {
    bin_head.msg_code = M5_STATUS;
    bin_head.task_id = job_id;
  }
 public:
  friend std::ostream& operator<< (std::ostream& out, const Ext_M5_Status&  msg) {
    out 
    << "status " << msg.status << std::endl 
    << "tot " << msg.tot << std::endl 
    << "su_id " << (int)msg.su_id << std::endl 
    << std::endl;
    return out;
  }
};
struct Ext_Lookup_Scan : public Lookup_Scan {
  Ext_Lookup_Scan(int job_id) {
    bin_head.msg_code = LOOKUP_SCAN;
    bin_head.task_id = job_id;
  }
 public:
  friend std::ostream& operator<< (std::ostream& out, const Ext_Lookup_Scan&  msg) {
    out 
    << "scan_label ";
    out << std::endl; 
    for (int dim0 = 0; dim0 < sizeof(msg.scan_label)/sizeof(msg.scan_label[0]); dim0++) {
      out << msg.scan_label[dim0] << " ";
    }
    out  << std::endl 
    << "bank_select " << (int)msg.bank_select << std::endl 
    << std::endl;
    return out;
  }
};
struct Ext_Scan_Bounds : public Scan_Bounds {
  Ext_Scan_Bounds(int job_id) {
    bin_head.msg_code = SCAN_BOUNDS;
    bin_head.task_id = job_id;
  }
 public:
  friend std::ostream& operator<< (std::ostream& out, const Ext_Scan_Bounds&  msg) {
    out 
    << "start_byte " << msg.start_byte << std::endl 
    << "end_byte " << msg.end_byte << std::endl 
    << "su_id " << (int)msg.su_id << std::endl 
    << std::endl;
    return out;
  }
};
struct Ext_Find_Next_Header : public Find_Next_Header {
  Ext_Find_Next_Header(int job_id) {
    bin_head.msg_code = FIND_NEXT_HEADER;
    bin_head.task_id = job_id;
  }
 public:
  friend std::ostream& operator<< (std::ostream& out, const Ext_Find_Next_Header&  msg) {
    out 
    << "byte_num " << msg.byte_num << std::endl 
    << std::endl;
    return out;
  }
};
struct Ext_Header_Contents : public Header_Contents {
  Ext_Header_Contents(int job_id) {
    bin_head.msg_code = HEADER_CONTENTS;
    bin_head.task_id = job_id;
  }
 public:
  friend std::ostream& operator<< (std::ostream& out, const Ext_Header_Contents&  msg) {
    out 
    << "byte_num " << msg.byte_num << std::endl 
    << "df_header ";
    out << std::endl; 
    for (int dim0 = 0; dim0 < sizeof(msg.df_header)/sizeof(msg.df_header[0]); dim0++) {
      out << msg.df_header[dim0] << " ";
    }
    out  << std::endl 
    << "su_id " << (int)msg.su_id << std::endl 
    << std::endl;
    return out;
  }
};
struct Ext_Configure_Scan : public Configure_Scan {
  Ext_Configure_Scan(int job_id) {
    bin_head.msg_code = CONFIGURE_SCAN;
    bin_head.task_id = job_id;
  }
 public:
  friend std::ostream& operator<< (std::ostream& out, const Ext_Configure_Scan&  msg) {
    out 
    << "byte_num " << msg.byte_num << std::endl 
    << "start_rot " << msg.start_rot << std::endl 
    << "end_rot " << msg.end_rot << std::endl 
    << "ss_invalid_code " << msg.ss_invalid_code << std::endl 
    << "dim_invalid_code " << msg.dim_invalid_code << std::endl 
    << "crossbar_map ";
    out << std::endl; 
    for (int dim0 = 0; dim0 < sizeof(msg.crossbar_map)/sizeof(msg.crossbar_map[0]); dim0++) {
      out << (int)msg.crossbar_map[dim0] << " ";
    }
    out  << std::endl 
    << "sample_rate " << (int)msg.sample_rate << std::endl 
    << "output_rate " << (int)msg.output_rate << std::endl 
    << "num_bitstreams " << (int)msg.num_bitstreams << std::endl 
    << "bits_sample " << (int)msg.bits_sample << std::endl 
    << "scan_label ";
    out << std::endl; 
    for (int dim0 = 0; dim0 < sizeof(msg.scan_label)/sizeof(msg.scan_label[0]); dim0++) {
      out << msg.scan_label[dim0] << " ";
    }
    out  << std::endl 
    << std::endl;
    return out;
  }
};
struct Ext_Model_Data : public Model_Data {
  Ext_Model_Data(int job_id) {
    bin_head.msg_code = MODEL_DATA;
    bin_head.task_id = job_id;
  }
 public:
  friend std::ostream& operator<< (std::ostream& out, const Ext_Model_Data&  msg) {
    out 
    << "rot_interval ";
    out << std::endl; 
    for (int dim0 = 0; dim0 < sizeof(msg.rot_interval)/sizeof(msg.rot_interval[0]); dim0++) {
      out << msg.rot_interval[dim0] << " ";
    }
    out  << std::endl 
    << "delay ";
    out << std::endl; 
    for (int dim0 = 0; dim0 < sizeof(msg.delay)/sizeof(msg.delay[0]); dim0++) {
      out << msg.delay[dim0] << " ";
    }
    out  << std::endl 
    << "phase ";
    out << std::endl; 
    for (int dim0 = 0; dim0 < sizeof(msg.phase)/sizeof(msg.phase[0]); dim0++) {
      out << std::endl; 
      for (int dim1 = 0; dim1 < sizeof(msg.phase[0])/sizeof(msg.phase[0][0]); dim1++) {
        out << msg.phase[dim0][dim1] << " ";
      }
    }
    out  << std::endl 
    << "sidebands " << msg.sidebands << std::endl 
    << "nchan " << (int)msg.nchan << std::endl 
    << "oversampling " << (int)msg.oversampling << std::endl 
    << "k_div " << (int)msg.k_div << std::endl 
    << std::endl;
    return out;
  }
};
struct Ext_Pcal_Request : public Pcal_Request {
  Ext_Pcal_Request(int job_id) {
    bin_head.msg_code = PCAL_REQUEST;
    bin_head.task_id = job_id;
  }
 public:
  friend std::ostream& operator<< (std::ostream& out, const Ext_Pcal_Request&  msg) {
    out 
    << "tones ";
    out << std::endl; 
    for (int dim0 = 0; dim0 < sizeof(msg.tones)/sizeof(msg.tones[0]); dim0++) {
      out << msg.tones[dim0] << " ";
    }
    out  << std::endl 
    << "ntones " << (int)msg.ntones << std::endl 
    << "ap " << (int)msg.ap << std::endl 
    << std::endl;
    return out;
  }
};
struct Ext_Pcal_Data : public Pcal_Data {
  Ext_Pcal_Data(int job_id) {
    bin_head.msg_code = PCAL_DATA;
    bin_head.task_id = job_id;
  }
 public:
  friend std::ostream& operator<< (std::ostream& out, const Ext_Pcal_Data&  msg) {
    out 
    << "timestamp " << msg.timestamp << std::endl 
    << "accums ";
    out << std::endl; 
    for (int dim0 = 0; dim0 < sizeof(msg.accums)/sizeof(msg.accums[0]); dim0++) {
      out << std::endl; 
      for (int dim1 = 0; dim1 < sizeof(msg.accums[0])/sizeof(msg.accums[0][0]); dim1++) {
        out << std::endl; 
        for (int dim2 = 0; dim2 < sizeof(msg.accums[0][0])/sizeof(msg.accums[0][0][0]); dim2++) {
          out << msg.accums[dim0][dim1][dim2] << " ";
        }
      }
    }
    out  << std::endl 
    << "su_id " << (int)msg.su_id << std::endl 
    << std::endl;
    return out;
  }
};
struct Ext_Scount_Request : public Scount_Request {
  Ext_Scount_Request(int job_id) {
    bin_head.msg_code = SCOUNT_REQUEST;
    bin_head.task_id = job_id;
  }
 public:
  friend std::ostream& operator<< (std::ostream& out, const Ext_Scount_Request&  msg) {
    out 
    << "ap " << (int)msg.ap << std::endl 
    << std::endl;
    return out;
  }
};
struct Ext_Scount_Data : public Scount_Data {
  Ext_Scount_Data(int job_id) {
    bin_head.msg_code = SCOUNT_DATA;
    bin_head.task_id = job_id;
  }
 public:
  friend std::ostream& operator<< (std::ostream& out, const Ext_Scount_Data&  msg) {
    out 
    << "timestamp " << msg.timestamp << std::endl 
    << "accums ";
    out << std::endl; 
    for (int dim0 = 0; dim0 < sizeof(msg.accums)/sizeof(msg.accums[0]); dim0++) {
      out << std::endl; 
      for (int dim1 = 0; dim1 < sizeof(msg.accums[0])/sizeof(msg.accums[0][0]); dim1++) {
        out << msg.accums[dim0][dim1] << " ";
      }
    }
    out  << std::endl 
    << "su_id " << (int)msg.su_id << std::endl 
    << std::endl;
    return out;
  }
};
struct Ext_Abort_Scan : public Abort_Scan {
  Ext_Abort_Scan(int job_id) {
    bin_head.msg_code = ABORT_SCAN;
    bin_head.task_id = job_id;
  }
 public:
  friend std::ostream& operator<< (std::ostream& out, const Ext_Abort_Scan&  msg) {
    out 
    << std::endl;
    return out;
  }
};
struct Ext_Send_Directory : public Send_Directory {
  Ext_Send_Directory(int job_id) {
    bin_head.msg_code = SEND_DIRECTORY;
    bin_head.task_id = job_id;
  }
 public:
  friend std::ostream& operator<< (std::ostream& out, const Ext_Send_Directory&  msg) {
    out 
    << "bank " << msg.bank << std::endl 
    << "nscan " << msg.nscan << std::endl 
    << std::endl;
    return out;
  }
};
struct Ext_Directory_Chunk : public Directory_Chunk {
  Ext_Directory_Chunk(int job_id) {
    bin_head.msg_code = DIRECTORY_CHUNK;
    bin_head.task_id = job_id;
  }
 public:
  friend std::ostream& operator<< (std::ostream& out, const Ext_Directory_Chunk&  msg) {
    out 
    << "bank " << msg.bank << std::endl 
    << "nscan " << msg.nscan << std::endl 
    << "nreturned " << msg.nreturned << std::endl 
    << "ntotal " << msg.ntotal << std::endl 
    << std::endl;
    return out;
  }
};
struct Ext_Playback_Control : public Playback_Control {
  Ext_Playback_Control(int job_id) {
    bin_head.msg_code = PLAYBACK_CONTROL;
    bin_head.task_id = job_id;
  }
 public:
  friend std::ostream& operator<< (std::ostream& out, const Ext_Playback_Control&  msg) {
    out 
    << "play " << msg.play << std::endl 
    << "start " << msg.start << std::endl 
    << "sample_rate " << (int)msg.sample_rate << std::endl 
    << "output_rate " << (int)msg.output_rate << std::endl 
    << "num_bitstreams " << (int)msg.num_bitstreams << std::endl 
    << std::endl;
    return out;
  }
};
struct Ext_Set_Cot_Clock : public Set_Cot_Clock {
  Ext_Set_Cot_Clock(int job_id) {
    bin_head.msg_code = SET_COT_CLOCK;
    bin_head.task_id = job_id;
  }
 public:
  friend std::ostream& operator<< (std::ostream& out, const Ext_Set_Cot_Clock&  msg) {
    out 
    << "initial_cot " << msg.initial_cot << std::endl 
    << "set " << msg.set << std::endl 
    << "broadcast " << msg.broadcast << std::endl 
    << std::endl;
    return out;
  }
};
struct Ext_Start_Rot_Clock : public Start_Rot_Clock {
  Ext_Start_Rot_Clock(int job_id) {
    bin_head.msg_code = START_ROT_CLOCK;
    bin_head.task_id = job_id;
  }
 public:
  friend std::ostream& operator<< (std::ostream& out, const Ext_Start_Rot_Clock&  msg) {
    out 
    << "starting_cot " << msg.starting_cot << std::endl 
    << "initial_rot " << msg.initial_rot << std::endl 
    << "ending_rot " << msg.ending_rot << std::endl 
    << "initial_rot_year " << msg.initial_rot_year << std::endl 
    << "rot_rate " << (int)msg.rot_rate << std::endl 
    << "stream " << (int)msg.stream << std::endl 
    << std::endl;
    return out;
  }
};
struct Ext_Send_Times : public Send_Times {
  Ext_Send_Times(int job_id) {
    bin_head.msg_code = SEND_TIMES;
    bin_head.task_id = job_id;
  }
 public:
  friend std::ostream& operator<< (std::ostream& out, const Ext_Send_Times&  msg) {
    out 
    << "interval " << msg.interval << std::endl 
    << std::endl;
    return out;
  }
};
struct Ext_Current_Times : public Current_Times {
  Ext_Current_Times(int job_id) {
    bin_head.msg_code = CURRENT_TIMES;
    bin_head.task_id = job_id;
  }
 public:
  friend std::ostream& operator<< (std::ostream& out, const Ext_Current_Times&  msg) {
    out 
    << "cot " << msg.cot << std::endl 
    << "rot ";
    out << std::endl; 
    for (int dim0 = 0; dim0 < sizeof(msg.rot)/sizeof(msg.rot[0]); dim0++) {
      out << msg.rot[dim0] << " ";
    }
    out  << std::endl 
    << std::endl;
    return out;
  }
};
struct Ext_Initialize_Hardware : public Initialize_Hardware {
  Ext_Initialize_Hardware(int job_id) {
    bin_head.msg_code = INITIALIZE_HARDWARE;
    bin_head.task_id = job_id;
  }
 public:
  friend std::ostream& operator<< (std::ostream& out, const Ext_Initialize_Hardware&  msg) {
    out 
    << "ivex_key ";
    out << std::endl; 
    for (int dim0 = 0; dim0 < sizeof(msg.ivex_key)/sizeof(msg.ivex_key[0]); dim0++) {
      out << msg.ivex_key[dim0] << " ";
    }
    out  << std::endl 
    << "correlator " << (int)msg.correlator << std::endl 
    << "su_list ";
    out << std::endl; 
    for (int dim0 = 0; dim0 < sizeof(msg.su_list)/sizeof(msg.su_list[0]); dim0++) {
      out << (int)msg.su_list[dim0] << " ";
    }
    out  << std::endl 
    << std::endl;
    return out;
  }
};
struct Ext_Remove_Station : public Remove_Station {
  Ext_Remove_Station(int job_id) {
    bin_head.msg_code = REMOVE_STATION;
    bin_head.task_id = job_id;
  }
 public:
  friend std::ostream& operator<< (std::ostream& out, const Ext_Remove_Station&  msg) {
    out 
    << "station " << msg.station << std::endl 
    << std::endl;
    return out;
  }
};
struct Ext_Send_Cond_Status : public Send_Cond_Status {
  Ext_Send_Cond_Status(int job_id) {
    bin_head.msg_code = SEND_COND_STATUS;
    bin_head.task_id = job_id;
  }
 public:
  friend std::ostream& operator<< (std::ostream& out, const Ext_Send_Cond_Status&  msg) {
    out 
    << "interval " << msg.interval << std::endl 
    << std::endl;
    return out;
  }
};
struct Ext_Cond_Status : public Cond_Status {
  Ext_Cond_Status(int job_id) {
    bin_head.msg_code = COND_STATUS;
    bin_head.task_id = job_id;
  }
 public:
  friend std::ostream& operator<< (std::ostream& out, const Ext_Cond_Status&  msg) {
    out 
    << std::endl;
    return out;
  }
};
struct Ext_Mount_Request : public Mount_Request {
  Ext_Mount_Request(int job_id) {
    bin_head.msg_code = MOUNT_REQUEST;
    bin_head.task_id = job_id;
  }
 public:
  friend std::ostream& operator<< (std::ostream& out, const Ext_Mount_Request&  msg) {
    out 
    << "ntapes " << (int)msg.ntapes << std::endl 
    << std::endl;
    return out;
  }
};
struct Ext_Mount_Status : public Mount_Status {
  Ext_Mount_Status(int job_id) {
    bin_head.msg_code = MOUNT_STATUS;
    bin_head.task_id = job_id;
  }
 public:
  friend std::ostream& operator<< (std::ostream& out, const Ext_Mount_Status&  msg) {
    out 
    << std::endl;
    return out;
  }
};
struct Ext_Dismount_Tape : public Dismount_Tape {
  Ext_Dismount_Tape(int job_id) {
    bin_head.msg_code = DISMOUNT_TAPE;
    bin_head.task_id = job_id;
  }
 public:
  friend std::ostream& operator<< (std::ostream& out, const Ext_Dismount_Tape&  msg) {
    out 
    << "su " << (int)msg.su << std::endl 
    << std::endl;
    return out;
  }
};
struct Ext_Stream_Control : public Stream_Control {
  Ext_Stream_Control(int job_id) {
    bin_head.msg_code = STREAM_CONTROL;
    bin_head.task_id = job_id;
  }
 public:
  friend std::ostream& operator<< (std::ostream& out, const Ext_Stream_Control&  msg) {
    out 
    << "stream_num " << (int)msg.stream_num << std::endl 
    << "request " << (int)msg.request << std::endl 
    << "tsf_lineno " << msg.tsf_lineno << std::endl 
    << "stream_filename ";
    out << std::endl; 
    for (int dim0 = 0; dim0 < sizeof(msg.stream_filename)/sizeof(msg.stream_filename[0]); dim0++) {
      out << msg.stream_filename[dim0] << " ";
    }
    out  << std::endl 
    << std::endl;
    return out;
  }
};
struct Ext_Reorder_Streams : public Reorder_Streams {
  Ext_Reorder_Streams(int job_id) {
    bin_head.msg_code = REORDER_STREAMS;
    bin_head.task_id = job_id;
  }
 public:
  friend std::ostream& operator<< (std::ostream& out, const Ext_Reorder_Streams&  msg) {
    out 
    << "stream_order ";
    out << std::endl; 
    for (int dim0 = 0; dim0 < sizeof(msg.stream_order)/sizeof(msg.stream_order[0]); dim0++) {
      out << (int)msg.stream_order[dim0] << " ";
    }
    out  << std::endl 
    << std::endl;
    return out;
  }
};
struct Ext_Send_Tape_Status : public Send_Tape_Status {
  Ext_Send_Tape_Status(int job_id) {
    bin_head.msg_code = SEND_TAPE_STATUS;
    bin_head.task_id = job_id;
  }
 public:
  friend std::ostream& operator<< (std::ostream& out, const Ext_Send_Tape_Status&  msg) {
    out 
    << "interval " << msg.interval << std::endl 
    << "watch_su ";
    out << std::endl; 
    for (int dim0 = 0; dim0 < sizeof(msg.watch_su)/sizeof(msg.watch_su[0]); dim0++) {
      out << (int)msg.watch_su[dim0] << " ";
    }
    out  << std::endl 
    << "num_addr " << (int)msg.num_addr << std::endl 
    << "watch_list ";
    out << std::endl; 
    for (int dim0 = 0; dim0 < sizeof(msg.watch_list)/sizeof(msg.watch_list[0]); dim0++) {
      out << (int)msg.watch_list[dim0] << " ";
    }
    out  << std::endl 
    << std::endl;
    return out;
  }
};
struct Ext_Tape_Status : public Tape_Status {
  Ext_Tape_Status(int job_id) {
    bin_head.msg_code = TAPE_STATUS;
    bin_head.task_id = job_id;
  }
 public:
  friend std::ostream& operator<< (std::ostream& out, const Ext_Tape_Status&  msg) {
    out 
    << "watch_su ";
    out << std::endl; 
    for (int dim0 = 0; dim0 < sizeof(msg.watch_su)/sizeof(msg.watch_su[0]); dim0++) {
      out << (int)msg.watch_su[dim0] << " ";
    }
    out  << std::endl 
    << "num_addr " << (int)msg.num_addr << std::endl 
    << "watch_list ";
    out << std::endl; 
    for (int dim0 = 0; dim0 < sizeof(msg.watch_list)/sizeof(msg.watch_list[0]); dim0++) {
      out << (int)msg.watch_list[dim0] << " ";
    }
    out  << std::endl 
    << "state ";
    out << std::endl; 
    for (int dim0 = 0; dim0 < sizeof(msg.state)/sizeof(msg.state[0]); dim0++) {
      out << std::endl; 
      for (int dim1 = 0; dim1 < sizeof(msg.state[0])/sizeof(msg.state[0][0]); dim1++) {
        out << msg.state[dim0][dim1] << " ";
      }
    }
    out  << std::endl 
    << std::endl;
    return out;
  }
};
struct Ext_Dpu_Command : public Dpu_Command {
  Ext_Dpu_Command(int job_id) {
    bin_head.msg_code = DPU_COMMAND;
    bin_head.task_id = job_id;
  }
 public:
  friend std::ostream& operator<< (std::ostream& out, const Ext_Dpu_Command&  msg) {
    out 
    << "rw " << msg.rw << std::endl 
    << "su " << (int)msg.su << std::endl 
    << "address " << (int)msg.address << std::endl 
    << "value " << msg.value << std::endl 
    << std::endl;
    return out;
  }
};
struct Ext_Ascii_Message : public Ascii_Message {
  Ext_Ascii_Message(int job_id) {
    bin_head.msg_code = ASCII_MESSAGE;
    bin_head.task_id = job_id;
  }
 public:
  friend std::ostream& operator<< (std::ostream& out, const Ext_Ascii_Message&  msg) {
    out 
    << "text ";
    out << std::endl; 
    for (int dim0 = 0; dim0 < sizeof(msg.text)/sizeof(msg.text[0]); dim0++) {
      out << msg.text[dim0] << " ";
    }
    out  << std::endl 
    << std::endl;
    return out;
  }
};
struct Ext_Terminate_Self : public Terminate_Self {
  Ext_Terminate_Self(int job_id) {
    bin_head.msg_code = TERMINATE_SELF;
    bin_head.task_id = job_id;
  }
 public:
  friend std::ostream& operator<< (std::ostream& out, const Ext_Terminate_Self&  msg) {
    out 
    << "flags " << msg.flags << std::endl 
    << std::endl;
    return out;
  }
};
struct Ext_Program_Control : public Program_Control {
  Ext_Program_Control(int job_id) {
    bin_head.msg_code = PROGRAM_CONTROL;
    bin_head.task_id = job_id;
  }
 public:
  friend std::ostream& operator<< (std::ostream& out, const Ext_Program_Control&  msg) {
    out 
    << "msg_level " << msg.msg_level << std::endl 
    << "prog_flags " << msg.prog_flags << std::endl 
    << std::endl;
    return out;
  }
};
struct Ext_Error_Message : public Error_Message {
  Ext_Error_Message(int job_id) {
    bin_head.msg_code = ERROR_MESSAGE;
    bin_head.task_id = job_id;
  }
 public:
  friend std::ostream& operator<< (std::ostream& out, const Ext_Error_Message&  msg) {
    out 
    << "errnum " << msg.errnum << std::endl 
    << "text ";
    out << std::endl; 
    for (int dim0 = 0; dim0 < sizeof(msg.text)/sizeof(msg.text[0]); dim0++) {
      out << msg.text[dim0] << " ";
    }
    out  << std::endl 
    << std::endl;
    return out;
  }
};
#endif
