#ifndef SCAN_ITERATOR_H
#define SCAN_ITERATOR_H

#include <job_descr/corr_job_descr.h>

class Scan_Iterator {
  // class primarly used to abstract merging of scans
 public:
  Scan_Iterator();
  
  bool set_cjd(Corr_Job_Descr* cjd, const std::string& mounted_vsn); // set the scan to the first in the sub job, also sets the containing medium and logical station
  Scan* get_current_scan(); // returns the first of the current MERGED scan
  Scan* get_end_scan(); // returns the last of the current MERGED scan
  Scan* peak_next_scan(); // returns the scan after end_scan()
  void goto_next_scan(); // sets the current scan to the next MERGED scan

  Logical_Station* get_containing_station();
  Medium* get_containing_medium();

 protected:
  Scan* _current_scan;
  Scan* _next_scan;
  Scan* _end_scan;
  Ordered_List* _scans;
  Logical_Station* _current_station;
  Medium* _current_medium;

  void set_end_and_next_scan(); // updates _end_scan and _next_scan according to set _current_scan

};

#endif
