//su_conn.h

//SU_CONTROL application - SU connection

//JIVE, May 1996

//_________________________________________________________________________

//for RCS

//$Header: /export/home/jive_cvs/JCCS/CVS_Repository/su_control/include/su_conn.h,v 3.2 2008/04/09 11:44:27 jive_cc Exp $

//$Locker:  $

//$Log: su_conn.h,v $
//Revision 3.2  2008/04/09 11:44:27  jive_cc
//BE: first version of mark5b control, also added the possibility to use the spare mk5b for production
//
//Revision 3.1  2005/12/23 13:16:30  verkout
//HV: Phew. This is the big thing. Merged all developments with both the port to Linux and the mods needed for a byte-order safe COF
//
//Revision 3.0.8.1  2005/10/18 09:29:45  jive_cc
//HV: * JCCS port to Linux/i386 * COF is now endian safe * libraryname clash on Linux - libutil is a systemlib on Linux, so renamed util -> jccs_util * put CountedPointer in JCCS namespace
//
//Revision 3.0  2002/04/17 14:42:50  jive_cc
//Included gnu branch
//
//Revision 1.7  1999/01/29 16:08:10  pwm
//Integrated peaking branch into root
//
//Revision 1.6  1998/12/15 20:11:18  ps
//Message library reorganisation, part three
//
//Revision 1.5.2.1  1999/01/19 15:44:35  pwm
//added location_broker
//
//Revision 1.5  1998/08/26 20:01:48  jive_cc
//added quit()
//
//Revision 1.4  1998/07/01 11:55:41  pwm
//friends, interface
//
//Revision 1.3  1998/01/26 20:28:47  pwm
//added fns to determine tape_id. Cosmetic changes
//
//Revision 1.2  1997/11/07 15:36:12  pwm
//various more or less major changes
//
//Revision 1.1  1997/04/03 15:53:16  pwm
//Initial revision
//

//___________________________________________________________________________

#ifndef SU_CONNECTION_H
#define SU_CONNECTION_H

#include <jccs_util/defs.h>
#include <su_control/su_cmd.h>
#include <su_control/transp.h>
#include <su_control/su_controller.h>
#include <su_control/su_defs.h>
#include <controllers/thread.h>
#include <herbert/service.h>
#include <standard_threads/service_mgr.h>
#include <jive_message_sets/msg_defns.h>
#include <message_base/msg_handler.h>
#include <jive_msgs/ccc_msg_codes.h>
#include <message_base/comm_msg.h>
#include <herbert/t_base.h>
#include <location_client/location_client.h>
#include <jive_locations/service_codes.h>

class SU_Command_Channel;
class Transparent_channel;
class SU_Controller;
class Init_Proc;
class Mark5B_Controller;


// included for acquiring local time
#include <time.h>
#include <stdlib.h>

class SU_Connection : public Thread
{
   friend class Transparent_channel;
   friend class SU_Controller;
   friend class Init_Proc;
   friend class Mark5B_Controller;
   
   public :
      SU_Connection(Thread_ID my_id, Thread_ID parent, Thread_Master *owner, \
		    SU_Command_Channel *comm1, Transparent_channel *comm2, unsigned int suid_code);
      
      ~SU_Connection(); //destructor
      
      int run();
      int shutdown();
      int install() {return 0;}
      
      bool initialise(SU_Controller *suc); //initiate service and connection
      int quit();
      
   private :
      Transparent_channel *transp;
      SU_Command_Channel *su_cmd;
      SU_Controller *su_controller;
      
      Location_Client location_if;
      Service_Thread_Interface su_client_interface;
      Service_Manager *su_client_mgr;
      Service_Client* service; 
      
      Msg_Handler_ID SUID;//of SU
     
      //to determine local time, etc for messages
      struct timeval tod;
      struct timezone tzp;
      Long_Time_Value time_stamp;
      Long_Time_Value local_time;
      void set_local_time(void);
      
      unsigned int su_id;
      bool init; //if service and connection successfully created
      SU_Control_Error error_msg;//persistent error message - configure to requirements
      
      bool handle_su_response(void);
      bool open_SU_Connection(void);
      void transmit_error(unsigned int error_code, unsigned int command_code = 0, unsigned int ref_id = 0); 
      //to PROCESSOR_CONTROL
      bool re_initialise(void);
      Connection* get_connection(int target);//returns connection to given target.
      Msg_Handler_ID &get_SUID(void) { return SUID;}

};

#endif
