// abstract base class, such that both Init_Proc and Mark5B_Control can use su_cmd

#ifndef SU_CONTROLLER_H
#define SU_CONTROLLER_H

#include <jive_message_sets/msg_defns.h>
#include <standard_threads/service_mgr.h>
#include <jccs_util/iter_list.h>

class SU_Controller {
  friend class SU_Connection;
  friend class SU_Command_Channel;
  friend class Transparent_channel; 
 public:
  SU_Controller();
  virtual ~SU_Controller();

 protected:
  bool in_cmd_queue(const unsigned int cmd_code) const;//returns true if message with cmd_code is in ...
  bool action_req_in_cmd_queue(const unsigned int SU_action_value)const;

  Iter_List<Incoming_Message_Info* > cmd_queue;
  Forward_List_Iter<Incoming_Message_Info *> *cmd_iter;

 private:
  virtual bool is_mounted() const = 0;
  virtual const char* get_barcode(int bank) const = 0;
  virtual void get_head_positions(int_32 head_pos[MAX_HEADS_PER_DPU]) const = 0;
  virtual int_32 get_DPU_id() const = 0;
  virtual unsigned int get_suid_code() const = 0;
  virtual unsigned int get_job_id()const = 0;
  virtual Msg_Handler_ID &get_SUC_ID() = 0;
  virtual bool initiated() const = 0;
  virtual int transmit_tape_status(unsigned int status = 0, unsigned int error_code = 0) = 0;
  virtual int transmit_disk_status(unsigned int status = 0, unsigned int error_code = 0) = 0;
  virtual bool get_allocation() const = 0;

  virtual bool queue_response(Incoming_Message_Info* info) = 0;
  virtual bool queue_cmd(Incoming_Message_Info* info);

  bool use_mark5;
  unsigned int num_head_stacks;
};

#endif
