//SU_CONTROL application 

//a definitions file for SU_CONTROL


//JIVE, May 1996

//_________________________________________________________________________

//for RCS


//$Locker:  $

//$Log: su_defs.h,v $
//Revision 3.11  2008/04/09 11:44:27  jive_cc
//BE: first version of mark5b control, also added the possibility to use the spare mk5b for production
//
//Revision 3.10  2007/10/17 07:21:25  jive_cc
//BE: finished spacecraft tracking mode; two minor changes in su_control: (1) parsing the mark5 response is a less white space dependent, (2) after doing a skip, the next servo response will be ignored (since it might be calculated on partly unskipped data)
//
//Revision 3.9  2006/09/29 10:32:37  jive_cc
//kettenis: Update location for log files for juw31/juw32.
//
//Revision 3.8  2005/12/23 13:16:30  verkout
//HV: Phew. This is the big thing. Merged all developments with both the port to Linux and the mods needed for a byte-order safe COF
//
//Revision 3.3.4.2  2005/12/22 09:56:53  verkout
//HV: Dragged in additions that MMK made because of phasecal and modelinfo. At the same time changed those additions to adhere to the endian-safe COF. * Some mods to make JCCS compile under gcc3.4 or something
//
//Revision 3.3.4.1  2005/10/25 15:02:01  verkout
//HV: Merge with main branch. May need fixes in order to compile on jaw0/HP-UX
//
//Revision 3.6  2005/09/30 12:31:47  jive_cc
//Arpad: e-VLBI enabled version
//
//Revision 3.5  2005/06/08 13:47:29  jive_cc
//arpad: shortened SERVO_REQUEST_INTERVAL from 7 to 5 sec
//
//Revision 3.4  2004/12/13 12:55:36  jive_cc
//Arpad + Friso: removed Mark5 as recording mode
//
//Revision 3.3.2.1  2004/11/12 12:30:40  jive_cc
//Arpad + Friso: removed Mark5 as recording mode (it isn't)
//
//Revision 3.3  2004/04/27 07:04:08  jive_cc
//Arpad: Increase MIN_SCAN_GAP from 15 to 90 sec, to give Mk5 time.
//
//Revision 3.2  2003/08/27 12:24:41  jive_cc
//Arpad: added servo error message to system
//
//Revision 3.1  2003/05/15 11:46:27  jive_cc
//Arpad: merged MarkV version into main
//
//Revision 3.0.2.1  2003/01/13 15:09:15  jive_cc
//*** empty log message ***
//
//Revision 3.0  2002/04/17 14:42:51  jive_cc
//Included gnu branch
//
//Revision 1.27  2000/10/12 14:31:58  jive_cc
//(CJP) Support for SU status logging
//
//Revision 1.26  2000/06/20 11:28:05  jive_cc
//(CJP): Tape stop fixes
//
//Revision 1.25  2000/03/07 13:55:46  jive_cc
//FMO changed data root directory
//
//Revision 1.24  2000/02/25 12:53:49  jive_cc
//CJP raised MAX_PEAK_HEAD_ATTEMPTS to 9
//
//Revision 1.23  2000/01/14 15:02:15  jive_cc
//(CJP) Increase peaking search window
//
//Revision 1.22  1999/09/22 10:41:40  jive_cc
//added MIN_SUB_JOB_DUR to 30
//
//Revision 1.21  1999/08/30 09:55:32  jive_cc
//changed  MAX_PEAK_HEAD_ATTEMPTS to 6
//
//Revision 1.20  1999/07/09 15:17:08  jive_cc
//(CJP) Added location of data directory
//
//Revision 1.19  1999/06/29 13:00:01  jive_cc
//(CJP) Changed scan start timing, Added Extra mask for SUIM config
//
//Revision 1.18  1999/06/16 16:02:21  pwm
//added SCAN_INTERVAL 5
//
//Revision 1.17  1999/03/08 17:19:50  pwm
//check SU buffers
//
//Revision 1.16  1999/02/26 12:21:20  jive_cc
//added START_SCAN_DELAY
//
//Revision 1.15  1999/01/29 16:08:10  pwm
//Integrated peaking branch into root
//
//Revision 1.14.2.6  1999/01/19 15:44:36  pwm
//added location_broker
//
//Revision 1.14.2.5  1998/11/19 15:36:13  pwm
//minor change
//
//Revision 1.14.2.4  1998/10/20 07:33:37  jive_cc
//changed rot clock service
//
//Revision 1.14.2.3  1998/10/19 18:50:48  jive_cc
// more improvements
//
//Revision 1.14.2.2  1998/10/16 18:00:50  jive_cc
//improved peaking, etc
//
//Revision 1.14.2.1  1998/10/09 16:48:06  pwm
//tidy up
//
//Revision 1.14  1998/09/09 17:04:02  pwm
//implemented servo error handling for opening
//
//Revision 1.13  1998/08/28 17:38:26  jive_cc
//changed SERVO_ERROR_THRESHOLD
//
//Revision 1.12  1998/08/26 16:57:03  jive_cc
//added thresholds
//
//Revision 1.11  1998/07/02 15:36:43  pwm
//added #define PARITY_ERROR_THRESHOLD 10000//rate of 1e-4
//
//Revision 1.10  1998/06/19 09:28:59  jive_cc
//changed TAPE_SERVO_MAX_SLEW_TIME
//
//Revision 1.9  1998/05/22 13:35:53  jive_cc
//Changed ROT_HOST #define to ROTHOST
//
//Revision 1.8  1998/04/06 07:46:13  jive_cc
//Changed RT_HOST to localhost
//
//Revision 1.7  1998/02/23 11:51:15  klijn
//Added #defines for ROT clock broadcasts
//
//Revision 1.6  1998/01/26 20:28:48  pwm
//added fns to determine tape_id. Cosmetic changes
//
//Revision 1.5  1997/12/16 17:16:11  pwm
//minor update
//
//Revision 1.4  1997/12/09 11:20:38  klijn
//set TTT_OFFSET = 50
//
//Revision 1.3  1997/11/07 15:36:12  pwm
//various more or less major changes
//
//Revision 1.2  97/06/09  18:39:37  18:39:37  pwm (Paul William Maguire)
//addition of services, etc
//
//Revision 1.1  97/04/03  15:54:03  15:54:03  pwm (Paul William Maguire)
//Initial revision
//

//___________________________________________________________________________
#ifndef SU_CONTROL_DEFINITIONS
#define SU_CONTROL_DEFINITIONS

#define CHANNEL_REF_SIZE 10

#define THE_CROSS_TRACK_PARITY 0x0000//ie disabled

//#define RX_PARITY_THR 0x0FFF
#define RX_PARITY_THR 0x00FF

#define CLK_SELECT__TRACK_FRAME_SELECT 0x0006//ie 18MHz TC, 36MHz CC, 1 track frame 2b xmited

#define DPUType 0// P&G pbu

#define DPU_ACCELLERATION 20 //20i/s/s

#define TAPE_SERVO_INTERVAL 1.6e+8

#define TAPE_SERVO_MAX_SLEW_TIME 2000.0//now apparently in 1/100 secs ???

#define SCAN_DATA_INTERVAL 9.6e+7//3 seconds

#define SYSTEM_RATE  32.0e+6//clock rate

#define CLOCK_RATE 1.0

#define ALLOWED_LOCK_RESYNCS 10

#define TTT_OFFSET 50//Tape_To_TOT OFFSET - a footage before nominal footage

#define START_OFFSET 32.0e+7//10 seconds (depending on rate)

#define THE_CLOCKS_BETWEEN_TRACK_FRAMES 0x03A7 //parameter in table III.10d

#define PARITY_ERROR_THRESHOLD 10000//rate of 1e-4

#define SERVO_ERROR_THRESHOLD 32.0e+6//?

#define DATA_REQ_INTERVAL 30//seconds repeat interval for dta rqs when running

#define SERVO_REQ_INTERVAL 5//seconds repeat interval for servo req when running, > 5 seconds
                            //interval between calculations of servo error in SU to make sure
                            //a fresh value is reported 

#define PCAL_ACC_PERIOD 10	// Phase Calibration accumulation period

#define MAX_PEAK_HEAD_ATTEMPTS 9

#define MAX_HEAD_POSITION 8000 //ie +/- 800 micron

#define START_SCAN_DELAY 5 //ie start scan 10 after nominal start

#define MIN_BUFFERS 5 //test for # of large and small buffers

#define SCAN_INTERVAL 5 //ie period between subsequent scans

#define VALMAG 0x1000 // Force magnitude to 1 when validity is zero (in SUIM)

#define DATADIR "/jccs/data" // Relative location for Tape Stats

#define LOGDIR "/ccs/var/log" // Relative location for Log files

#define MIN_SUB_JOB_DUR 30 //seconds NB also in proc_job/defs.h !!!

#define MIN_SCAN_GAP 15 // Second between consequtive scans to treat as single
//#define MIN_SCAN_GAP 90 //  At least 1.5 minute needed to give Mk5 change to catch up with rotclock

#define HEAD1_IDEAL_TRACK 18 // Best track to head peak/auto track for head 1
#define HEAD2_IDEAL_TRACK 35 // Best track to head peak/auto track for head 2


#define MARK5B_SCAN_CONFIG_TIME 20 // seconds required to safely configure a scan
#define SERVO_DELAY 2 // the delay to start servoing after switching to play from recording in seconds

//following to enable querying for connection to 
enum {PROCESSOR_CONTROL = 1, SU_MONITOR = 2, S_U = 3, DATA_HANDLER = 4, ROT_CLOCK = 5,
      TAPE_HANDLER = 6, REPLAYED_TELESCOPE = 7, SU_CONTROL = 8, PROCESSING_JOB = 9, 
      LOGICAL_ARRAY = 10, CORRELATOR_CONTROL = 12, TSPU_CONTROL = 13, CORRELATOR = 14};

//tape mounted status
enum {DISMOUNTED = 0, MOUNTED = 1};

//tape formats
enum Tape_Format {MkIIIA = 1, MkIIIAx, MkIV, MkIVA, VLB};

#endif
