#include <su_control/mark5b_connection.h>

bool Mark5B_Connection::receive_msg(int* client_socket, struct header* msg) {
const int message_size = sizeof(msg->msg_code) + sizeof(msg->task_id);
if (!(read_chunk(client_socket,message_size) == message_size)) return false;
read_value((char*)&msg->msg_code, sizeof(msg->msg_code));
read_value((char*)&msg->task_id, sizeof(msg->task_id));
return true;
}

int Mark5B_Connection::write_msg(const struct header& msg) {
write_value((char*)&msg.msg_code, sizeof(msg.msg_code));
write_value((char*)&msg.task_id, sizeof(msg.task_id));
return sizeof(msg.msg_code) + sizeof(msg.task_id);
}

bool Mark5B_Connection::receive_msg(int* client_socket, struct Generate_Root* msg) {
const int message_size = sizeof(msg->ekey) + sizeof(msg->scan_id) + sizeof(msg->init_key) + sizeof(msg->corr_mode) + sizeof(msg->stations) + sizeof(msg->ap_length) + sizeof(msg->mirror_flags);
if (!(read_chunk(client_socket,message_size) == message_size)) return false;
for (int dim0 = 0; dim0 < sizeof(msg->ekey)/sizeof(msg->ekey[0]); dim0++) {
read_value((char*)&msg->ekey[dim0], sizeof(msg->ekey[0]));
}
for (int dim0 = 0; dim0 < sizeof(msg->scan_id)/sizeof(msg->scan_id[0]); dim0++) {
read_value((char*)&msg->scan_id[dim0], sizeof(msg->scan_id[0]));
}
for (int dim0 = 0; dim0 < sizeof(msg->init_key)/sizeof(msg->init_key[0]); dim0++) {
read_value((char*)&msg->init_key[dim0], sizeof(msg->init_key[0]));
}
for (int dim0 = 0; dim0 < sizeof(msg->corr_mode)/sizeof(msg->corr_mode[0]); dim0++) {
read_value((char*)&msg->corr_mode[dim0], sizeof(msg->corr_mode[0]));
}
for (int dim0 = 0; dim0 < sizeof(msg->stations)/sizeof(msg->stations[0]); dim0++) {
read_value((char*)&msg->stations[dim0], sizeof(msg->stations[0]));
}
read_value((char*)&msg->ap_length, sizeof(msg->ap_length));
read_value((char*)&msg->mirror_flags, sizeof(msg->mirror_flags));
return true;
}

int Mark5B_Connection::write_msg(const struct Generate_Root& msg) {
for (int dim0 = 0; dim0 < sizeof(msg.ekey)/sizeof(msg.ekey[0]); dim0++) {
write_value((char*)&msg.ekey[dim0], sizeof(msg.ekey[0]));
}
for (int dim0 = 0; dim0 < sizeof(msg.scan_id)/sizeof(msg.scan_id[0]); dim0++) {
write_value((char*)&msg.scan_id[dim0], sizeof(msg.scan_id[0]));
}
for (int dim0 = 0; dim0 < sizeof(msg.init_key)/sizeof(msg.init_key[0]); dim0++) {
write_value((char*)&msg.init_key[dim0], sizeof(msg.init_key[0]));
}
for (int dim0 = 0; dim0 < sizeof(msg.corr_mode)/sizeof(msg.corr_mode[0]); dim0++) {
write_value((char*)&msg.corr_mode[dim0], sizeof(msg.corr_mode[0]));
}
for (int dim0 = 0; dim0 < sizeof(msg.stations)/sizeof(msg.stations[0]); dim0++) {
write_value((char*)&msg.stations[dim0], sizeof(msg.stations[0]));
}
write_value((char*)&msg.ap_length, sizeof(msg.ap_length));
write_value((char*)&msg.mirror_flags, sizeof(msg.mirror_flags));
return sizeof(msg.ekey) + sizeof(msg.scan_id) + sizeof(msg.init_key) + sizeof(msg.corr_mode) + sizeof(msg.stations) + sizeof(msg.ap_length) + sizeof(msg.mirror_flags);
}

bool Mark5B_Connection::receive_msg(int* client_socket, struct Root_Complete* msg) {
const int message_size = sizeof(msg->root_filename);
if (!(read_chunk(client_socket,message_size) == message_size)) return false;
for (int dim0 = 0; dim0 < sizeof(msg->root_filename)/sizeof(msg->root_filename[0]); dim0++) {
read_value((char*)&msg->root_filename[dim0], sizeof(msg->root_filename[0]));
}
return true;
}

int Mark5B_Connection::write_msg(const struct Root_Complete& msg) {
for (int dim0 = 0; dim0 < sizeof(msg.root_filename)/sizeof(msg.root_filename[0]); dim0++) {
write_value((char*)&msg.root_filename[dim0], sizeof(msg.root_filename[0]));
}
return sizeof(msg.root_filename);
}

bool Mark5B_Connection::receive_msg(int* client_socket, struct Root_Failure* msg) {
const int message_size = sizeof(msg->return_code);
if (!(read_chunk(client_socket,message_size) == message_size)) return false;
read_value((char*)&msg->return_code, sizeof(msg->return_code));
return true;
}

int Mark5B_Connection::write_msg(const struct Root_Failure& msg) {
write_value((char*)&msg.return_code, sizeof(msg.return_code));
return sizeof(msg.return_code);
}

bool Mark5B_Connection::receive_msg(int* client_socket, struct Initialize_Correlator* msg) {
const int message_size = sizeof(msg->ivex_key) + sizeof(msg->su_list);
if (!(read_chunk(client_socket,message_size) == message_size)) return false;
for (int dim0 = 0; dim0 < sizeof(msg->ivex_key)/sizeof(msg->ivex_key[0]); dim0++) {
read_value((char*)&msg->ivex_key[dim0], sizeof(msg->ivex_key[0]));
}
for (int dim0 = 0; dim0 < sizeof(msg->su_list)/sizeof(msg->su_list[0]); dim0++) {
read_value((char*)&msg->su_list[dim0], sizeof(msg->su_list[0]));
}
return true;
}

int Mark5B_Connection::write_msg(const struct Initialize_Correlator& msg) {
for (int dim0 = 0; dim0 < sizeof(msg.ivex_key)/sizeof(msg.ivex_key[0]); dim0++) {
write_value((char*)&msg.ivex_key[dim0], sizeof(msg.ivex_key[0]));
}
for (int dim0 = 0; dim0 < sizeof(msg.su_list)/sizeof(msg.su_list[0]); dim0++) {
write_value((char*)&msg.su_list[dim0], sizeof(msg.su_list[0]));
}
return sizeof(msg.ivex_key) + sizeof(msg.su_list);
}

bool Mark5B_Connection::receive_msg(int* client_socket, struct Correlator_Initialized* msg) {
const int message_size = sizeof(msg->link_status);
if (!(read_chunk(client_socket,message_size) == message_size)) return false;
for (int dim0 = 0; dim0 < sizeof(msg->link_status)/sizeof(msg->link_status[0]); dim0++) {
for (int dim1 = 0; dim1 < sizeof(msg->link_status[0])/sizeof(msg->link_status[0][0]); dim1++) {
read_value((char*)&msg->link_status[dim0][dim1], sizeof(msg->link_status[0][0]));
}
}
return true;
}

int Mark5B_Connection::write_msg(const struct Correlator_Initialized& msg) {
for (int dim0 = 0; dim0 < sizeof(msg.link_status)/sizeof(msg.link_status[0]); dim0++) {
for (int dim1 = 0; dim1 < sizeof(msg.link_status[0])/sizeof(msg.link_status[0][0]); dim1++) {
write_value((char*)&msg.link_status[dim0][dim1], sizeof(msg.link_status[0][0]));
}
}
return sizeof(msg.link_status);
}

bool Mark5B_Connection::receive_msg(int* client_socket, struct Configure_Correlator* msg) {
const int message_size = sizeof(msg->root_filename) + sizeof(msg->ref_station_order) + sizeof(msg->configure_cot) + sizeof(msg->stream) + sizeof(msg->slice_pool);
if (!(read_chunk(client_socket,message_size) == message_size)) return false;
for (int dim0 = 0; dim0 < sizeof(msg->root_filename)/sizeof(msg->root_filename[0]); dim0++) {
read_value((char*)&msg->root_filename[dim0], sizeof(msg->root_filename[0]));
}
for (int dim0 = 0; dim0 < sizeof(msg->ref_station_order)/sizeof(msg->ref_station_order[0]); dim0++) {
read_value((char*)&msg->ref_station_order[dim0], sizeof(msg->ref_station_order[0]));
}
read_value((char*)&msg->configure_cot, sizeof(msg->configure_cot));
read_value((char*)&msg->stream, sizeof(msg->stream));
read_value((char*)&msg->slice_pool, sizeof(msg->slice_pool));
return true;
}

int Mark5B_Connection::write_msg(const struct Configure_Correlator& msg) {
for (int dim0 = 0; dim0 < sizeof(msg.root_filename)/sizeof(msg.root_filename[0]); dim0++) {
write_value((char*)&msg.root_filename[dim0], sizeof(msg.root_filename[0]));
}
for (int dim0 = 0; dim0 < sizeof(msg.ref_station_order)/sizeof(msg.ref_station_order[0]); dim0++) {
write_value((char*)&msg.ref_station_order[dim0], sizeof(msg.ref_station_order[0]));
}
write_value((char*)&msg.configure_cot, sizeof(msg.configure_cot));
write_value((char*)&msg.stream, sizeof(msg.stream));
write_value((char*)&msg.slice_pool, sizeof(msg.slice_pool));
return sizeof(msg.root_filename) + sizeof(msg.ref_station_order) + sizeof(msg.configure_cot) + sizeof(msg.stream) + sizeof(msg.slice_pool);
}

bool Mark5B_Connection::receive_msg(int* client_socket, struct Cu_Configuration* msg) {
return true;
}

int Mark5B_Connection::write_msg(const struct Cu_Configuration& msg) {
return 0;
}

bool Mark5B_Connection::receive_msg(int* client_socket, struct Cu_Resource_Error* msg) {
const int message_size = sizeof(msg->return_code);
if (!(read_chunk(client_socket,message_size) == message_size)) return false;
read_value((char*)&msg->return_code, sizeof(msg->return_code));
return true;
}

int Mark5B_Connection::write_msg(const struct Cu_Resource_Error& msg) {
write_value((char*)&msg.return_code, sizeof(msg.return_code));
return sizeof(msg.return_code);
}

bool Mark5B_Connection::receive_msg(int* client_socket, struct Correlator_Abort* msg) {
const int message_size = sizeof(msg->abort_flags) + sizeof(msg->station);
if (!(read_chunk(client_socket,message_size) == message_size)) return false;
read_value((char*)&msg->abort_flags, sizeof(msg->abort_flags));
read_value((char*)&msg->station, sizeof(msg->station));
return true;
}

int Mark5B_Connection::write_msg(const struct Correlator_Abort& msg) {
write_value((char*)&msg.abort_flags, sizeof(msg.abort_flags));
write_value((char*)&msg.station, sizeof(msg.station));
return sizeof(msg.abort_flags) + sizeof(msg.station);
}

bool Mark5B_Connection::receive_msg(int* client_socket, struct Corrtask_Complete* msg) {
const int message_size = sizeof(msg->slice_count) + sizeof(msg->error_flags);
if (!(read_chunk(client_socket,message_size) == message_size)) return false;
read_value((char*)&msg->slice_count, sizeof(msg->slice_count));
read_value((char*)&msg->error_flags, sizeof(msg->error_flags));
return true;
}

int Mark5B_Connection::write_msg(const struct Corrtask_Complete& msg) {
write_value((char*)&msg.slice_count, sizeof(msg.slice_count));
write_value((char*)&msg.error_flags, sizeof(msg.error_flags));
return sizeof(msg.slice_count) + sizeof(msg.error_flags);
}

bool Mark5B_Connection::receive_msg(int* client_socket, struct Realtime_Display* msg) {
const int message_size = sizeof(msg->baseline) + sizeof(msg->chan_name) + sizeof(msg->enable);
if (!(read_chunk(client_socket,message_size) == message_size)) return false;
for (int dim0 = 0; dim0 < sizeof(msg->baseline)/sizeof(msg->baseline[0]); dim0++) {
read_value((char*)&msg->baseline[dim0], sizeof(msg->baseline[0]));
}
for (int dim0 = 0; dim0 < sizeof(msg->chan_name)/sizeof(msg->chan_name[0]); dim0++) {
read_value((char*)&msg->chan_name[dim0], sizeof(msg->chan_name[0]));
}
read_value((char*)&msg->enable, sizeof(msg->enable));
return true;
}

int Mark5B_Connection::write_msg(const struct Realtime_Display& msg) {
for (int dim0 = 0; dim0 < sizeof(msg.baseline)/sizeof(msg.baseline[0]); dim0++) {
write_value((char*)&msg.baseline[dim0], sizeof(msg.baseline[0]));
}
for (int dim0 = 0; dim0 < sizeof(msg.chan_name)/sizeof(msg.chan_name[0]); dim0++) {
write_value((char*)&msg.chan_name[dim0], sizeof(msg.chan_name[0]));
}
write_value((char*)&msg.enable, sizeof(msg.enable));
return sizeof(msg.baseline) + sizeof(msg.chan_name) + sizeof(msg.enable);
}

bool Mark5B_Connection::receive_msg(int* client_socket, struct Realtime_Data* msg) {
const int message_size = sizeof(msg->chan_name);
if (!(read_chunk(client_socket,message_size) == message_size)) return false;
for (int dim0 = 0; dim0 < sizeof(msg->chan_name)/sizeof(msg->chan_name[0]); dim0++) {
read_value((char*)&msg->chan_name[dim0], sizeof(msg->chan_name[0]));
}
return true;
}

int Mark5B_Connection::write_msg(const struct Realtime_Data& msg) {
for (int dim0 = 0; dim0 < sizeof(msg.chan_name)/sizeof(msg.chan_name[0]); dim0++) {
write_value((char*)&msg.chan_name[dim0], sizeof(msg.chan_name[0]));
}
return sizeof(msg.chan_name);
}

bool Mark5B_Connection::receive_msg(int* client_socket, struct Correlator_Stats* msg) {
const int message_size = sizeof(msg->su) + sizeof(msg->numChannels) + sizeof(msg->ChnData);
if (!(read_chunk(client_socket,message_size) == message_size)) return false;
for (int dim0 = 0; dim0 < sizeof(msg->su)/sizeof(msg->su[0]); dim0++) {
read_value((char*)&msg->su[dim0], sizeof(msg->su[0]));
}
read_value((char*)&msg->numChannels, sizeof(msg->numChannels));
for (int dim0 = 0; dim0 < sizeof(msg->ChnData)/sizeof(msg->ChnData[0]); dim0++) {
read_value((char*)&msg->ChnData[dim0], sizeof(msg->ChnData[0]));
}
return true;
}

int Mark5B_Connection::write_msg(const struct Correlator_Stats& msg) {
for (int dim0 = 0; dim0 < sizeof(msg.su)/sizeof(msg.su[0]); dim0++) {
write_value((char*)&msg.su[dim0], sizeof(msg.su[0]));
}
write_value((char*)&msg.numChannels, sizeof(msg.numChannels));
for (int dim0 = 0; dim0 < sizeof(msg.ChnData)/sizeof(msg.ChnData[0]); dim0++) {
write_value((char*)&msg.ChnData[dim0], sizeof(msg.ChnData[0]));
}
return sizeof(msg.su) + sizeof(msg.numChannels) + sizeof(msg.ChnData);
}

bool Mark5B_Connection::receive_msg(int* client_socket, struct Initialize_Sus* msg) {
const int message_size = sizeof(msg->ivex_key) + sizeof(msg->su_list);
if (!(read_chunk(client_socket,message_size) == message_size)) return false;
for (int dim0 = 0; dim0 < sizeof(msg->ivex_key)/sizeof(msg->ivex_key[0]); dim0++) {
read_value((char*)&msg->ivex_key[dim0], sizeof(msg->ivex_key[0]));
}
for (int dim0 = 0; dim0 < sizeof(msg->su_list)/sizeof(msg->su_list[0]); dim0++) {
read_value((char*)&msg->su_list[dim0], sizeof(msg->su_list[0]));
}
return true;
}

int Mark5B_Connection::write_msg(const struct Initialize_Sus& msg) {
for (int dim0 = 0; dim0 < sizeof(msg.ivex_key)/sizeof(msg.ivex_key[0]); dim0++) {
write_value((char*)&msg.ivex_key[dim0], sizeof(msg.ivex_key[0]));
}
for (int dim0 = 0; dim0 < sizeof(msg.su_list)/sizeof(msg.su_list[0]); dim0++) {
write_value((char*)&msg.su_list[dim0], sizeof(msg.su_list[0]));
}
return sizeof(msg.ivex_key) + sizeof(msg.su_list);
}

bool Mark5B_Connection::receive_msg(int* client_socket, struct Sus_Initialized* msg) {
const int message_size = sizeof(msg->su_init_flags);
if (!(read_chunk(client_socket,message_size) == message_size)) return false;
for (int dim0 = 0; dim0 < sizeof(msg->su_init_flags)/sizeof(msg->su_init_flags[0]); dim0++) {
read_value((char*)&msg->su_init_flags[dim0], sizeof(msg->su_init_flags[0]));
}
return true;
}

int Mark5B_Connection::write_msg(const struct Sus_Initialized& msg) {
for (int dim0 = 0; dim0 < sizeof(msg.su_init_flags)/sizeof(msg.su_init_flags[0]); dim0++) {
write_value((char*)&msg.su_init_flags[dim0], sizeof(msg.su_init_flags[0]));
}
return sizeof(msg.su_init_flags);
}

bool Mark5B_Connection::receive_msg(int* client_socket, struct Configure_Sus* msg) {
const int message_size = sizeof(msg->root_filename) + sizeof(msg->stream) + sizeof(msg->chan_mask) + sizeof(msg->realtime_mode);
if (!(read_chunk(client_socket,message_size) == message_size)) return false;
for (int dim0 = 0; dim0 < sizeof(msg->root_filename)/sizeof(msg->root_filename[0]); dim0++) {
read_value((char*)&msg->root_filename[dim0], sizeof(msg->root_filename[0]));
}
read_value((char*)&msg->stream, sizeof(msg->stream));
read_value((char*)&msg->chan_mask, sizeof(msg->chan_mask));
read_value((char*)&msg->realtime_mode, sizeof(msg->realtime_mode));
return true;
}

int Mark5B_Connection::write_msg(const struct Configure_Sus& msg) {
for (int dim0 = 0; dim0 < sizeof(msg.root_filename)/sizeof(msg.root_filename[0]); dim0++) {
write_value((char*)&msg.root_filename[dim0], sizeof(msg.root_filename[0]));
}
write_value((char*)&msg.stream, sizeof(msg.stream));
write_value((char*)&msg.chan_mask, sizeof(msg.chan_mask));
write_value((char*)&msg.realtime_mode, sizeof(msg.realtime_mode));
return sizeof(msg.root_filename) + sizeof(msg.stream) + sizeof(msg.chan_mask) + sizeof(msg.realtime_mode);
}

bool Mark5B_Connection::receive_msg(int* client_socket, struct Sus_Configured* msg) {
return true;
}

int Mark5B_Connection::write_msg(const struct Sus_Configured& msg) {
return 0;
}

bool Mark5B_Connection::receive_msg(int* client_socket, struct Su_Config_Error* msg) {
const int message_size = sizeof(msg->return_code);
if (!(read_chunk(client_socket,message_size) == message_size)) return false;
read_value((char*)&msg->return_code, sizeof(msg->return_code));
return true;
}

int Mark5B_Connection::write_msg(const struct Su_Config_Error& msg) {
write_value((char*)&msg.return_code, sizeof(msg.return_code));
return sizeof(msg.return_code);
}

bool Mark5B_Connection::receive_msg(int* client_socket, struct Cant_Mount_Tape* msg) {
const int message_size = sizeof(msg->return_code) + sizeof(msg->station);
if (!(read_chunk(client_socket,message_size) == message_size)) return false;
read_value((char*)&msg->return_code, sizeof(msg->return_code));
read_value((char*)&msg->station, sizeof(msg->station));
return true;
}

int Mark5B_Connection::write_msg(const struct Cant_Mount_Tape& msg) {
write_value((char*)&msg.return_code, sizeof(msg.return_code));
write_value((char*)&msg.station, sizeof(msg.station));
return sizeof(msg.return_code) + sizeof(msg.station);
}

bool Mark5B_Connection::receive_msg(int* client_socket, struct All_Mounted* msg) {
return true;
}

int Mark5B_Connection::write_msg(const struct All_Mounted& msg) {
return 0;
}

bool Mark5B_Connection::receive_msg(int* client_socket, struct Pos_To_Tot* msg) {
return true;
}

int Mark5B_Connection::write_msg(const struct Pos_To_Tot& msg) {
return 0;
}

bool Mark5B_Connection::receive_msg(int* client_socket, struct Repos_To_Tot* msg) {
const int message_size = sizeof(msg->su) + sizeof(msg->location);
if (!(read_chunk(client_socket,message_size) == message_size)) return false;
read_value((char*)&msg->su, sizeof(msg->su));
read_value((char*)&msg->location, sizeof(msg->location));
return true;
}

int Mark5B_Connection::write_msg(const struct Repos_To_Tot& msg) {
write_value((char*)&msg.su, sizeof(msg.su));
write_value((char*)&msg.location, sizeof(msg.location));
return sizeof(msg.su) + sizeof(msg.location);
}

bool Mark5B_Connection::receive_msg(int* client_socket, struct Valid_Time* msg) {
const int message_size = sizeof(msg->first_useable_tot) + sizeof(msg->su);
if (!(read_chunk(client_socket,message_size) == message_size)) return false;
read_value((char*)&msg->first_useable_tot, sizeof(msg->first_useable_tot));
read_value((char*)&msg->su, sizeof(msg->su));
return true;
}

int Mark5B_Connection::write_msg(const struct Valid_Time& msg) {
write_value((char*)&msg.first_useable_tot, sizeof(msg.first_useable_tot));
write_value((char*)&msg.su, sizeof(msg.su));
return sizeof(msg.first_useable_tot) + sizeof(msg.su);
}

bool Mark5B_Connection::receive_msg(int* client_socket, struct Cant_Find_Time* msg) {
const int message_size = sizeof(msg->bad_tot) + sizeof(msg->failure_code) + sizeof(msg->station) + sizeof(msg->su);
if (!(read_chunk(client_socket,message_size) == message_size)) return false;
read_value((char*)&msg->bad_tot, sizeof(msg->bad_tot));
read_value((char*)&msg->failure_code, sizeof(msg->failure_code));
read_value((char*)&msg->station, sizeof(msg->station));
read_value((char*)&msg->su, sizeof(msg->su));
return true;
}

int Mark5B_Connection::write_msg(const struct Cant_Find_Time& msg) {
write_value((char*)&msg.bad_tot, sizeof(msg.bad_tot));
write_value((char*)&msg.failure_code, sizeof(msg.failure_code));
write_value((char*)&msg.station, sizeof(msg.station));
write_value((char*)&msg.su, sizeof(msg.su));
return sizeof(msg.bad_tot) + sizeof(msg.failure_code) + sizeof(msg.station) + sizeof(msg.su);
}

bool Mark5B_Connection::receive_msg(int* client_socket, struct Synchronize_Tapes* msg) {
const int message_size = sizeof(msg->tape_start_rot);
if (!(read_chunk(client_socket,message_size) == message_size)) return false;
for (int dim0 = 0; dim0 < sizeof(msg->tape_start_rot)/sizeof(msg->tape_start_rot[0]); dim0++) {
read_value((char*)&msg->tape_start_rot[dim0], sizeof(msg->tape_start_rot[0]));
}
return true;
}

int Mark5B_Connection::write_msg(const struct Synchronize_Tapes& msg) {
for (int dim0 = 0; dim0 < sizeof(msg.tape_start_rot)/sizeof(msg.tape_start_rot[0]); dim0++) {
write_value((char*)&msg.tape_start_rot[dim0], sizeof(msg.tape_start_rot[0]));
}
return sizeof(msg.tape_start_rot);
}

bool Mark5B_Connection::receive_msg(int* client_socket, struct Send_Tape_Info* msg) {
const int message_size = sizeof(msg->interval);
if (!(read_chunk(client_socket,message_size) == message_size)) return false;
read_value((char*)&msg->interval, sizeof(msg->interval));
return true;
}

int Mark5B_Connection::write_msg(const struct Send_Tape_Info& msg) {
write_value((char*)&msg.interval, sizeof(msg.interval));
return sizeof(msg.interval);
}

bool Mark5B_Connection::receive_msg(int* client_socket, struct Tape_Info* msg) {
return true;
}

int Mark5B_Connection::write_msg(const struct Tape_Info& msg) {
return 0;
}

bool Mark5B_Connection::receive_msg(int* client_socket, struct End_Task* msg) {
return true;
}

int Mark5B_Connection::write_msg(const struct End_Task& msg) {
return 0;
}

bool Mark5B_Connection::receive_msg(int* client_socket, struct Transmit_Ffs* msg) {
return true;
}

int Mark5B_Connection::write_msg(const struct Transmit_Ffs& msg) {
return 0;
}

bool Mark5B_Connection::receive_msg(int* client_socket, struct Initialize_Mk5* msg) {
const int message_size = sizeof(msg->cf_length) + sizeof(msg->bocf_stretch) + sizeof(msg->su_id) + sizeof(msg->send_mounts) + sizeof(msg->realtime) + sizeof(msg->packet_size);
if (!(read_chunk(client_socket,message_size) == message_size)) return false;
read_value((char*)&msg->cf_length, sizeof(msg->cf_length));
read_value((char*)&msg->bocf_stretch, sizeof(msg->bocf_stretch));
read_value((char*)&msg->su_id, sizeof(msg->su_id));
read_value((char*)&msg->send_mounts, sizeof(msg->send_mounts));
read_value((char*)&msg->realtime, sizeof(msg->realtime));
read_value((char*)&msg->packet_size, sizeof(msg->packet_size));
return true;
}

int Mark5B_Connection::write_msg(const struct Initialize_Mk5& msg) {
write_value((char*)&msg.cf_length, sizeof(msg.cf_length));
write_value((char*)&msg.bocf_stretch, sizeof(msg.bocf_stretch));
write_value((char*)&msg.su_id, sizeof(msg.su_id));
write_value((char*)&msg.send_mounts, sizeof(msg.send_mounts));
write_value((char*)&msg.realtime, sizeof(msg.realtime));
write_value((char*)&msg.packet_size, sizeof(msg.packet_size));
return sizeof(msg.cf_length) + sizeof(msg.bocf_stretch) + sizeof(msg.su_id) + sizeof(msg.send_mounts) + sizeof(msg.realtime) + sizeof(msg.packet_size);
}

bool Mark5B_Connection::receive_msg(int* client_socket, struct Mount_Change* msg) {
const int message_size = sizeof(msg->vsn) + sizeof(msg->serno) + sizeof(msg->su_id);
if (!(read_chunk(client_socket,message_size) == message_size)) return false;
for (int dim0 = 0; dim0 < sizeof(msg->vsn)/sizeof(msg->vsn[0]); dim0++) {
for (int dim1 = 0; dim1 < sizeof(msg->vsn[0])/sizeof(msg->vsn[0][0]); dim1++) {
read_value((char*)&msg->vsn[dim0][dim1], sizeof(msg->vsn[0][0]));
}
}
for (int dim0 = 0; dim0 < sizeof(msg->serno)/sizeof(msg->serno[0]); dim0++) {
for (int dim1 = 0; dim1 < sizeof(msg->serno[0])/sizeof(msg->serno[0][0]); dim1++) {
for (int dim2 = 0; dim2 < sizeof(msg->serno[0][0])/sizeof(msg->serno[0][0][0]); dim2++) {
read_value((char*)&msg->serno[dim0][dim1][dim2], sizeof(msg->serno[0][0][0]));
}
}
}
read_value((char*)&msg->su_id, sizeof(msg->su_id));
return true;
}

int Mark5B_Connection::write_msg(const struct Mount_Change& msg) {
for (int dim0 = 0; dim0 < sizeof(msg.vsn)/sizeof(msg.vsn[0]); dim0++) {
for (int dim1 = 0; dim1 < sizeof(msg.vsn[0])/sizeof(msg.vsn[0][0]); dim1++) {
write_value((char*)&msg.vsn[dim0][dim1], sizeof(msg.vsn[0][0]));
}
}
for (int dim0 = 0; dim0 < sizeof(msg.serno)/sizeof(msg.serno[0]); dim0++) {
for (int dim1 = 0; dim1 < sizeof(msg.serno[0])/sizeof(msg.serno[0][0]); dim1++) {
for (int dim2 = 0; dim2 < sizeof(msg.serno[0][0])/sizeof(msg.serno[0][0][0]); dim2++) {
write_value((char*)&msg.serno[dim0][dim1][dim2], sizeof(msg.serno[0][0][0]));
}
}
}
write_value((char*)&msg.su_id, sizeof(msg.su_id));
return sizeof(msg.vsn) + sizeof(msg.serno) + sizeof(msg.su_id);
}

bool Mark5B_Connection::receive_msg(int* client_socket, struct Send_M5_Status* msg) {
const int message_size = sizeof(msg->interval);
if (!(read_chunk(client_socket,message_size) == message_size)) return false;
read_value((char*)&msg->interval, sizeof(msg->interval));
return true;
}

int Mark5B_Connection::write_msg(const struct Send_M5_Status& msg) {
write_value((char*)&msg.interval, sizeof(msg.interval));
return sizeof(msg.interval);
}

bool Mark5B_Connection::receive_msg(int* client_socket, struct M5_Status* msg) {
const int message_size = sizeof(msg->status) + sizeof(msg->tot) + sizeof(msg->su_id);
if (!(read_chunk(client_socket,message_size) == message_size)) return false;
read_value((char*)&msg->status, sizeof(msg->status));
read_value((char*)&msg->tot, sizeof(msg->tot));
read_value((char*)&msg->su_id, sizeof(msg->su_id));
return true;
}

int Mark5B_Connection::write_msg(const struct M5_Status& msg) {
write_value((char*)&msg.status, sizeof(msg.status));
write_value((char*)&msg.tot, sizeof(msg.tot));
write_value((char*)&msg.su_id, sizeof(msg.su_id));
return sizeof(msg.status) + sizeof(msg.tot) + sizeof(msg.su_id);
}

bool Mark5B_Connection::receive_msg(int* client_socket, struct Lookup_Scan* msg) {
const int message_size = sizeof(msg->scan_label) + sizeof(msg->bank_select);
if (!(read_chunk(client_socket,message_size) == message_size)) return false;
for (int dim0 = 0; dim0 < sizeof(msg->scan_label)/sizeof(msg->scan_label[0]); dim0++) {
read_value((char*)&msg->scan_label[dim0], sizeof(msg->scan_label[0]));
}
read_value((char*)&msg->bank_select, sizeof(msg->bank_select));
return true;
}

int Mark5B_Connection::write_msg(const struct Lookup_Scan& msg) {
for (int dim0 = 0; dim0 < sizeof(msg.scan_label)/sizeof(msg.scan_label[0]); dim0++) {
write_value((char*)&msg.scan_label[dim0], sizeof(msg.scan_label[0]));
}
write_value((char*)&msg.bank_select, sizeof(msg.bank_select));
return sizeof(msg.scan_label) + sizeof(msg.bank_select);
}

bool Mark5B_Connection::receive_msg(int* client_socket, struct Scan_Bounds* msg) {
const int message_size = sizeof(msg->start_byte) + sizeof(msg->end_byte) + sizeof(msg->su_id);
if (!(read_chunk(client_socket,message_size) == message_size)) return false;
read_value((char*)&msg->start_byte, sizeof(msg->start_byte));
read_value((char*)&msg->end_byte, sizeof(msg->end_byte));
read_value((char*)&msg->su_id, sizeof(msg->su_id));
return true;
}

int Mark5B_Connection::write_msg(const struct Scan_Bounds& msg) {
write_value((char*)&msg.start_byte, sizeof(msg.start_byte));
write_value((char*)&msg.end_byte, sizeof(msg.end_byte));
write_value((char*)&msg.su_id, sizeof(msg.su_id));
return sizeof(msg.start_byte) + sizeof(msg.end_byte) + sizeof(msg.su_id);
}

bool Mark5B_Connection::receive_msg(int* client_socket, struct Find_Next_Header* msg) {
const int message_size = sizeof(msg->byte_num);
if (!(read_chunk(client_socket,message_size) == message_size)) return false;
read_value((char*)&msg->byte_num, sizeof(msg->byte_num));
return true;
}

int Mark5B_Connection::write_msg(const struct Find_Next_Header& msg) {
write_value((char*)&msg.byte_num, sizeof(msg.byte_num));
return sizeof(msg.byte_num);
}

bool Mark5B_Connection::receive_msg(int* client_socket, struct Header_Contents* msg) {
const int message_size = sizeof(msg->byte_num) + sizeof(msg->df_header) + sizeof(msg->su_id);
if (!(read_chunk(client_socket,message_size) == message_size)) return false;
read_value((char*)&msg->byte_num, sizeof(msg->byte_num));
for (int dim0 = 0; dim0 < sizeof(msg->df_header)/sizeof(msg->df_header[0]); dim0++) {
read_value((char*)&msg->df_header[dim0], sizeof(msg->df_header[0]));
}
read_value((char*)&msg->su_id, sizeof(msg->su_id));
return true;
}

int Mark5B_Connection::write_msg(const struct Header_Contents& msg) {
write_value((char*)&msg.byte_num, sizeof(msg.byte_num));
for (int dim0 = 0; dim0 < sizeof(msg.df_header)/sizeof(msg.df_header[0]); dim0++) {
write_value((char*)&msg.df_header[dim0], sizeof(msg.df_header[0]));
}
write_value((char*)&msg.su_id, sizeof(msg.su_id));
return sizeof(msg.byte_num) + sizeof(msg.df_header) + sizeof(msg.su_id);
}

bool Mark5B_Connection::receive_msg(int* client_socket, struct Configure_Scan* msg) {
const int message_size = sizeof(msg->byte_num) + sizeof(msg->start_rot) + sizeof(msg->end_rot) + sizeof(msg->ss_invalid_code) + sizeof(msg->dim_invalid_code) + sizeof(msg->crossbar_map) + sizeof(msg->sample_rate) + sizeof(msg->output_rate) + sizeof(msg->num_bitstreams) + sizeof(msg->bits_sample) + sizeof(msg->scan_label);
if (!(read_chunk(client_socket,message_size) == message_size)) return false;
read_value((char*)&msg->byte_num, sizeof(msg->byte_num));
read_value((char*)&msg->start_rot, sizeof(msg->start_rot));
read_value((char*)&msg->end_rot, sizeof(msg->end_rot));
read_value((char*)&msg->ss_invalid_code, sizeof(msg->ss_invalid_code));
read_value((char*)&msg->dim_invalid_code, sizeof(msg->dim_invalid_code));
for (int dim0 = 0; dim0 < sizeof(msg->crossbar_map)/sizeof(msg->crossbar_map[0]); dim0++) {
read_value((char*)&msg->crossbar_map[dim0], sizeof(msg->crossbar_map[0]));
}
read_value((char*)&msg->sample_rate, sizeof(msg->sample_rate));
read_value((char*)&msg->output_rate, sizeof(msg->output_rate));
read_value((char*)&msg->num_bitstreams, sizeof(msg->num_bitstreams));
read_value((char*)&msg->bits_sample, sizeof(msg->bits_sample));
for (int dim0 = 0; dim0 < sizeof(msg->scan_label)/sizeof(msg->scan_label[0]); dim0++) {
read_value((char*)&msg->scan_label[dim0], sizeof(msg->scan_label[0]));
}
return true;
}

int Mark5B_Connection::write_msg(const struct Configure_Scan& msg) {
write_value((char*)&msg.byte_num, sizeof(msg.byte_num));
write_value((char*)&msg.start_rot, sizeof(msg.start_rot));
write_value((char*)&msg.end_rot, sizeof(msg.end_rot));
write_value((char*)&msg.ss_invalid_code, sizeof(msg.ss_invalid_code));
write_value((char*)&msg.dim_invalid_code, sizeof(msg.dim_invalid_code));
for (int dim0 = 0; dim0 < sizeof(msg.crossbar_map)/sizeof(msg.crossbar_map[0]); dim0++) {
write_value((char*)&msg.crossbar_map[dim0], sizeof(msg.crossbar_map[0]));
}
write_value((char*)&msg.sample_rate, sizeof(msg.sample_rate));
write_value((char*)&msg.output_rate, sizeof(msg.output_rate));
write_value((char*)&msg.num_bitstreams, sizeof(msg.num_bitstreams));
write_value((char*)&msg.bits_sample, sizeof(msg.bits_sample));
for (int dim0 = 0; dim0 < sizeof(msg.scan_label)/sizeof(msg.scan_label[0]); dim0++) {
write_value((char*)&msg.scan_label[dim0], sizeof(msg.scan_label[0]));
}
return sizeof(msg.byte_num) + sizeof(msg.start_rot) + sizeof(msg.end_rot) + sizeof(msg.ss_invalid_code) + sizeof(msg.dim_invalid_code) + sizeof(msg.crossbar_map) + sizeof(msg.sample_rate) + sizeof(msg.output_rate) + sizeof(msg.num_bitstreams) + sizeof(msg.bits_sample) + sizeof(msg.scan_label);
}

bool Mark5B_Connection::receive_msg(int* client_socket, struct Model_Data* msg) {
const int message_size = sizeof(msg->rot_interval) + sizeof(msg->delay) + sizeof(msg->phase) + sizeof(msg->sidebands) + sizeof(msg->nchan) + sizeof(msg->oversampling) + sizeof(msg->k_div);
if (!(read_chunk(client_socket,message_size) == message_size)) return false;
for (int dim0 = 0; dim0 < sizeof(msg->rot_interval)/sizeof(msg->rot_interval[0]); dim0++) {
read_value((char*)&msg->rot_interval[dim0], sizeof(msg->rot_interval[0]));
}
for (int dim0 = 0; dim0 < sizeof(msg->delay)/sizeof(msg->delay[0]); dim0++) {
read_value((char*)&msg->delay[dim0], sizeof(msg->delay[0]));
}
for (int dim0 = 0; dim0 < sizeof(msg->phase)/sizeof(msg->phase[0]); dim0++) {
for (int dim1 = 0; dim1 < sizeof(msg->phase[0])/sizeof(msg->phase[0][0]); dim1++) {
read_value((char*)&msg->phase[dim0][dim1], sizeof(msg->phase[0][0]));
}
}
read_value((char*)&msg->sidebands, sizeof(msg->sidebands));
read_value((char*)&msg->nchan, sizeof(msg->nchan));
read_value((char*)&msg->oversampling, sizeof(msg->oversampling));
read_value((char*)&msg->k_div, sizeof(msg->k_div));
return true;
}

int Mark5B_Connection::write_msg(const struct Model_Data& msg) {
for (int dim0 = 0; dim0 < sizeof(msg.rot_interval)/sizeof(msg.rot_interval[0]); dim0++) {
write_value((char*)&msg.rot_interval[dim0], sizeof(msg.rot_interval[0]));
}
for (int dim0 = 0; dim0 < sizeof(msg.delay)/sizeof(msg.delay[0]); dim0++) {
write_value((char*)&msg.delay[dim0], sizeof(msg.delay[0]));
}
for (int dim0 = 0; dim0 < sizeof(msg.phase)/sizeof(msg.phase[0]); dim0++) {
for (int dim1 = 0; dim1 < sizeof(msg.phase[0])/sizeof(msg.phase[0][0]); dim1++) {
write_value((char*)&msg.phase[dim0][dim1], sizeof(msg.phase[0][0]));
}
}
write_value((char*)&msg.sidebands, sizeof(msg.sidebands));
write_value((char*)&msg.nchan, sizeof(msg.nchan));
write_value((char*)&msg.oversampling, sizeof(msg.oversampling));
write_value((char*)&msg.k_div, sizeof(msg.k_div));
return sizeof(msg.rot_interval) + sizeof(msg.delay) + sizeof(msg.phase) + sizeof(msg.sidebands) + sizeof(msg.nchan) + sizeof(msg.oversampling) + sizeof(msg.k_div);
}

bool Mark5B_Connection::receive_msg(int* client_socket, struct Pcal_Request* msg) {
const int message_size = sizeof(msg->tones) + sizeof(msg->ntones) + sizeof(msg->ap);
if (!(read_chunk(client_socket,message_size) == message_size)) return false;
for (int dim0 = 0; dim0 < sizeof(msg->tones)/sizeof(msg->tones[0]); dim0++) {
read_value((char*)&msg->tones[dim0], sizeof(msg->tones[0]));
}
read_value((char*)&msg->ntones, sizeof(msg->ntones));
read_value((char*)&msg->ap, sizeof(msg->ap));
return true;
}

int Mark5B_Connection::write_msg(const struct Pcal_Request& msg) {
for (int dim0 = 0; dim0 < sizeof(msg.tones)/sizeof(msg.tones[0]); dim0++) {
write_value((char*)&msg.tones[dim0], sizeof(msg.tones[0]));
}
write_value((char*)&msg.ntones, sizeof(msg.ntones));
write_value((char*)&msg.ap, sizeof(msg.ap));
return sizeof(msg.tones) + sizeof(msg.ntones) + sizeof(msg.ap);
}

bool Mark5B_Connection::receive_msg(int* client_socket, struct Pcal_Data* msg) {
const int message_size = sizeof(msg->timestamp) + sizeof(msg->accums) + sizeof(msg->su_id);
if (!(read_chunk(client_socket,message_size) == message_size)) return false;
read_value((char*)&msg->timestamp, sizeof(msg->timestamp));
for (int dim0 = 0; dim0 < sizeof(msg->accums)/sizeof(msg->accums[0]); dim0++) {
for (int dim1 = 0; dim1 < sizeof(msg->accums[0])/sizeof(msg->accums[0][0]); dim1++) {
for (int dim2 = 0; dim2 < sizeof(msg->accums[0][0])/sizeof(msg->accums[0][0][0]); dim2++) {
read_value((char*)&msg->accums[dim0][dim1][dim2], sizeof(msg->accums[0][0][0]));
}
}
}
read_value((char*)&msg->su_id, sizeof(msg->su_id));
return true;
}

int Mark5B_Connection::write_msg(const struct Pcal_Data& msg) {
write_value((char*)&msg.timestamp, sizeof(msg.timestamp));
for (int dim0 = 0; dim0 < sizeof(msg.accums)/sizeof(msg.accums[0]); dim0++) {
for (int dim1 = 0; dim1 < sizeof(msg.accums[0])/sizeof(msg.accums[0][0]); dim1++) {
for (int dim2 = 0; dim2 < sizeof(msg.accums[0][0])/sizeof(msg.accums[0][0][0]); dim2++) {
write_value((char*)&msg.accums[dim0][dim1][dim2], sizeof(msg.accums[0][0][0]));
}
}
}
write_value((char*)&msg.su_id, sizeof(msg.su_id));
return sizeof(msg.timestamp) + sizeof(msg.accums) + sizeof(msg.su_id);
}

bool Mark5B_Connection::receive_msg(int* client_socket, struct Scount_Request* msg) {
const int message_size = sizeof(msg->ap);
if (!(read_chunk(client_socket,message_size) == message_size)) return false;
read_value((char*)&msg->ap, sizeof(msg->ap));
return true;
}

int Mark5B_Connection::write_msg(const struct Scount_Request& msg) {
write_value((char*)&msg.ap, sizeof(msg.ap));
return sizeof(msg.ap);
}

bool Mark5B_Connection::receive_msg(int* client_socket, struct Scount_Data* msg) {
const int message_size = sizeof(msg->timestamp) + sizeof(msg->accums) + sizeof(msg->su_id);
if (!(read_chunk(client_socket,message_size) == message_size)) return false;
read_value((char*)&msg->timestamp, sizeof(msg->timestamp));
for (int dim0 = 0; dim0 < sizeof(msg->accums)/sizeof(msg->accums[0]); dim0++) {
for (int dim1 = 0; dim1 < sizeof(msg->accums[0])/sizeof(msg->accums[0][0]); dim1++) {
read_value((char*)&msg->accums[dim0][dim1], sizeof(msg->accums[0][0]));
}
}
read_value((char*)&msg->su_id, sizeof(msg->su_id));
return true;
}

int Mark5B_Connection::write_msg(const struct Scount_Data& msg) {
write_value((char*)&msg.timestamp, sizeof(msg.timestamp));
for (int dim0 = 0; dim0 < sizeof(msg.accums)/sizeof(msg.accums[0]); dim0++) {
for (int dim1 = 0; dim1 < sizeof(msg.accums[0])/sizeof(msg.accums[0][0]); dim1++) {
write_value((char*)&msg.accums[dim0][dim1], sizeof(msg.accums[0][0]));
}
}
write_value((char*)&msg.su_id, sizeof(msg.su_id));
return sizeof(msg.timestamp) + sizeof(msg.accums) + sizeof(msg.su_id);
}

bool Mark5B_Connection::receive_msg(int* client_socket, struct Abort_Scan* msg) {
return true;
}

int Mark5B_Connection::write_msg(const struct Abort_Scan& msg) {
return 0;
}

bool Mark5B_Connection::receive_msg(int* client_socket, struct Send_Directory* msg) {
const int message_size = sizeof(msg->bank) + sizeof(msg->nscan);
if (!(read_chunk(client_socket,message_size) == message_size)) return false;
read_value((char*)&msg->bank, sizeof(msg->bank));
read_value((char*)&msg->nscan, sizeof(msg->nscan));
return true;
}

int Mark5B_Connection::write_msg(const struct Send_Directory& msg) {
write_value((char*)&msg.bank, sizeof(msg.bank));
write_value((char*)&msg.nscan, sizeof(msg.nscan));
return sizeof(msg.bank) + sizeof(msg.nscan);
}

bool Mark5B_Connection::receive_msg(int* client_socket, struct Directory_Chunk* msg) {
const int message_size = sizeof(msg->bank) + sizeof(msg->nscan) + sizeof(msg->nreturned) + sizeof(msg->ntotal);
if (!(read_chunk(client_socket,message_size) == message_size)) return false;
read_value((char*)&msg->bank, sizeof(msg->bank));
read_value((char*)&msg->nscan, sizeof(msg->nscan));
read_value((char*)&msg->nreturned, sizeof(msg->nreturned));
read_value((char*)&msg->ntotal, sizeof(msg->ntotal));
return true;
}

int Mark5B_Connection::write_msg(const struct Directory_Chunk& msg) {
write_value((char*)&msg.bank, sizeof(msg.bank));
write_value((char*)&msg.nscan, sizeof(msg.nscan));
write_value((char*)&msg.nreturned, sizeof(msg.nreturned));
write_value((char*)&msg.ntotal, sizeof(msg.ntotal));
return sizeof(msg.bank) + sizeof(msg.nscan) + sizeof(msg.nreturned) + sizeof(msg.ntotal);
}

bool Mark5B_Connection::receive_msg(int* client_socket, struct Playback_Control* msg) {
const int message_size = sizeof(msg->play) + sizeof(msg->start) + sizeof(msg->sample_rate) + sizeof(msg->output_rate) + sizeof(msg->num_bitstreams);
if (!(read_chunk(client_socket,message_size) == message_size)) return false;
read_value((char*)&msg->play, sizeof(msg->play));
read_value((char*)&msg->start, sizeof(msg->start));
read_value((char*)&msg->sample_rate, sizeof(msg->sample_rate));
read_value((char*)&msg->output_rate, sizeof(msg->output_rate));
read_value((char*)&msg->num_bitstreams, sizeof(msg->num_bitstreams));
return true;
}

int Mark5B_Connection::write_msg(const struct Playback_Control& msg) {
write_value((char*)&msg.play, sizeof(msg.play));
write_value((char*)&msg.start, sizeof(msg.start));
write_value((char*)&msg.sample_rate, sizeof(msg.sample_rate));
write_value((char*)&msg.output_rate, sizeof(msg.output_rate));
write_value((char*)&msg.num_bitstreams, sizeof(msg.num_bitstreams));
return sizeof(msg.play) + sizeof(msg.start) + sizeof(msg.sample_rate) + sizeof(msg.output_rate) + sizeof(msg.num_bitstreams);
}

bool Mark5B_Connection::receive_msg(int* client_socket, struct Set_Cot_Clock* msg) {
const int message_size = sizeof(msg->initial_cot) + sizeof(msg->set) + sizeof(msg->broadcast);
if (!(read_chunk(client_socket,message_size) == message_size)) return false;
read_value((char*)&msg->initial_cot, sizeof(msg->initial_cot));
read_value((char*)&msg->set, sizeof(msg->set));
read_value((char*)&msg->broadcast, sizeof(msg->broadcast));
return true;
}

int Mark5B_Connection::write_msg(const struct Set_Cot_Clock& msg) {
write_value((char*)&msg.initial_cot, sizeof(msg.initial_cot));
write_value((char*)&msg.set, sizeof(msg.set));
write_value((char*)&msg.broadcast, sizeof(msg.broadcast));
return sizeof(msg.initial_cot) + sizeof(msg.set) + sizeof(msg.broadcast);
}

bool Mark5B_Connection::receive_msg(int* client_socket, struct Start_Rot_Clock* msg) {
const int message_size = sizeof(msg->starting_cot) + sizeof(msg->initial_rot) + sizeof(msg->ending_rot) + sizeof(msg->initial_rot_year) + sizeof(msg->rot_rate) + sizeof(msg->stream);
if (!(read_chunk(client_socket,message_size) == message_size)) return false;
read_value((char*)&msg->starting_cot, sizeof(msg->starting_cot));
read_value((char*)&msg->initial_rot, sizeof(msg->initial_rot));
read_value((char*)&msg->ending_rot, sizeof(msg->ending_rot));
read_value((char*)&msg->initial_rot_year, sizeof(msg->initial_rot_year));
read_value((char*)&msg->rot_rate, sizeof(msg->rot_rate));
read_value((char*)&msg->stream, sizeof(msg->stream));
return true;
}

int Mark5B_Connection::write_msg(const struct Start_Rot_Clock& msg) {
write_value((char*)&msg.starting_cot, sizeof(msg.starting_cot));
write_value((char*)&msg.initial_rot, sizeof(msg.initial_rot));
write_value((char*)&msg.ending_rot, sizeof(msg.ending_rot));
write_value((char*)&msg.initial_rot_year, sizeof(msg.initial_rot_year));
write_value((char*)&msg.rot_rate, sizeof(msg.rot_rate));
write_value((char*)&msg.stream, sizeof(msg.stream));
return sizeof(msg.starting_cot) + sizeof(msg.initial_rot) + sizeof(msg.ending_rot) + sizeof(msg.initial_rot_year) + sizeof(msg.rot_rate) + sizeof(msg.stream);
}

bool Mark5B_Connection::receive_msg(int* client_socket, struct Send_Times* msg) {
const int message_size = sizeof(msg->interval);
if (!(read_chunk(client_socket,message_size) == message_size)) return false;
read_value((char*)&msg->interval, sizeof(msg->interval));
return true;
}

int Mark5B_Connection::write_msg(const struct Send_Times& msg) {
write_value((char*)&msg.interval, sizeof(msg.interval));
return sizeof(msg.interval);
}

bool Mark5B_Connection::receive_msg(int* client_socket, struct Current_Times* msg) {
const int message_size = sizeof(msg->cot) + sizeof(msg->rot);
if (!(read_chunk(client_socket,message_size) == message_size)) return false;
read_value((char*)&msg->cot, sizeof(msg->cot));
for (int dim0 = 0; dim0 < sizeof(msg->rot)/sizeof(msg->rot[0]); dim0++) {
read_value((char*)&msg->rot[dim0], sizeof(msg->rot[0]));
}
return true;
}

int Mark5B_Connection::write_msg(const struct Current_Times& msg) {
write_value((char*)&msg.cot, sizeof(msg.cot));
for (int dim0 = 0; dim0 < sizeof(msg.rot)/sizeof(msg.rot[0]); dim0++) {
write_value((char*)&msg.rot[dim0], sizeof(msg.rot[0]));
}
return sizeof(msg.cot) + sizeof(msg.rot);
}

bool Mark5B_Connection::receive_msg(int* client_socket, struct Initialize_Hardware* msg) {
const int message_size = sizeof(msg->ivex_key) + sizeof(msg->correlator) + sizeof(msg->su_list);
if (!(read_chunk(client_socket,message_size) == message_size)) return false;
for (int dim0 = 0; dim0 < sizeof(msg->ivex_key)/sizeof(msg->ivex_key[0]); dim0++) {
read_value((char*)&msg->ivex_key[dim0], sizeof(msg->ivex_key[0]));
}
read_value((char*)&msg->correlator, sizeof(msg->correlator));
for (int dim0 = 0; dim0 < sizeof(msg->su_list)/sizeof(msg->su_list[0]); dim0++) {
read_value((char*)&msg->su_list[dim0], sizeof(msg->su_list[0]));
}
return true;
}

int Mark5B_Connection::write_msg(const struct Initialize_Hardware& msg) {
for (int dim0 = 0; dim0 < sizeof(msg.ivex_key)/sizeof(msg.ivex_key[0]); dim0++) {
write_value((char*)&msg.ivex_key[dim0], sizeof(msg.ivex_key[0]));
}
write_value((char*)&msg.correlator, sizeof(msg.correlator));
for (int dim0 = 0; dim0 < sizeof(msg.su_list)/sizeof(msg.su_list[0]); dim0++) {
write_value((char*)&msg.su_list[dim0], sizeof(msg.su_list[0]));
}
return sizeof(msg.ivex_key) + sizeof(msg.correlator) + sizeof(msg.su_list);
}

bool Mark5B_Connection::receive_msg(int* client_socket, struct Remove_Station* msg) {
const int message_size = sizeof(msg->station);
if (!(read_chunk(client_socket,message_size) == message_size)) return false;
read_value((char*)&msg->station, sizeof(msg->station));
return true;
}

int Mark5B_Connection::write_msg(const struct Remove_Station& msg) {
write_value((char*)&msg.station, sizeof(msg.station));
return sizeof(msg.station);
}

bool Mark5B_Connection::receive_msg(int* client_socket, struct Send_Cond_Status* msg) {
const int message_size = sizeof(msg->interval);
if (!(read_chunk(client_socket,message_size) == message_size)) return false;
read_value((char*)&msg->interval, sizeof(msg->interval));
return true;
}

int Mark5B_Connection::write_msg(const struct Send_Cond_Status& msg) {
write_value((char*)&msg.interval, sizeof(msg.interval));
return sizeof(msg.interval);
}

bool Mark5B_Connection::receive_msg(int* client_socket, struct Cond_Status* msg) {
return true;
}

int Mark5B_Connection::write_msg(const struct Cond_Status& msg) {
return 0;
}

bool Mark5B_Connection::receive_msg(int* client_socket, struct Mount_Request* msg) {
const int message_size = sizeof(msg->ntapes) + sizeof(msg->tape);
if (!(read_chunk(client_socket,message_size) == message_size)) return false;
read_value((char*)&msg->ntapes, sizeof(msg->ntapes));
for (int dim0 = 0; dim0 < sizeof(msg->tape)/sizeof(msg->tape[0]); dim0++) {
read_value((char*)&msg->tape[dim0], sizeof(msg->tape[0]));
}
return true;
}

int Mark5B_Connection::write_msg(const struct Mount_Request& msg) {
write_value((char*)&msg.ntapes, sizeof(msg.ntapes));
for (int dim0 = 0; dim0 < sizeof(msg.tape)/sizeof(msg.tape[0]); dim0++) {
write_value((char*)&msg.tape[dim0], sizeof(msg.tape[0]));
}
return sizeof(msg.ntapes) + sizeof(msg.tape);
}

bool Mark5B_Connection::receive_msg(int* client_socket, struct Mount_Status* msg) {
const int message_size = sizeof(msg->tape);
if (!(read_chunk(client_socket,message_size) == message_size)) return false;
read_value((char*)&msg->tape, sizeof(msg->tape));
return true;
}

int Mark5B_Connection::write_msg(const struct Mount_Status& msg) {
write_value((char*)&msg.tape, sizeof(msg.tape));
return sizeof(msg.tape);
}

bool Mark5B_Connection::receive_msg(int* client_socket, struct Dismount_Tape* msg) {
const int message_size = sizeof(msg->su);
if (!(read_chunk(client_socket,message_size) == message_size)) return false;
read_value((char*)&msg->su, sizeof(msg->su));
return true;
}

int Mark5B_Connection::write_msg(const struct Dismount_Tape& msg) {
write_value((char*)&msg.su, sizeof(msg.su));
return sizeof(msg.su);
}

bool Mark5B_Connection::receive_msg(int* client_socket, struct Stream_Control* msg) {
const int message_size = sizeof(msg->stream_num) + sizeof(msg->request) + sizeof(msg->tsf_lineno) + sizeof(msg->stream_filename);
if (!(read_chunk(client_socket,message_size) == message_size)) return false;
read_value((char*)&msg->stream_num, sizeof(msg->stream_num));
read_value((char*)&msg->request, sizeof(msg->request));
read_value((char*)&msg->tsf_lineno, sizeof(msg->tsf_lineno));
for (int dim0 = 0; dim0 < sizeof(msg->stream_filename)/sizeof(msg->stream_filename[0]); dim0++) {
read_value((char*)&msg->stream_filename[dim0], sizeof(msg->stream_filename[0]));
}
return true;
}

int Mark5B_Connection::write_msg(const struct Stream_Control& msg) {
write_value((char*)&msg.stream_num, sizeof(msg.stream_num));
write_value((char*)&msg.request, sizeof(msg.request));
write_value((char*)&msg.tsf_lineno, sizeof(msg.tsf_lineno));
for (int dim0 = 0; dim0 < sizeof(msg.stream_filename)/sizeof(msg.stream_filename[0]); dim0++) {
write_value((char*)&msg.stream_filename[dim0], sizeof(msg.stream_filename[0]));
}
return sizeof(msg.stream_num) + sizeof(msg.request) + sizeof(msg.tsf_lineno) + sizeof(msg.stream_filename);
}

bool Mark5B_Connection::receive_msg(int* client_socket, struct Reorder_Streams* msg) {
const int message_size = sizeof(msg->stream_order);
if (!(read_chunk(client_socket,message_size) == message_size)) return false;
for (int dim0 = 0; dim0 < sizeof(msg->stream_order)/sizeof(msg->stream_order[0]); dim0++) {
read_value((char*)&msg->stream_order[dim0], sizeof(msg->stream_order[0]));
}
return true;
}

int Mark5B_Connection::write_msg(const struct Reorder_Streams& msg) {
for (int dim0 = 0; dim0 < sizeof(msg.stream_order)/sizeof(msg.stream_order[0]); dim0++) {
write_value((char*)&msg.stream_order[dim0], sizeof(msg.stream_order[0]));
}
return sizeof(msg.stream_order);
}

bool Mark5B_Connection::receive_msg(int* client_socket, struct Send_Tape_Status* msg) {
const int message_size = sizeof(msg->interval) + sizeof(msg->watch_su) + sizeof(msg->num_addr) + sizeof(msg->watch_list);
if (!(read_chunk(client_socket,message_size) == message_size)) return false;
read_value((char*)&msg->interval, sizeof(msg->interval));
for (int dim0 = 0; dim0 < sizeof(msg->watch_su)/sizeof(msg->watch_su[0]); dim0++) {
read_value((char*)&msg->watch_su[dim0], sizeof(msg->watch_su[0]));
}
read_value((char*)&msg->num_addr, sizeof(msg->num_addr));
for (int dim0 = 0; dim0 < sizeof(msg->watch_list)/sizeof(msg->watch_list[0]); dim0++) {
read_value((char*)&msg->watch_list[dim0], sizeof(msg->watch_list[0]));
}
return true;
}

int Mark5B_Connection::write_msg(const struct Send_Tape_Status& msg) {
write_value((char*)&msg.interval, sizeof(msg.interval));
for (int dim0 = 0; dim0 < sizeof(msg.watch_su)/sizeof(msg.watch_su[0]); dim0++) {
write_value((char*)&msg.watch_su[dim0], sizeof(msg.watch_su[0]));
}
write_value((char*)&msg.num_addr, sizeof(msg.num_addr));
for (int dim0 = 0; dim0 < sizeof(msg.watch_list)/sizeof(msg.watch_list[0]); dim0++) {
write_value((char*)&msg.watch_list[dim0], sizeof(msg.watch_list[0]));
}
return sizeof(msg.interval) + sizeof(msg.watch_su) + sizeof(msg.num_addr) + sizeof(msg.watch_list);
}

bool Mark5B_Connection::receive_msg(int* client_socket, struct Tape_Status* msg) {
const int message_size = sizeof(msg->watch_su) + sizeof(msg->num_addr) + sizeof(msg->watch_list) + sizeof(msg->state);
if (!(read_chunk(client_socket,message_size) == message_size)) return false;
for (int dim0 = 0; dim0 < sizeof(msg->watch_su)/sizeof(msg->watch_su[0]); dim0++) {
read_value((char*)&msg->watch_su[dim0], sizeof(msg->watch_su[0]));
}
read_value((char*)&msg->num_addr, sizeof(msg->num_addr));
for (int dim0 = 0; dim0 < sizeof(msg->watch_list)/sizeof(msg->watch_list[0]); dim0++) {
read_value((char*)&msg->watch_list[dim0], sizeof(msg->watch_list[0]));
}
for (int dim0 = 0; dim0 < sizeof(msg->state)/sizeof(msg->state[0]); dim0++) {
for (int dim1 = 0; dim1 < sizeof(msg->state[0])/sizeof(msg->state[0][0]); dim1++) {
read_value((char*)&msg->state[dim0][dim1], sizeof(msg->state[0][0]));
}
}
return true;
}

int Mark5B_Connection::write_msg(const struct Tape_Status& msg) {
for (int dim0 = 0; dim0 < sizeof(msg.watch_su)/sizeof(msg.watch_su[0]); dim0++) {
write_value((char*)&msg.watch_su[dim0], sizeof(msg.watch_su[0]));
}
write_value((char*)&msg.num_addr, sizeof(msg.num_addr));
for (int dim0 = 0; dim0 < sizeof(msg.watch_list)/sizeof(msg.watch_list[0]); dim0++) {
write_value((char*)&msg.watch_list[dim0], sizeof(msg.watch_list[0]));
}
for (int dim0 = 0; dim0 < sizeof(msg.state)/sizeof(msg.state[0]); dim0++) {
for (int dim1 = 0; dim1 < sizeof(msg.state[0])/sizeof(msg.state[0][0]); dim1++) {
write_value((char*)&msg.state[dim0][dim1], sizeof(msg.state[0][0]));
}
}
return sizeof(msg.watch_su) + sizeof(msg.num_addr) + sizeof(msg.watch_list) + sizeof(msg.state);
}

bool Mark5B_Connection::receive_msg(int* client_socket, struct Dpu_Command* msg) {
const int message_size = sizeof(msg->rw) + sizeof(msg->su) + sizeof(msg->address) + sizeof(msg->value);
if (!(read_chunk(client_socket,message_size) == message_size)) return false;
read_value((char*)&msg->rw, sizeof(msg->rw));
read_value((char*)&msg->su, sizeof(msg->su));
read_value((char*)&msg->address, sizeof(msg->address));
read_value((char*)&msg->value, sizeof(msg->value));
return true;
}

int Mark5B_Connection::write_msg(const struct Dpu_Command& msg) {
write_value((char*)&msg.rw, sizeof(msg.rw));
write_value((char*)&msg.su, sizeof(msg.su));
write_value((char*)&msg.address, sizeof(msg.address));
write_value((char*)&msg.value, sizeof(msg.value));
return sizeof(msg.rw) + sizeof(msg.su) + sizeof(msg.address) + sizeof(msg.value);
}

bool Mark5B_Connection::receive_msg(int* client_socket, struct Ascii_Message* msg) {
const int message_size = sizeof(msg->text);
if (!(read_chunk(client_socket,message_size) == message_size)) return false;
for (int dim0 = 0; dim0 < sizeof(msg->text)/sizeof(msg->text[0]); dim0++) {
read_value((char*)&msg->text[dim0], sizeof(msg->text[0]));
}
return true;
}

int Mark5B_Connection::write_msg(const struct Ascii_Message& msg) {
for (int dim0 = 0; dim0 < sizeof(msg.text)/sizeof(msg.text[0]); dim0++) {
write_value((char*)&msg.text[dim0], sizeof(msg.text[0]));
}
return sizeof(msg.text);
}

bool Mark5B_Connection::receive_msg(int* client_socket, struct Terminate_Self* msg) {
const int message_size = sizeof(msg->flags);
if (!(read_chunk(client_socket,message_size) == message_size)) return false;
read_value((char*)&msg->flags, sizeof(msg->flags));
return true;
}

int Mark5B_Connection::write_msg(const struct Terminate_Self& msg) {
write_value((char*)&msg.flags, sizeof(msg.flags));
return sizeof(msg.flags);
}

bool Mark5B_Connection::receive_msg(int* client_socket, struct Program_Control* msg) {
const int message_size = sizeof(msg->msg_level) + sizeof(msg->prog_flags);
if (!(read_chunk(client_socket,message_size) == message_size)) return false;
read_value((char*)&msg->msg_level, sizeof(msg->msg_level));
read_value((char*)&msg->prog_flags, sizeof(msg->prog_flags));
return true;
}

int Mark5B_Connection::write_msg(const struct Program_Control& msg) {
write_value((char*)&msg.msg_level, sizeof(msg.msg_level));
write_value((char*)&msg.prog_flags, sizeof(msg.prog_flags));
return sizeof(msg.msg_level) + sizeof(msg.prog_flags);
}

bool Mark5B_Connection::receive_msg(int* client_socket, struct Error_Message* msg) {
const int message_size = sizeof(msg->errnum) + sizeof(msg->text);
if (!(read_chunk(client_socket,message_size) == message_size)) return false;
read_value((char*)&msg->errnum, sizeof(msg->errnum));
for (int dim0 = 0; dim0 < sizeof(msg->text)/sizeof(msg->text[0]); dim0++) {
read_value((char*)&msg->text[dim0], sizeof(msg->text[0]));
}
return true;
}

int Mark5B_Connection::write_msg(const struct Error_Message& msg) {
write_value((char*)&msg.errnum, sizeof(msg.errnum));
for (int dim0 = 0; dim0 < sizeof(msg.text)/sizeof(msg.text[0]); dim0++) {
write_value((char*)&msg.text[dim0], sizeof(msg.text[0]));
}
return sizeof(msg.errnum) + sizeof(msg.text);
}

