
//init_proc.C

//SU_CONTROL application - Initialisation & Processing

//JIVE, May 1996

//_________________________________________________________________________

#include <sstream>

using namespace std;

//define macro to delete and ground cmd and tables - final ; excluded from macro
#define DELETE_ALL delete aux_table; aux_table = 0; delete table1; table1 = 0; delete table2; \
   table2 = 0; delete table3; table3 = 0; delete table4; table4 = 0; delete table5; table5 = 0; \
   delete table6; table6 = 0; delete gen_tab1; gen_tab1 = 0; delete gen_tab2; gen_tab2 = 0; \
   delete gen_tab3; gen_tab3 = 0; delete gen_tab4; gen_tab4 = 0; delete gen_tab5; gen_tab5 = 0; \
   delete gen_tab6; gen_tab6 = 0; delete cmd; cmd = 0

#define DELETE_CMD delete cmd; cmd = 0; aux_table = 0; table1 = 0; table2 = 0; table3 = 0; table4 = 0; \
   table5 = 0; table6 = 0; gen_tab1 = 0; gen_tab2 = 0; gen_tab3 = 0; gen_tab4 = 0; gen_tab5 = 0; gen_tab5 = 0


#include <su_control/init_proc.h>
#include <jccs_util/nint.h>
//
//  Need this for the time_value stuff (Short/Long_Time_Value)
//
#include <message_base/time_value.h>
#include <hw_sw_setup_db/su_params.h>
#include <hw_sw_setup_db/evlbi_params.h>
#include <data_handler/PhaseCalDescRecord.h>

extern bool ignore_next_servo_error; // defined in init_proc_p.C, needed here after a record/play switch

Init_Proc::Init_Proc(Thread_ID my_id, Thread_ID parent, Thread_Master *owner, unsigned int suid_code,
		     bool disk, bool evilBI, SU_Command_Channel *comm1, SU_Connection *comm3)
  :Thread(my_id, parent, owner), 
   timer(&signal_flag), 
   peaking_thread(0),
#ifdef USE_MYSQL
   mystore(Database_Access::mySQL),
#endif
#ifdef USE_MSQL1
   mystore(Database_Access::mSQL1),
#endif
   poly_lib(mystore),
   hw_sw_setup_lib(mystore),
   dsm_service(*location_if.get_service_id(DH_DSM), *owner, false)
{
  //initialise lib
  poly_lib.initialise();
  hw_sw_setup_lib.initialise();  
  outFilename = new char[100];
  peakFilename = new char[100];
  //headerFilename = new char[25];
  pcalFile = 0;
  
  the_suid_code = suid_code;
  use_mark5 = disk;
  eVLBI = evilBI;

  id_of_job = 0;//obtained from Enquire_SU_Control
  abort_id = 0;
  timer_key = timer.register_for_timer();
  key_stop_su_control = signal_flag.register_for_signal(SIGINT);
  dpu_type = DPUType;//frpm db?
  dpu_accel = DPU_ACCELLERATION;//frpm db?
  fs = 0;//initialisation
  muxmode = 1;
  speedup = 1;
  oversampling_factor = 1;
  bandwidth = 0;
  bpi = 0;
  num_bits = 1;
  the_nominal_tape_speed = 0;
  the_model_parameters = 0;
  the_sidebands = 0;  
  
  
  su_cmd = comm1;//SU_Command channel
  su_conn = comm3;//connection to station unit
  
  initialised = false;//is SU_Control in RUN state?
  allocated = false;
  clk_msgs_disabled = false;
  suim_confgd = false;
  op_code = 0;
  


  //these need protected somehow!!!
  response_iter = new Forward_List_Iter<Incoming_Message_Info *>(&response_queue);//iterator for response queue
  
  sub_job_start_ROT = 0;
  sub_job_ending_ROT = 0;
  begin_ROT = 0;
  end_ROT = 0;
  poly_offset = 0;
  last_received_rot = -1;
  poly_obey_ROT = 0;
  current_station = 0;
  su_configuration = 0;
  su_status = 0;
  cjd = 0;
  current_jd = 0;
  load_polys_aux = 0;
  num_head_stacks = 0;
  
  reset_peripherals_required = true;
  next_SU_command_time = 0; // used in transmit SU to ensure communication is delayed 15 secs after reset
  
  // External overrides
  external_dim_xbar = false;
  external_trm_active = false;
  external_suim_pg = false;
  external_crm_shuffle = false;
  force_bits = -1;
  //header_multiplier = 1;
  
  // Not needed here
  //// Feature bit values
  //corr_head = -1;  // Which head are we actually correlating
  
  int i, j, k ;//counters
  
  //initialisation
  for(i = 0; i<NUM_TRACKS; ++i)
    {
      dim_x_bar_configuration[i] = 80;
      the_active_tracks[i] = -1;
      for(j = 0; j<NUM_CHANNELS; ++j)
	{
	  output_mapping[j] = j;
	  the_frames_per_barrel_roll_ph[j] = 14;
	  the_aux_data[j][i][0] = 0;
	  the_aux_data[j][i][1] = 0;
	  the_cross_bar_config[j][i] = -1;
	}
    }
  
  for(i = 0;  i < NUM_CHANNELS; ++i)
    {
      for(j = 0; j < 73; ++j)
	{
	  for(k = 0; k < 2; ++k)
	    {
	      log_chan_track_link[i][j][k] = unknown;
	    }
	}
    }
  
  the_mask[0] = 0;
  the_mask[1] = 0;
  
  head_0_fwd_offset = 0;
  head_0_rev_offset = 0;
  head_1_fwd_offset = 0;
  head_1_rev_offset = 0;
  cout << "***Peak Head command info: head_offset = 0 (constructor)." << endl;
  
  
  if (use_mark5)
    {
      get_du_parameters(mystore,disk_unit,eVLBI,the_suid_code);

    }

  recording = false;
}



Init_Proc::~Init_Proc()
{
  this->clear_queues();
  delete cmd_iter;
  cmd_iter = 0;
  delete response_iter;
  response_iter = 0;
  delete su_configuration;
  su_configuration = 0;
  delete su_status;
  su_status = 0;
  delete current_jd; 
  current_jd = 0;
  //delete [] headerFilename;
  delete [] outFilename;
  outFilename = 0;
  delete [] peakFilename;
  peakFilename = 0;
  delete pcalFile;
  pcalFile = 0;
  signal_flag.deregister_from_signal(SIGINT,key_stop_su_control);
  mystore.shutdown_library(&poly_lib);
  mystore.shutdown_library(&hw_sw_setup_lib);
  dsm_service.close_connections();
}



int Init_Proc::shutdown()
{
  return 0;
}

int Init_Proc::quit()
{
#ifdef DEBUG 
  Counted count;
  cout << "SU_Control# " << the_suid_code << " The net number of CCC_Msgs created = " 
       << count.count_is_now() - 1 << endl;
#endif
  
  this->set_stat(Thread::terminating);
  return 0;
}

bool Init_Proc::queue_response(Incoming_Message_Info* info)
{
  if(response_queue.append(info) != -1) return true;
  else return false;
}

int Init_Proc::pre_state()
{
  assert(use_mark5);
  Action_Status *msg = 0; //outbound
      
  ieee_dbl the_standard_time_out = 10.0;//seconds - reset to zero upon sending a cmd to SU
      
  if ((signal_flag.signal_occurred(SIGINT, key_stop_su_control)))
    {
#ifdef DEBUG 
      cout << "Received ^C. Exiting Process" <<endl;
#endif
	  
      su_status->set_medium_mounted_status(DISMOUNTED);
      allocated = false;
      this->transmit_disk_status();
      su_conn->get_connection(S_U)->close_connection();
      delete (su_conn->get_connection(S_U));//dangerous?
      this->exit_process(SU_Control_Error_Codes::Abort_Command_Exception);
      return 0;
    }
      
  switch (current_state)
    {
    case (wait_for_SU1) :
    case (wait_for_SU2) :
    case (wait_for_SU3) :
    case (wait_for_SU4) :
      if(this->check_timeout(the_standard_time_out))
	{
#ifdef DEBUG 
	  cout << "Timeout. Exiting Process" <<endl;
#endif
	  this->exit_process(SU_Control_Error_Codes::Timeout_Exception, CCC_Action_Request::Init_SU_Control);
	  break;
	}
      break;
    case (idle) :
    case (idle_2) :
    case (idle_3) :
    case (mounted) :
      //check for disconnect command
      if(this->in_cmd_queue(CCC_Action_Request::Disconn_SU_Control))
	{
#ifdef DEBUG 
	  cout << "Received Disconnect cmd. Exiting Process" <<endl;
#endif
	  allocated = false;
	  this->transmit_disk_status();
	  su_conn->get_connection(S_U)->close_connection();
	  delete (su_conn->get_connection(S_U));//dangerous?
	  su_cmd->quit();
	  su_conn->quit();
	  this->quit();
	  get_controller()->shutdown();
	  break;
	}

      check_end_subjob_message();

	  
      // no break: check for abort
    default :
      //check for abort command
      if(this->in_cmd_queue(CCC_Action_Request::Abort) && (peaking_thread == 0))
	{
	  //ie respond to abort cmd only if peaking thread(s) are not running
#ifdef DEBUG 
	  cout << "(Init_Proc::pre_state) Received Abort Cmd" <<endl;
#endif
	  abort_id = (unsigned int)((CCC_Msg *)cmd_iter->contents()->get_msg())->get_msg_id();
	  this->do_abort();
	  current_state = wait_for_abort;
	  break;
	}
      break;
    }//end switch

  while (this->in_cmd_queue(CCC_Action_Request::Poly_Offset)) {
    Command_Message* msg = (Command_Message*)cmd_queue.remove(cmd_iter)->get_msg();
    poly_offset = ((Poly_Offset_Table*)(((General_CCC_Table&)(msg->get_table(SU_Table_Types::Poly_Offset))).get_table_data()))->get_offset();
    cout << "!!!Warning!!! poly offset set to " << poly_offset << endl;
    delete msg;

    if(current_state == running && last_received_rot > 0 && (msg = form_command(SU_Station_Unit_Cmds::Load_Polynomials))) {
      send_load_poly_cmd(msg, last_received_rot, false);
      delete msg;
    }			     
  }

  while(this->in_cmd_queue(CCC_Action_Request::Poly_Pid))
    {
      cout << "new poly pid received" << endl;
      Command_Message* cmd = (Command_Message*)cmd_queue.remove(cmd_iter)->get_msg();
      Poly_Pid_Table* poly_pid_table = ((Poly_Pid_Table*)(((General_CCC_Table&)(cmd->get_table(SU_Table_Types::Poly_Pid))).get_table_data()));
      cout << "replacing polys for " << current_station->get_station_ID() << endl;
      current_station->set_persistent_polys_id(poly_pid_table->get_poly_pid());
      cout << "loading new polys" << endl;
      get_polys();
      Command_Message* msg = form_command(SU_Station_Unit_Cmds::Load_Polynomials);
      send_load_poly_cmd(msg, last_received_rot); // FIX last_received => some time decided by PJ
      delete msg;
      delete cmd;
    }
	
  // debug: process check rot message and print header times
  while(this->action_req_in_cmd_queue(SU_Action_Values::Check_ROT)) {
    //fetch message
    Check_ROT_Clock_Message *acm = (Check_ROT_Clock_Message *) cmd_queue.remove(cmd_iter)->get_msg();
    //iterate through its entries
    Clock_Message_Entry *entry = acm->first_entry();
    for (int i = 0; i < acm->how_many(); i++) {
      time_t now = time(0);
      cout << "Got check rot message for job " << entry->get_SU_array_code() << ": " << entry->get_ROT().get_rot_string() << " at " << ctime(&now);
      if (cjd && cjd->get_CJD_ID() == entry->get_SU_array_code()) {
	last_received_rot = entry->get_ROT().get_sysclks();
      }
      entry = acm->next_entry(entry);
    }
    delete acm;	
  }

#if 0 // appears to sometimes crash su control when doing VLBA or mk5b, so commented for now
  if (current_state >= mounted) {
    static int counter = 0;
    static time_t previous_req = 0;
    unsigned int msg_id;
    time_t now = time(0);
    if ((now - previous_req) >= 10) {
      previous_req = now;
      counter = 0;
	  
      /* sending a request for all frame headers
	 for (int i = 0; i < 8; i++) {
	 send_req_tpe_frm_hdr(i*4,counter,msg_id);
	 }
      //*/
	  
      /* sending a request for a whole frame
	 Command_Message* cmd = form_command(SU_Station_Unit_Cmds::Req_Medium_Frame);
	 Req_Medium_Frame_Table table(0,last_rot);
	 General_CCC_Table gen_table(SU_Table_Types::Medium_Frame_Hd_Req, &table, 0);
	 cmd->add_table(&gen_table);
	 transmit_to_SU(cmd);
	 delete cmd;
      //*/

      // sending a request for any frame header
      Command_Message *cmd = this->form_command(SU_Station_Unit_Cmds::Req_Medium_Frme_Hdr);
      Req_Medium_Frame_Header_Table table1(0xffffffff);
      General_CCC_Table gen_tab1(SU_Table_Types::Medium_Frame_Hd_Req, &table1, 0);
      cmd->add_table(&gen_tab1);
      if(this->transmit_to_SU(cmd)) {
	++counter;
      }
      delete cmd;
      //

    }
    /*
      else {
      cout << "Not sending tape requests " << counter << " " << (now - previous_req) << endl;
      }
    */
    while(in_response_queue(SU_Action_Status::Medium_Frame_Hdr_Data)) {
      counter--;
      Medium_Frame_Header_Data* header = (Medium_Frame_Header_Data*)response_iter->contents()->get_msg();
      int_16 header_data[20];
      if (header->get_medium_frame_header(header_data)) {
	if(the_tape_format == MkIIIA || the_tape_format == MkIV) {
	  //the time code is in bcd code - see Mk IV Memo 230
	  int day = (header_data[4]&0xf) * 100 + ((header_data[5]>>4)&0xf) * 10 + (header_data[5]&0xf);
	  int hours = ((header_data[6]>>4)&0xf) * 10 + (header_data[6]&0xf);
	  int mins = ((header_data[7]>>4)&0xf) * 10 + (header_data[7]&0xf);
	  int secs = ((header_data[8]>>4)&0xf) * 10 + (header_data[8]&0xf);
	  time_t now = time(0);
	  cout << "Day " << day << ", hour " << hours << ", min " << mins << ", sec " << secs << " time: " << ctime(&now);
	  cout << "track_nr " << header->get_track_number();
	  for (int i = 0; i < 20; i++) {
	    cout << " " << hex << ((header_data[i] >> 4) &0xf) << (header_data[i] & 0xf);
	  }
	  cout << dec << endl;
	}
	else if (the_tape_format == VLB) {
	  unsigned long mjdd;	   /* Modified Julian date in days */
	  //first get base date
	  int year;
	  if (cjd) {
	    year = (int) cjd->get_obs_TOT_start().get_base_date();
	  }
	  else { // guess year is this year
	    time_t now = time(0);
	    struct tm* time = gmtime(&now);
	    year = time->tm_year + 1900;
	  }
	  int month = 1;//January
	  int day = 1;
	      
	  mjdd = (((1461 * (year - (12 - month) / 10 + 4712)) / 4
		   + (306 * ((month + 9) % 12) + 5) / 10
		   - (3 * ((year - (12 - month)/10 + 4900) / 100)) / 4
		   + day - 2399904));
	  //should return the mjd (in days) at 00.00 on 1/1/year - now get 3 least significant digits
	  mjdd = mjdd % 1000;
	      
	  //get MJD (days) from header_data - least significant 3 digits anyway!
	  day = ((header_data[4]>>4)&0xf) * 100 + (header_data[4]&0xf) * 10 + ((header_data[5]>>4)&0xf);
	      
	  //get elapsed days from mjdd
	  if(mjdd > day) { //ie if mjdd + days to date > 1000
	    day = day + 1000 - mjdd;
	  }
	  else {
	    day = day - mjdd;
	  }
	      
	  //now get seconds into day
	  int secs = (header_data[5]&0xf) * 10000 + ((header_data[6]>>4)&0xf) * 1000 + (header_data[6]&0xf) * 100 + ((header_data[7]>>4)&0xf) * 10 + (header_data[7]&0xf); 
	      
	  int systicks = (int)SYSTEM_RATE * ((day * 86400) + secs);
	  time_t now = time(0);
	  cout << "Day " << day + 1 << ", sec " << secs << "  (" <<  Short_Time_Value(systicks).get_rot_string() << ") time: " << ctime(&now);
	}
	else {
	  cout << "Unrecognized tape format " << the_tape_format << endl;
	}
      }
      delete response_iter->contents()->get_msg();
      delete response_queue.remove(response_iter);
    }
    while(in_response_queue(SU_Action_Status::Medium_Frame_Data)) {
      cout << "Received the whole frame, just don't know in what" << endl;
      delete response_iter->contents()->get_msg();
      delete response_queue.remove(response_iter);
    }
  }
  // END debug printf header time
#endif

  return 0;
      
}


int Init_Proc::do_state()
{
  int prev_state = current_state;
  static int the_tape_ftg_time_out = 600;//seconds
  static int lock_resyncs = 0;
  static int nr_tracks = 0; //number of active tracks (actually channels)
  static int recvd_cjd_count = 0;//initialisation - the number of cjd's received
  static int recvd_set_rot_cmds = 0;
  static ieee_dbl start_TOT;//start of a job
  static int start_footage;//required in wait_for_ROT
  static Short_Time_Value attained_TOT;//from position_to_TOT response
  static bool head_0 = false, head_1 = false; // heads set true if in use


  assert(use_mark5);

  string experName;
      
  Command_Message *cmd = 0;//outbound
  Action_Status *msg = 0; //outbound
      
  Table_Data *table1 = 0, *table2 = 0, *table3 = 0, *table4 = 0, *table5 = 0, *table6 = 0;
      
  Aux_Data *aux_table = 0;
      
  General_CCC_Table *gen_tab1 = 0, *gen_tab2 = 0, *gen_tab3 = 0, *gen_tab4 = 0, *gen_tab5 = 0, *gen_tab6 = 0;
      
  int the_tape_TOT_time_out = 600;//seconds
  int the_pos_heads_timeout = 600;//seconds
  ieee_dbl the_standard_time_out = 120.0;//seconds - reset to zero upon sending a cmd to SU
      
  //big switch statement depending on current_state
      
  switch (current_state)
    {
    case (wait_for_SU1) :
      {
	//temporary :
	if((cmd = this->form_command(SU_Station_Unit_Cmds::Set_SU_Id)) && 
	   (table1 = new Set_SU_ID_Table(the_suid_code)) &&
	   (gen_tab1 = new General_CCC_Table(SU_Table_Types::SU_Id_Code, table1, 0)) &&
	   cmd->add_table(gen_tab1)
	   )
	  {
	    cout << "su_conn initialiseed ok - in init_proc" << endl;
	    if(this->transmit_to_SU(cmd))
	      {
		DELETE_CMD;
		current_state = wait_for_SU2;
#ifdef DEBUG 
		cout << "Sent Set SUID cmd. Entering wait_for_SU2" <<endl;
#endif
		break;
	      }
	    else
	      {
		DELETE_CMD;
		this->exit_process(SU_Control_Error_Codes::SU_Connection_Exception, 
				   CCC_Action_Request::Init_SU_Control);
	      }
	  }
	else
	  {
	    DELETE_ALL;
	    this->exit_process(SU_Control_Error_Codes::Memory_Allocation_Exception, 
			       CCC_Action_Request::Init_SU_Control);
	  }
	    
	break;
      }
    case (wait_for_SU2) :
      {
	//response to set SUID
	cout << "into wait_for_SU2" << endl;
	    
	if(this->in_response_queue(SU_Action_Status::Set_SU_Id_Status))
	  {
	    cout << "Set_SU_Id_Status in response queue" << endl;

	    //check suid is correct
	    if(((SU_ID_Set *) response_iter->contents()->get_msg())->get_suid() == the_suid_code)
	      {
		cout << "response_iter->contents()->get_msg())->get_suid() == the_suid_code" <<endl;
		//form request su config cmd and transmit to SU
		if(cmd = this->form_command(SU_Station_Unit_Cmds::Req_SU_Config))
		  {
		    if(this->transmit_to_SU(cmd))
		      {
			DELETE_CMD;
			current_state = wait_for_SU3;
#ifdef DEBUG 
			cout << "Sent Req_SU_Config cmd. Entering wait_for_SU3" <<endl;
#endif
			break;
		      }
		    else
		      {
			DELETE_CMD;
			this->exit_process(SU_Control_Error_Codes::SU_Connection_Exception, 
					   CCC_Action_Request::Init_SU_Control);
		      }
		  }
		else 
		  {
		    DELETE_ALL;
		    this->exit_process(SU_Control_Error_Codes::Memory_Allocation_Exception, 
				       CCC_Action_Request::Init_SU_Control);
		  }	       
		    
	      }
	    else
	      {
		//try again?
		static int counter = 0;
		if(counter == 1)
		  {
		    //only one re_attempt allowed!
		    this->exit_process(SU_Control_Error_Codes::Unspecified_Error,
				       CCC_Action_Request::Init_SU_Control);
		  }
		    
		if((cmd = this->form_command(SU_Station_Unit_Cmds::Set_SU_Id)) && 
		   (table1 = new Set_SU_ID_Table(the_suid_code)) &&
		   (gen_tab1 = new General_CCC_Table(SU_Table_Types::SU_Id_Code, table1, 0)) &&
		   cmd->add_table(gen_tab1)
		   )
		  {
		    if(this->transmit_to_SU(cmd))
		      {
			DELETE_CMD;
			current_state = wait_for_SU2;
			break;
		      }
		    else
		      {
			DELETE_CMD;
			this->exit_process(SU_Control_Error_Codes::SU_Connection_Exception, 
					   CCC_Action_Request::Init_SU_Control);
		      }
		  }
		else
		  {  
		    DELETE_ALL;
		    this->exit_process(SU_Control_Error_Codes::Memory_Allocation_Exception, 
				       CCC_Action_Request::Init_SU_Control);
		  }
		++counter;
	      }
	  }
	break;
      }
    case (wait_for_SU3) :
      {
	//check response to su config command
	    
	if(this->in_response_queue(SU_Action_Status::SU_Config))
	  {
	    //store su configuration - the iterator must be pointing to it.
	    if(su_configuration != 0) delete su_configuration;
	    su_configuration = (SU_Configuration *)response_iter->contents()->get_msg();
	    delete response_queue.remove(response_iter);//msg is not deleted!
		
	    char* logFilename = new char[100]; 
	    // Save some status info to a log file
	    sprintf(logFilename, "%s/su_config-%d.log", LOGDIR, su_configuration->get_suid());
		
	    logFile.open(logFilename, ios::app);
	    if (logFile) 
	      {
		this->set_local_time();
		logFile << "SU_Control Started " << local_time.get_rot_string() << endl;
		logFile << hex << "SUCC software 0x" << su_configuration->get_su_ccc_software() << endl;
		logFile << "DIM 0/1 id:     0x" <<  su_configuration->get_DIM_0_id()
			<< " 0x" <<  su_configuration->get_DIM_1_id() << endl;
		logFile  << "TRM software:   0x" << su_configuration->get_TRM_0_software() << " 0x" 
			 << su_configuration->get_TRM_1_software() << " 0x" 
			 << su_configuration->get_TRM_2_software() << " 0x" 
			 << su_configuration->get_TRM_3_software() << " 0x" 
			 << su_configuration->get_TRM_4_software() << " 0x" 
			 << su_configuration->get_TRM_5_software() << " 0x" 
			 << su_configuration->get_TRM_6_software() << " 0x" 
			 << su_configuration->get_TRM_7_software() << endl;
		logFile  << "TRM ID:         0x" << su_configuration->get_TRM_0_id() << " 0x" 
			 << su_configuration->get_TRM_1_id() << " 0x" 
			 << su_configuration->get_TRM_2_id() << " 0x" 
			 << su_configuration->get_TRM_3_id() << " 0x" 
			 << su_configuration->get_TRM_4_id() << " 0x" 
			 << su_configuration->get_TRM_5_id() << " 0x" 
			 << su_configuration->get_TRM_6_id() << " 0x" 
			 << su_configuration->get_TRM_7_id() << endl;
		logFile << "PCM sofware/id  0x" <<  su_configuration->get_PCM_software()
			<< " 0x" <<  su_configuration->get_PCM_id() << endl;
		logFile << "CRM sofware/id  0x" <<  su_configuration->get_CRM_software()
			<< " 0x" <<  su_configuration->get_CRM_id() << endl;
		logFile << "DCM sofware/id  0x" <<  su_configuration->get_DCM_software()
			<< " 0x" <<  su_configuration->get_DCM_id() << endl;
		logFile << "DMM 0/2 id:     0x" <<  su_configuration->get_DMM_0_id()
			<< " 0x" <<  su_configuration->get_DMM_1_id() << endl;
		logFile << "DPU software    0x" << su_configuration->get_DPU_id() << endl;
		logFile.close();
	      } 
	    else 
	      {
		cerr << "Failed to open config log file " << logFilename << endl;
	      }
	    delete [] logFilename;
	    logFilename = 0;
		
	    //form request su status cmd and transmit to SU
		
	    if(cmd = this->form_command(SU_Station_Unit_Cmds::Req_SU_Status))
	      {
		if(this->transmit_to_SU(cmd))
		  {
		    DELETE_CMD;
		    current_state = wait_for_SU4;
#ifdef DEBUG 
		    cout << "Sent Req_SU_Status cmd. Entering wait_for_SU4" <<endl;
#endif
		    break;
		  }
		else
		  {
		    DELETE_CMD;
		    this->exit_process(SU_Control_Error_Codes::SU_Connection_Exception,
				       CCC_Action_Request::Init_SU_Control);
		  }
	      }
	    else 
	      {
		DELETE_ALL;
		this->exit_process(SU_Control_Error_Codes::Memory_Allocation_Exception,
				   CCC_Action_Request::Init_SU_Control);
	      }
	  }
	break;
      }
	  
    case (wait_for_SU4) :
      {
	//check for response to su status command
	    
	if(this->in_response_queue(SU_Action_Status::SU_Status))
	  {
	    //store su status - the iterator must be pointing to it.
	    if(su_status != 0) delete su_status;
	    su_status = (SU_Status *)response_iter->contents()->get_msg();
	    delete response_queue.remove(response_iter);//msg is not deleted
		
	    //set initialised to true
	    initialised = true;

	    //make sure the disk unit is not playing
	    if(disk_unit.query_play_on()) disk_unit.stop_play();
	    if (eVLBI)
	      {
		if(disk_unit.query_e_station_play_on()) disk_unit.stop_e_station_play();
		if(disk_unit.query_in2net_on()) disk_unit.in2net("off");
		closeEVLBIout(true);
		disk_unit.in2net("disconnect");
	      }
		
	    if(!eVLBI)
	      {
		if(disk_unit.query_du_ready() && disk_unit.query_VSN())
		  {
		    su_status->set_medium_mounted_status(MOUNTED);
		  }
	      }
	    else
	      {
		if(!disk_unit.query_du_ready_4evil()) 
		  {
		    cout << "SU_control:: wait_for_SU4: query_du_ready_4evil() nicht gut" << endl;
		    su_status->set_medium_mounted_status(DISMOUNTED);
		  }
		else 
		  {
		    su_status->set_medium_mounted_status(MOUNTED);
		    cout << "SU_control:: wait_for_SU4: eVLBI bar code = " << disk_unit.du_status.get_VSN_active() << endl;
		  }
	      }
		
	    //do the Set_Feature_Set cmd
		
	    unsigned int feature_2 = 0;
	    feature_2 |= Feature_Set_2_Bit::Continuous_BOCF;
	    feature_2 |= Feature_Set_2_Bit::Enable_Tape_Servo_Range_Check;
	    feature_2 |= Feature_Set_2_Bit::Enable_Tape_Servo_Range_Load;
	    feature_2 |= Feature_Set_2_Bit::Enable_ROT_TOT_Offset;
	    feature_2 |= Feature_Set_2_Bit::CCC_Tape_Servo_Control;
	    feature_2 |= Feature_Set_2_Bit::Enable_Auto_CRM_Stop;
		
	    // Some possible debuging
	    if (getenv("ENABLE_TIME_TAG_PRINT")) 
	      feature_2 |= Feature_Set_2_Bit::Enable_Time_Tag_Print;
	    if (getenv("ENABLE_CRM_SERVO")) 
	      feature_2 |= Feature_Set_2_Bit::Enable_CRM_Servo;
		
	    unsigned int feature_3 = 0;
		
	    if (getenv("ENABLE_SOT_SNAP_PRINTS")) 
	      feature_3 |= Feature_Set_3_Bit::Enable_SOT_Snap_Prints;
	    if (getenv("ENABLE_SU_FINISH_DIAGNOSTICS")) 
	      feature_3 |= Feature_Set_3_Bit::Enable_SU_Finish_Diags;
	    if (getenv("ENABLE_BIG_BUFFER_DIAGNOSTICS")) 
	      feature_3 |= Feature_Set_3_Bit::Enable_Big_Buffer_Diags;
	    if (getenv("ENABLE_SMALL_BUFFER_DIAGNOSTICS")) 
	      feature_3 |= Feature_Set_3_Bit::Enable_Small_Buffer_Diags;
	    if (getenv("ENABLE_TASK_SPECIFIC_BUFFER_DIAGNOSTICS")) 
	      feature_3 |= Feature_Set_3_Bit::Enable_Task_Specific_Buffer_Diags;
	    if (getenv("ENABLE_DPU_DIAG_1_PRINT")) 
	      feature_3 |= Feature_Set_3_Bit::Enable_DPU_Diag_1_Print;
	    if (getenv("ENABLE_DPU_DIAG_0_PRINT")) 
	      feature_3 |= Feature_Set_3_Bit::Enable_DPU_Diag_0_Print;
		
	    if((cmd = this->form_command(SU_Station_Unit_Cmds::Set_Feature_Set_Cmd)) &&
	       (table1 = new Set_Feature_Set_Table(Set_Feature_Set_Actions::Load_Feature_Set,
						   0XFFFFFFFF, //default all set
						   0XFFFFFFFF, // ditto
						   feature_2 , 
						   feature_3)) && //default all unset
	       (gen_tab1 = new General_CCC_Table(SU_Table_Types::Set_Feature_Set, table1, 0)) &&
	       cmd->add_table(gen_tab1)
	       )
	      {
		if(this->transmit_to_SU(cmd))
		  {
		    DELETE_CMD;
		  }
		else
		  {
		    DELETE_CMD;
		    this->exit_process(SU_Control_Error_Codes::SU_Connection_Exception, 
				       CCC_Action_Request::Init_SU_Control);
		  }
	      }
	    else
	      {  
		DELETE_ALL;
		this->exit_process(SU_Control_Error_Codes::Memory_Allocation_Exception, 
				   CCC_Action_Request::Init_SU_Control);
	      }
		
		
	    //form su_control ready status msg and transmit to PROCESSOR_CONTROL (or originator!)
		
	    if(msg = new SU_Control_Ready(su_status->get_suid(), disk_unit.du_status.get_VSN_active().c_str(),
					  (int)su_status->get_medium_mounted_status()))
	      {
		this->set_local_time();
		msg->set_local_time(local_time);  
		msg->set_time_stamp(time_stamp);
		msg->set_sender_id(SU_CONTROL_ID);
		msg->set_receiver_id(su_cmd->get_PC_Handle_ID());
		    
		Connection *target = su_cmd->get_connection(PROCESSOR_CONTROL);
		if(target)
		  {
		    msg->transmit(*target);
		    delete msg;
		    msg = 0;
			
		    if(su_status->get_medium_mounted_status())
		      {
			current_state = mounted;
#ifdef DEBUG 
			cout << "Entering mounted state" <<endl;
#endif
		      }
		    else
		      {
			current_state = idle;
#ifdef DEBUG 
			cout << "Entering idle state" <<endl;
#endif
		      }
			
		    if(this->transmit_disk_status() == -1)
		      {
			this->exit_process(SU_Control_Error_Codes::Unspecified_Error, 
					   CCC_Action_Request::Init_SU_Control);
		      }
		    suim_confgd = false;
		  }
		else 
		  {
		    delete msg;
		    msg = 0;
		    this->exit_process(SU_Control_Error_Codes::Proc_Cntrl_Conn_Exception, 
				       CCC_Action_Request::Init_SU_Control);
		  }
	      }
	    else 
	      {
		this->exit_process(SU_Control_Error_Codes::Memory_Allocation_Exception, 
				   CCC_Action_Request::Init_SU_Control);
	      }
	  }
	break;
      }
    case (idle) :
      {	    
	recvd_cjd_count = 0;//reinitialisation
	    
	//check for initalise command
	if(this->in_cmd_queue(CCC_Action_Request::Init_SU_Control))
	  {
	    //get job_id
	    id_of_job = ((CCC_Msg *)cmd_iter->contents()->get_msg())->get_sender_id().job_id();
	    //get PROCESSOR_CONTROL_SERVICE_ID
	    unsigned int proc_cntrl_id;
	    proc_cntrl_id = ((Proc_Ctrl_ID_Aux *)
			     ((General_CCC_Table &)((Command_Message *)cmd_iter->contents()->get_msg())
			      ->get_table(SU_Table_Types::CCC_PROC_CNTRL_ID)).get_aux_data())->
	      get_processor_control_service_id();
	    //convert it to reqd and pass it back to su_cmd
		
	    //close connection to SU, reopen it and exit to wait_for_SU1
	    if(su_conn->re_initialise())
	      {
		initialised = false;
		allocated = false;
		current_state = wait_for_SU1;
		this->transmit_disk_status();
#ifdef DEBUG 
		cout << "Received re_initialise cmd. Entering wait_for_SU1" <<endl;
#endif
	      }
	    else
	      {
		this->exit_process(SU_Control_Error_Codes::Memory_Allocation_Exception, 
				   CCC_Action_Request::Init_SU_Control);
	      }
	    break;
	  }
	if (!eVLBI)
	  {
		
	    //check for disk mounted status message 
	    if (disk_unit.query_du_ready() && disk_unit.query_VSN()) //disk unit ready, status ok, play rate known, VSN queried
	      {
		su_status->set_medium_mounted_status(MOUNTED);
		current_state = mounted;
		//form SU_control disk status action status message and transmit to SU_MONITOR
		this->transmit_disk_status();
#ifdef DEBUG 
		cout << "Received Disk_Mounted AS. Entering mounted state" <<endl;
#endif
		break;
	      }
	  }
	else
	  {
	    if(disk_unit.query_du_ready_4evil()) 
	      {
		char temp[9];
		su_status->set_medium_mounted_status(MOUNTED);
		cout << "SU_control:: idle: eVLBI bar code = " << disk_unit.du_status.get_VSN_active() << endl;
		current_state = mounted;
		this->transmit_disk_status();
#ifdef DEBUG 
		cout << "Received eVLBI Disk_Mounted AS. Entering mounted state" <<endl;
#endif
		break;
	      }		
	  }
	break; 
      }
	  
	  
    case (mounted) :
      {
	allocated = false;
	    
	    
	if (!eVLBI)
	  {
	    //check for disk dismounted
	    if(!disk_unit.query_du_ready())
	      {
		su_status->set_medium_mounted_status(DISMOUNTED);//should really check status bit xx (NYI)
		disk_unit.du_status.set_active_bank(-1);
		current_state = idle;
		//form SU_control medium status action status message and transmit to SU_MONITOR
		this->transmit_disk_status();
#ifdef DEBUG 
		cout << "Received Disk_Dismounted AS. Entering idle state" <<endl;
#endif
		//deliberate no break - possible for a dismounted & mounted msg in same cycle
	      }
		
	    //check for disk mounted status message 
	    if(disk_unit.query_du_ready() && disk_unit.query_VSN())
	      {
		su_status->set_medium_mounted_status(MOUNTED);
		current_state = mounted;
		//form SU_control disk status action status message and transmit to SU_MONITOR
		this->transmit_disk_status();
#ifdef DEBUG 
		//		cout << "Received Disk_Mounted AS. Staying in mounted state" <<endl;
#endif
	      }	    
	  }
	else
	  {

	    if(!disk_unit.query_du_ready_4evil())
	      {
		su_status->set_medium_mounted_status(DISMOUNTED);//should really check status bit xx (NYI)
		current_state = idle;
		//form SU_control medium status action status message and transmit to SU_MONITOR
		this->transmit_disk_status();
#ifdef DEBUG 
		cout << "Received Disk_Dismounted AS. Entering idle state" <<endl;
#endif
		//deliberate no break - possible for a dismounted & mounted msg in same cycle
	      }
	    else
	      {
		su_status->set_medium_mounted_status(MOUNTED);
		cout << "SU_control:: idle: eVLBI bar code = " << disk_unit.du_status.get_VSN_active() << endl;
		current_state = mounted;
		this->transmit_disk_status();
#ifdef DEBUG 
		//		cout << "Received Disk_Mounted AS. Staying in mounted state" <<endl;
#endif
	      }
	  }



	if(current_state != mounted) break;
	op_code = 0;
	    
	//wait for an Enquire_SU_Control cmd
	if(this->in_cmd_queue(CCC_Action_Request::Enquire_SU_Control))
	  {
	    recvd_cjd_count = 0;
	    delete current_jd;
	    current_jd = 0;
	    cjd = 0;
	    current_station = 0;
	    scans = 0;
	    current_scan = 0;
	    current_medium = 0;
		
	    unsigned int msg_id = (unsigned int) ((CCC_Msg *)cmd_iter->contents()->get_msg())->get_msg_id();
		
	    SU_Control_Enquiry_Aux *aux_table = 0;
	    aux_table = ((SU_Control_Enquiry_Aux *)((General_CCC_Table &)
						    ((Command_Message *)cmd_iter->contents()->get_msg())->
						    get_table(SU_Table_Types::CCC_SUC_Enquire)).get_aux_data());
		
	    //disk bar codes have to match or wildcard
	    bool match = false;
	    const int actual_disk_id_len = VSN_LEN;//actual length
	    strncmp_mediumid(aux_table->get_bar_code(), disk_unit.du_status.get_VSN_active().c_str(), actual_disk_id_len) ?
	      (strcmp_mediumid(aux_table->get_bar_code(), "") ? match = false : match = true) : 
	      match = true;
		
	    if(!match)
	      {
		cout << "Actual Disk_id = " <<  disk_unit.du_status.get_VSN_active() << endl;
		cout << "Requested Disk_id = " << aux_table->get_bar_code() << endl;
		cout << "Trying to compare to inactive bank(s)" << endl;
		int bank = 0;
		while (bank < MAX_NR_BANKS && strncmp_mediumid(aux_table->get_bar_code(), disk_unit.du_status.get_VSN(bank), actual_disk_id_len)) {
		  bank++;
		}
		if (bank >= MAX_NR_BANKS) {
#ifdef DEBUG 
		  cout << "Received Enquire_SU_Control cmd - mismatched disk_id. Remaining in mounted state" <<endl;
#endif
		  break;//out of case
		}
		else {
		  if (!disk_unit.bank_set('A'+bank)) {
		    cout << "Failed to switch bank" << endl;
		    break;//out of case
		  }
		  else {
		    cout << "Switched bank" << endl;
		    time_t now = time(0);
		    while (!disk_unit.query_VSN() && time(0) - now < 15) { // update to the new situation, give it 15 seconds to succeed
		      sleep(1); // markv software needs some time to realise banks are switched
		    }
		    disk_unit.query_VSN(); // update to the new situation
		    // check if it really is the right VSN now
		    if (strncmp_mediumid(aux_table->get_bar_code(),disk_unit.du_status.get_VSN_active().c_str(),VSN_LEN)) {
		      // they still differ, something must have gone wrong
		      cout << "Requested and actual disk id still differ" << endl;
		      break;//out of case
		    }
		    cout << "VSN is as expected" << endl;
		  }
		}
	      }
	    op_code = (unsigned int)(aux_table->get_op_code());
	    //for now pay attention to tape operation codes only
	    op_code = op_code & 0XFF;
		
		
	    switch (op_code) 
	      {
	      case  Medium_Operation_Medium_Ops::Processing_Job :
		//run processing job - ie existing case
		if(this->handle_enquire(aux_table))
		  {
		    this->transmit_disk_status(SU_Control_SU_Status_Codes::Medium_Processing);
		    current_state = wait_for_cjd;
		    check_reset_peripherals();
#ifdef DEBUG 
		    cout << "Received Enquire_SU_Control cmd. Entering wait_for_cjd state" << endl;
#endif
		  }
		else
		  {
#ifdef DEBUG 
		    cout << "Received Enquire_SU_Control cmd. Remaining in mounted state" <<endl;
#endif
		  }
		break;
	      case Medium_Operation_Medium_Ops::Stop :
		//stop disk - call appropriate function then ?
#ifdef DEBUG 
		cout << "Received Enquire_SU_Control cmd - stop disk. Remaining in mounted state" <<endl;
#endif
		if(disk_unit.query_play_on()) disk_unit.stop_play();
		if (eVLBI)
		  {
		    if(disk_unit.query_e_station_play_on()) disk_unit.stop_e_station_play();
		    if(disk_unit.query_in2net_on()) disk_unit.in2net("off");
		    closeEVLBIout(true);
		    disk_unit.in2net("disconnect");
		  }
		this->do_abort();
		this->transmit_disk_status();
		op_code = 0;
		break;

	      default :
		//no operation required
		op_code = 0;
		//return status
		this->handle_enquire(aux_table);
		allocated = false;
#ifdef DEBUG 
		cout << "Received Enquire_SU_Control cmd - No operation. Remaining in mounted state" <<endl;
#endif
		break;
	      }//end of switch
	  }//end of if enquire
	    
	if(this->in_response_queue(SU_Action_Status::SU_Status))
	  {
	    //the iterator must be pointing to it.
	    SU_Status *su_stat = (SU_Status *)response_iter->contents()->get_msg();
	    delete response_queue.remove(response_iter);//msg is not deleted
		
	    if(su_stat->get_SU_small_buffers() < MIN_BUFFERS)
	      {
#ifdef DEBUG 
		cout << "WARNING : less than " << MIN_BUFFERS << 
		  " small buffers. Remaining in mounted state" <<endl;
#endif
	      }
		
	    if(su_stat->get_SU_big_buffers() < MIN_BUFFERS)
	      {
#ifdef DEBUG 
		cout << "WARNING : less than " << MIN_BUFFERS << 
		  " big buffers. Remaining in mounted state" <<endl;
#endif
	      }
		
	    delete su_stat;
	    su_stat = 0;
	  }//end if status
	    
	break;
      }//end of case
	  
    case (wait_for_cjd) :
      {
	disk_unit.set_disk_task_ID(id_of_job); // might as well do it here

	T_Job_Descriptor *tcjd;
	    
	// (CJP 10/02/99 ) Removed at Paul's advice
	//if(this->check_timeout(the_standard_time_out))
	//{
	//   this->do_exit_to_mounted(SU_Control_Error_Codes::Timeout_Exception);
	//   break;
	//}
	    
	while(this->action_req_in_cmd_queue(SU_Action_Values::CJD))
	  {
	    tcjd = (T_Job_Descriptor *)cmd_iter->contents()->get_msg();
	    delete cmd_queue.remove(cmd_iter);//msg is not deleted!
		
	    if(((Corr_Job_Descr *) tcjd->get_job_descriptor())->get_corr_job_ID() != id_of_job)
	      {
		//send error message to MEDIUM_HANDLERs, close conns to medium handlers and exit to mounted
		this->do_exit_to_mounted(SU_Control_Error_Codes::Job_ID_Exception,
					 SU_Action_Values::CJD, 
					 (unsigned int)tcjd->get_msg_id());
		delete tcjd;
		tcjd = 0;
		delete current_jd;
		current_jd = 0;
		cjd = 0;
		break; //exit while loop
	      }
		
	    if(recvd_cjd_count == 0)//ie if first cjd
	      {
		current_jd = tcjd;
		cjd = ((Corr_Job_Descr *) tcjd->get_job_descriptor());
		sub_job_start_ROT = cjd->get_sub_job_starting_ROT().get_sysclks();
		sub_job_ending_ROT = cjd->get_sub_job_ending_ROT().get_sysclks();
		SU_CONTROL_ID.set_job_id(cjd->get_corr_job_ID());
		tcjd = 0;
	      }
	    else
	      {
		delete tcjd;
		tcjd = 0;
	      }
		
	    ++recvd_cjd_count;//increase for each cjd received
	    cout << "recvd_cjd_count: " << recvd_cjd_count << endl;		
	    if(cjd->get_sequence_indication().get_max_index() == recvd_cjd_count)
	      {
		current_state = open_disk_stats_file;
		this->transmit_disk_status();
#ifdef DEBUG 
		cout << "Received all CJD. Entering open_disk_stats_file state" <<endl;
#endif
		break; //exit while loop and enter open_dh_rotclock_conns
	      }
		
	  }//end while
	    
	break;
      }//end case
	  
    case (open_disk_stats_file) :
      {      
	//Temporary - open files for output
	    
	// Disk Statistics
	experName = cjd->get_experiment_ID().get_exper_name();
	sprintf(outFilename, "%s/%s/%d/%s.stats", DATADIR, experName.c_str(), cjd->get_CJD_ID(), disk_unit.du_status.get_VSN_active().c_str());
	    
	outFile.open(outFilename, ios::app);
	if(outFile)
	  {
	    outFile << "File containing av_stats and sampler stats msgs" << endl;
	    outFile.close();
	  } 
	else 
	  {
	    cerr << "Failed to open Statistics file " << outFilename << endl;
	  }
	    
	    
	//send msg to rot-clock to suspend messages and exit to configure_su
	    
	if(this->suspend_clock_msgs()) current_state = configure_su;
	//else exit to mounted - dealt with by suspend_clock_msgs()
#ifdef DEBUG 
	cout << "Clock msgs suspended. Entering configure_su state" <<endl;
#endif
	break;
      }	
    case (configure_su) :
      {	 
	int i;//counters
	delete load_polys_aux;

	if (eVLBI) {
	  disk_unit.set_remote_version();
	}

	if(!this->set_current_scan()) break;
	cout << "calling set_fundamental_parameters" << endl;
	if(!this->set_fundamental_parameters(current_scan)) break;
	if(!this->get_polys())
	  {
	    cout << "Init_Proc::do_state() - configure_su: get_polys() failed" << endl;
	    break;
	  }	 
	// Possibly read in values to override automatic settings
	do_external_config();
	    
	//now configure the various arrays
	if(!this->do_config_arrays(current_scan, nr_tracks))
	  {
	    this->do_exit_to_mounted(SU_Control_Error_Codes::Unspecified_Error);
	    break;
	  }
	else
	  {
	    //now have to construct following 
	    Load_Polynomials_Aux *aux_table = 0;
	    Storeable_Aux_Data *table = 0;
	    CompDouble *key = 0;
	    unsigned short int k_div = nint(k_div,log2(SYSTEM_RATE / fs));
	    unsigned short int the_nchan = 0x0010;
	    // fmo060126: fold recirculation factor into k_div.
	    if (itsRecirculationFactor > 0)
	      {
		cout << "Init_Proc::do_state() [configure_su] - recirculation factor = " << itsRecirculationFactor << endl;
		unsigned short int rcf = nint(rcf,log2(itsRecirculationFactor));
		k_div += 256*rcf;
	      }
		
	    if((load_polys_aux = new Ordered_List()) &&
	       (aux_table = new Load_Polynomials_Aux(0, the_nchan, k_div, fs, 
						     the_model_parameters, 
						     the_sidebands)) &&
	       (table = new Storeable_Aux_Data(aux_table)) &&
	       (key = new CompDouble((double) sub_job_start_ROT)) &&
	       load_polys_aux->add(key, table))
	      {
		cout << "Aux_Data : \n k_div = " << k_div << endl
		     << "    true k_div = " << k_div % 256 << endl
		     << "  log2(recirc) = " << k_div / 256 << endl
		     << "fs = " << fs << endl
		     << "the_model_parameters = " << the_model_parameters << endl
		     << "the_sidebands = " << the_sidebands << endl
		     << "speedup = " << speedup << endl;
	      }
	    else
	      {
		delete aux_table; aux_table = 0;
		delete table; table = 0;
		delete key; key = 0;
		this->do_abort();
		this->do_exit_to_mounted(SU_Control_Error_Codes::Memory_Allocation_Exception);
		break;
	      }
	  }
	    
	//which heads are in use?
	cout << "Init_Proc::do_state() [configure_su} - INFO" << endl;
	for(i = 0; i < NUM_TRACKS; ++i)
	  {
	    cout << "-dim_x_bar_configuration[" << i << "] = " << int(dim_x_bar_configuration[i]) << endl;
	    if(((int)dim_x_bar_configuration[i]) < 36) head_0 = true;
	    else if(((int)dim_x_bar_configuration[i]) < 72) head_1 = true;
	    if(head_0 && head_1) break;
	  }
	    
	//Flush the SUIM before the CRM is configured to fix 
	// the rotclock non-start problem
	//if(!this->flush_suim()) break;
	    
	//now construct the various tables
	if(!this->construct_tables(current_scan, table1, table2, table3, table4, table5, table6))
	  {
	    DELETE_ALL;
	    break;
	  }
	    


	if(!(cmd = form_command(SU_Station_Unit_Cmds::Configure_SU))||
	   !(gen_tab1 = new General_CCC_Table(SU_Table_Types::DIM_X_Bar_Setting, table1, 0)) || 
	   !(gen_tab2 = new General_CCC_Table(SU_Table_Types::TRM_Settings, table2, 0)) || 
	   //!(gen_tab3 = new General_CCC_Table(SU_Table_Types::Aux_Data_Check, table3, 0)) || 
	   !(gen_tab4 = new General_CCC_Table(SU_Table_Types::CRM_Settings, table4, 0)) || 
	   !(gen_tab5 = new General_CCC_Table(SU_Table_Types::DM_Configuration, table5, 0)) || 
	   !(gen_tab6 = new General_CCC_Table(SU_Table_Types::Miscell_SU_Params, table6, 0))
	   )
	  { 
	    DELETE_ALL;
	    this->do_exit_to_mounted(SU_Control_Error_Codes::Memory_Allocation_Exception);
	    break;
	  }
	//Transmit cmd to su
	if(!this->config_su(gen_tab1, gen_tab2, gen_tab3, gen_tab4, gen_tab5, gen_tab6, cmd)) 
	  {
	    DELETE_ALL;
	    this->do_exit_to_mounted(SU_Control_Error_Codes::SU_Connection_Exception);
	    break;
	  }
	else
	  {
	    DELETE_ALL;//not DELETE_CMD
	    current_state = form_pcal_tables;
	  }
	//now configure suim
	//if(!this->configure_suim_2()) break;

#ifdef DEBUG
	cout << "SU configured. Entering form_pcal_tables state" <<endl;
#endif
	break;
      }//end of case


    case (form_pcal_tables) :
      {
	int pcmtab[4][3200];
	char table00[3200], table01[3200], table10[3200], table11[3200];
	int tones[4] = { 1, -2, 2, -1 };
	int tone_freqs[4];

	//for each channel derive phase calibration tables 
	//Phase_Cal_Tone_Table* Logical_Station::get_phase_cal_tones(void);
	//Phase_Cal_Entry* Phase_Cal_Tone_Table::get_entry(const char* chan_ref);
	//ieee_dbl Phase_Cal_Entry::get_frequency(void);
	//ieee_dbl Phase_Cal_Entry::get_freq_spacing(void);

	Phase_Cal_Tone_Table* phase_cal_tones = current_station->get_phase_cal_tones();
	assert(phase_cal_tones);

	char *value = getenv("PCAL_TONES");
	if (value)
	  {
	    for (int i = 0; i < sizeof(tones) / sizeof(tones[0]); i++)
	      {
		tones[i] = strtol(value, &value, 10);
		if (value[0] == ':')
		  value++;
	      }
	  }

	// Clear tables for validity = 0.
	memset(table00, 0, sizeof table00);
	memset(table01, 0, sizeof table01);
	memset(table10, 0, sizeof table10);
	memset(table11, 0, sizeof table11);
	if((cmd = form_command(SU_Station_Unit_Cmds::Configure_SU)) && 
	   (table1 = new Phase_Calibration_Table(table00, table01, table10, table11)) &&
	   (aux_table = new Phase_Calibration_Aux(33, 0xdeadbeef)) &&
	   (gen_tab1 = new General_CCC_Table(SU_Table_Types::PCM_Settings, table1, aux_table)) &&
	   cmd->add_table(gen_tab1))
	  {
	    if(!this->transmit_to_SU(cmd))
	      {
		DELETE_CMD;
		this->do_exit_to_mounted(SU_Control_Error_Codes::SU_Connection_Exception);
		break;
	      }
	    else
	      {
		DELETE_CMD;
	      }
	  }
	else
	  {
	    DELETE_ALL;
	    this->do_abort();
	    this->do_exit_to_mounted(SU_Control_Error_Codes::Memory_Allocation_Exception);
	    break;
	  }

	nr_pcal_channels = 0;
	for(int i = 0; i < NUM_CHANNELS; i++)
	  {
	    if(log_chan_track_link[i][72][1] == active)
	      {
		Phase_Cal_Entry *phase_cal_entry = phase_cal_tones->get_entry(log_chan_ref_table[i].c_str());
		assert(phase_cal_entry);

		Channel_Reference *channel = cjd->get_channel(log_chan_ref_table[i].c_str());
		assert(channel);

		ieee_dbl freq = phase_cal_entry->get_frequency();
		ieee_dbl spacing = phase_cal_entry->get_freq_spacing();
		ieee_dbl bandwidth = channel->get_bandwidth();
		if(spacing == 0)
		  continue;//for loop

		assert(freq < spacing);
		for (int j = 0; j < sizeof(tones) / sizeof(tones[0]); j++)
		  {
		    if (tones[j] > 0)
		      tone_freqs[j] = (int)(freq + (tones[j] - 1) * spacing);
		    else if (tones[j] < 0)
		      tone_freqs[j] = (int)(freq + bandwidth + tones[j] * spacing);

		    //round towards a multiple of 10KHz
		    tone_freqs[j] = (tone_freqs[j]+4999)/10000;
		    tone_freqs[j] *= 10000;
		  }

		//derive phase calibration unit tables
		this->make_tab(tone_freqs, pcmtab);

		for(int j = 0; j < 3200; j++)
		  {
		    table00[j] = (char)pcmtab[0][j];
		    table01[j] = (char)pcmtab[1][j];
		    table10[j] = (char)pcmtab[2][j];
		    table11[j] = (char)pcmtab[3][j];
		  }

#ifdef DEBUG
		cout << "Configuring phase calibration tones:" << endl;
		cout << tone_freqs[0] << " Hz, " << tone_freqs[1] << " Hz";
		if (num_bits == 1)
		  cout << ", " << tone_freqs[2] << " Hz, " << tone_freqs[3] << " Hz";
		cout << endl;
#endif

		//form Configure SU cmd, add phase_call tables and send to SU

		if((cmd = form_command(SU_Station_Unit_Cmds::Configure_SU)) && 
		   (table1 = new Phase_Calibration_Table(table00, table01, table10, table11)) &&
		   (aux_table = new Phase_Calibration_Aux(i, 0x10000000)) &&//check this!
		   (gen_tab1 = new General_CCC_Table(SU_Table_Types::PCM_Settings, table1, aux_table)) &&
		   cmd->add_table(gen_tab1))
		  {
		    if(!this->transmit_to_SU(cmd))
		      {
			DELETE_CMD;
			this->do_exit_to_mounted(SU_Control_Error_Codes::SU_Connection_Exception);
			break;
		      }
		    else
		      {
			DELETE_CMD;
		      }
		  }
		else
		  {
		    DELETE_ALL;
		    this->do_abort();
		    this->do_exit_to_mounted(SU_Control_Error_Codes::Memory_Allocation_Exception);
		    break;
		  }

		nr_pcal_channels++;

	      }//end if active channel
	  }//end for each channel loop

	// ??? Should we use SU ID instead of bar code for the file name?
	ostringstream path;
	experName = cjd->get_experiment_ID().get_exper_name();
	path << DATADIR << "/" << experName << "/" << cjd->get_CJD_ID() << "/"
	     << disk_unit.du_status.get_VSN_active() << ".PCAL";

	try
	  {
	    // Clean up an already opened PhaseCal data file, but only
	    // if we're starting a new job (instead of a new subjob).
	    if (pcalFile && pcalFile->fileCJDId() != cjd->get_CJD_ID())
	      {
		delete pcalFile; pcalFile = 0;
	      }

	    if (!pcalFile)
	      {
		pcalFile = new PhaseCalFile(path.str().c_str(), the_suid_code,
					    cjd->get_corr_job_ID(), 0,
					    cjd->get_CJD_ID());

		PhaseCalDescRecord data(cjd->get_sub_job_starting_ROT(),
					(num_bits == 1) ? 4 : 2, tones);
		*pcalFile << data;
		pcalFile->flush();
	      }
	  }
	catch (...)
	  {
	    cout << "ERROR dumping phase cal data to "
		 << path.str() << endl;
	  }

	if(this->resume_clock_msgs())
	  {
#ifdef DEBUG
	    cout << "Clock msgs resumed. Case (form_pcal_tables): Entering positioning1 state" <<endl;
#endif
	    current_state = positioning1;
	    this->transmit_disk_status();
	  }
	//else could not restart ROT_clock msgs - dealt with by resume_clock_msgs()

	break;
      }//end case


    case (wait_for_abort) : 
      {
#ifdef DEBUG
	cout << "In wait_for_abort" << endl;
#endif
	//check for timeout or response to su abort command
	/* commented this, since the timeout is always reached and waiting seems not needed (a reset is done immediatly after)
	   if(this->check_timeout(the_standard_time_out) || 
	   this->in_response_queue(SU_Action_Status::SU_Ops_Aborted))
	   {
	*/
	int_16 stat = 0x0001;
	    
	if((this->in_response_queue(SU_Action_Status::SU_Ops_Aborted)))
	  {
	    stat = 0;
		
	    //maintain su_state
	    su_status->set_SU_state(((SU_Operations_Aborted *)response_iter->contents()->get_msg())->get_su_state());
	  }
	    
	//form error msg and transmit to all medium handlers and close their conns
	    
	if(msg = new Aborted_Action_Status(the_suid_code, stat, id_of_job))
	  {
	    this->set_local_time();
	    msg->set_sender_id(SU_CONTROL_ID);
	    msg->set_ref_id(abort_id);
	    msg->set_local_time(local_time);  
	    msg->set_time_stamp(time_stamp); 
		
	    //transmit msg to all medium Handlers
	    su_cmd->transmit_medium_handlers(msg);
	    delete msg;
	    msg = 0;
	    su_cmd->close_medium_handler_conns();
	    //change state to mounted
	    current_state = mounted;
	    allocated = false;
	    this->transmit_disk_status();
#ifdef DEBUG 
	    cout << "Received Abort cmd. Flushing queues and entering mounted state" <<endl;
#endif
	    Command_Message *command = 0;
	    if(!((command = this->form_command(SU_Command_Queue_Commands::Flush_Queue))
		 && this->transmit_to_SU(command))) {
	      cout << "Warning: Failed to send Flush_Queue command to SU" << endl;
	    }
	    delete command;
	    command = 0;
	  }
	else
	  {
	    this->do_exit_to_mounted(SU_Control_Error_Codes::Memory_Allocation_Exception);
	  }
	break;
      }//end case
	  
	  
    case (positioning1) :
      {	  
	if(clk_msgs_disabled) this->resume_clock_msgs();//insurance
	ieee_dbl required_TOT = 0; 
	    
	if(sub_job_start_ROT >= current_scan->get_start_TOT())
	  {
	    required_TOT = sub_job_start_ROT;
	  }
	else
	  {
	    //a problem!
	    required_TOT = current_scan->get_start_TOT();
	  }
	    
	start_TOT = required_TOT;
	this->transmit_disk_status();

	Short_Time_Value actual_tot(start_TOT);
	Short_Time_Value eVLBI_clock_delay(0); // mark5A does not need any delay
	if(msg = new Su_Control_Medium_Positioned(the_suid_code, eVLBI_clock_delay, actual_tot))
	  {
	    this->set_local_time();
	    msg->set_sender_id(SU_CONTROL_ID);
	    msg->set_ref_id((unsigned int)current_jd->get_msg_id());
	    msg->set_local_time(local_time);  
	    msg->set_time_stamp(time_stamp); 
		
	    //transmit msg to all medium Handlers
	    su_cmd->transmit_medium_handlers(msg);//cant tell if this fails
	    delete msg;
	    msg = 0;
	    recvd_set_rot_cmds = 0;
	    current_state = wait_for_ROT;
	    this->transmit_disk_status();
#ifdef DEBUG 
	    cout << "Received Disk_at_TOT AS - sending Su_Control_Medium_Positioned AS to Medium_Handlers."; 
	    cout << endl << "Entering wait_for_ROT state" <<endl;
#endif
	    break;
	  }
	else
	  {
	    this->do_abort();
	    this->do_exit_to_mounted(SU_Control_Error_Codes::Memory_Allocation_Exception);
	    break;
	  }
	break;
      }//end case
	  
	  
    case (wait_for_ROT) :
      {
	while(this->in_cmd_queue(CCC_Action_Request::SU_Control_Set_ROT))
	  {
	    //we want a SU_Control_Set_ROT cmd from each medium handler - how many have we got? 
	    //- should be the same as recvd_cjd_count
			  
	    //will need to maintain number of such responses as a class data member
			  
	    ++recvd_set_rot_cmds;
	    cout << "recvd_set_rot_cmds= " << recvd_set_rot_cmds << endl;
	    //need to get starting rot 
			  
	    eVLBI_clock_delay = ((Starting_ROT_Aux *)((General_CCC_Table &)((Command_Message *)cmd_iter->contents()->get_msg())->get_table(SU_Table_Types::CCC_SUC_Starting_ROT)).get_aux_data())->get_eVLBI_clock_delay();
	    cout << "received a clock delay of " << eVLBI_clock_delay << endl;

	    if(recvd_set_rot_cmds == recvd_cjd_count)
	      {
		Short_Time_Value time(start_TOT);
		if(msg = new Su_Control_Medium_Ready(the_suid_code, time, time, output_mapping))
		  {
		    cerr << "SU_Control::map_ROT = " << 
		      ((Su_Control_Medium_Ready *)msg)->get_map_rot() << "   " 
			 << (((Su_Control_Medium_Ready *)msg)->get_map_rot()).get_rot_string()
			 << endl;
		    this->set_local_time();
		    msg->set_sender_id(SU_CONTROL_ID);
		    msg->set_ref_id(00);//unsolicited?
		    msg->set_local_time(local_time);  
		    msg->set_time_stamp(time_stamp);
						 
		    //transmit msg to all medium Handlers
		    su_cmd->transmit_medium_handlers(msg);//cant tell if succeds
		    delete msg;
		    msg = 0;
		    current_state = wait_job_starting;
#ifdef DEBUG 
		    cout << "Received Tape_at_TOT AS - sending Su_Control_Medium_Ready AS to Medium_Handlers."; 
		    cout << endl << "Entering wait_job_starting state" <<endl; 
#endif
		    break;
		  }
		else
		  {
		    this->do_abort();
		    this->do_exit_to_mounted(SU_Control_Error_Codes::Memory_Allocation_Exception);
		    break;//out of case
		  }
	      }
	    else
	      {
		//delete current cmd and continue
		delete (cmd_queue.remove(cmd_iter));
		continue;//not really reqd
	      }
	  }//end while
	    
	//if got to here havn't received enough SU_Control_Set_ROT cmds, stay in this state
	//cout << "if got to here havn't received enough SU_Control_Set_ROT cmds, stay in this state" << endl;
	break;
      }//end case
	  
    case (wait_job_starting) :
      {
	//check for arrival of job_starting cmd
	if(this->in_cmd_queue(CCC_Action_Request::SU_Control_Job_Strt))
	  {
#ifdef DEBUG 
	    cout << "Received SU_Control_Job_Strt cmd " <<endl;
#endif
	    Job_Starting_Aux* js_aux = (Job_Starting_Aux *)((General_CCC_Table &)((Command_Message *)cmd_iter->contents()->get_msg())->get_table(SU_Table_Types::CCC_SUC_Job_Starting)).get_aux_data();
	    recording = js_aux->start_recording();
	    cout << "recording from js aux " << recording << endl;
	    //get data handler service id 
	    int serv_type = (int) js_aux->get_data_handler_service_id();
			  
	    if(!(su_cmd->open_DATA_HANDLER_Connection(serv_type)))
	      {
		//failed to open connections
		this->do_exit_to_mounted(SU_Control_Error_Codes::Data_Handler_Conn_Exception);
		break;
	      }
			  
	    //suspend rot clock msgs and exit to configure_su2
	    if(this->suspend_clock_msgs())
	      {
		current_state = configure_su2;
	      }
	    //else exit to mounted - dealt with by suspend_clock_msgs()
#ifdef DEBUG 
	    cout << "Suspending clock msgs. Entering configure_su2 state" <<endl;
#endif
	    break;
	  }
	break;
      }
    case (configure_su2) :
      {
	//	    disk_unit.set_disk_task_ID(id_of_job);
	if(this->configure_su_next_scans(nr_tracks, start_TOT))
	  {
#ifdef DEBUG 
	    cout << "SU configured. Entering get_polynomials state" <<endl;
#endif
	    current_state = get_polynomials;
	  }
	break;
      }//end case
	  
	  
    case (get_polynomials) :
      {
	if(!(cmd = form_command(SU_Station_Unit_Cmds::Load_Polynomials)))
	  {
	    DELETE_ALL;
	    this->do_abort();
	    this->do_exit_to_mounted(SU_Control_Error_Codes::Memory_Allocation_Exception);
	    break;//out of case
	  }
	    
	if(this->send_load_poly_cmd(cmd, sub_job_start_ROT))//send first load poly cmd
	  {
	    if(end_ROT < sub_job_ending_ROT)
	      {
		cout << "send another load poly cmd" << endl;
		//remove table from cmd 
		delete (cmd->remove_table(SU_Table_Types::Delay_Phase_Poly));
		    
		cmd->set_obey_ROT(poly_obey_ROT);
		cmd->set_flags(SU_Action_Request_Flags::Obey_ROT_Set);
		    
		if(this->send_load_poly_cmd(cmd, end_ROT))
		  //send second load poly cmd timed to be obeyed at obey_rot
		  {
		    DELETE_CMD;
		    //send alarm message to rot_clock if ..
		    if(end_ROT < sub_job_ending_ROT)
		      {
			load_polys_flag = ROT_Clock_Alarm_Codes::Load_Polys + the_suid_code;
			if(this->send_alarm_request(load_polys_flag, begin_ROT))
			  {
			    //next resume_clock_msgs
			    if(this->resume_clock_msgs())
			      {
				current_state = running;
				this->transmit_disk_status();
#ifdef DEBUG 
				cout << "First: Polys sent to su - resuming clock msgs."; 
				cout << endl << "First: Entering running state" <<endl;
#endif
			      }
			    //else could not restart ROT_clock msgs - dealt with by resume_clock_msgs()
			    break;
			  }
			//else fn take care of state
			else
			  {
			    break;
			  }
		      }//end send alarm msg if...
		    else
		      {
			current_state = running;
			this->transmit_disk_status();
#ifdef DEBUG 
			cout << "Second: Polys sent to su - resuming clock msgs."; 
			cout << endl << "Second: Entering running state" <<endl;
#endif
			break;
		      }
		  }//end if send second load polys cmd
		else
		  {
		    //something wrong - state taken care of by send_load_poly_cmd()
		    DELETE_CMD;
		    break;
		  }
	      }//end if more polys to send
	    else
	      {
		DELETE_CMD;
		//next resume_clock_msgs
		if(this->resume_clock_msgs())
		  {
		    current_state = running;
		    this->transmit_disk_status();
#ifdef DEBUG 
		    cout << "Polys sent to su - resuming clock msgs."; 
		    cout << endl << "Entering running state" <<endl;
#endif
		  }
		//else could not restart ROT_clock msgs - dealt with by resume_clock_msgs()
		break;
	      }
	  }//end if send first load polys cmd
	else
	  {
	    //something wrong - state taken care of by send_load_poly_cmd()
	    DELETE_CMD;
	    break;
	  }	 
      }
    case (running) :
      {
	// First, make sure that su_scan_config_disk has actually been called, wait for a 
	// Report_Scan_Finished response of SU (can only be meant for us)
	if(this->in_response_queue(SU_Action_Status::Scan_Finished))
	  {
	    cout << "case running: SU_Action_Status::Scan_Finished in response queue" << endl;
	    if(!this->su_scan_config_disk()) break;
	  }
	//		 else break;

	if(clk_msgs_disabled) this->resume_clock_msgs();//insurance

	// check for switch msgs
	// turn on/off servoing
	//cout << "Recording state: " << recording << " play in q " << this->in_cmd_queue(CCC_Action_Request::Switch_To_Play) << " record in q " << this->in_cmd_queue(CCC_Action_Request::Switch_To_Record) << endl;
	if (
	    eVLBI &&
	    ((recording && this->in_cmd_queue(CCC_Action_Request::Switch_To_Play)) ||
	     (!recording && this->in_cmd_queue(CCC_Action_Request::Switch_To_Record)))
	    ) {
	  //if (disk_unit.query_in2net_on()) querying takes precious time
	  Command_Message* msg = (Command_Message *) cmd_iter->contents()->get_msg();
	  ieee_dbl rot = ((Switch_Table*)((General_CCC_Table &)msg->get_table(SU_Table_Types::Switch_Record_Play)).get_table_data())->get_rot();
	  if (rot > cjd->get_sub_job_starting_ROT().get_sysclks()) { // ignore switch messages until start ROT is reached
	    disk_unit.in2net("off");
	    if (recording) {
	      this->do_servoing(true, rot + SERVO_DELAY * SYSTEM_RATE);
	      ignore_next_servo_error = true; // ignore first servo error
	      //if (disk_unit.query_net2disk_on()) querying takes precious time
	      disk_unit.net2disk("close");
	      disk_unit.in2net("disconnect");
	      if (!disk_unit.net2out("open")) return false;
	    }
	    else {
	      this->do_servoing(false, -1.0); //disable servoing bit
	      closeEVLBIout(false); // querying takes precious time => false
	      disk_unit.in2net("disconnect");
	      cout << "forming net2disk command" << endl;
	      if (!disk_unit.net2disk(form_net2disk_command(rot + SYSTEM_RATE).c_str())) return false;
	    }
	    if (
#ifndef DO_ACTUAL_RECORDING
		recording && // if we are not actually recording (that is in the recording scans we do actually nothing), there is no need to connect on switching to record
#endif
		(!disk_unit.in2net("connect") || !disk_unit.in2net("on"))) { 
	      return false;
	    }
	    recording = !recording;
	  } // if (rot > sub job ROT)
	  else {
	    cout << "switch message ignored since " << Short_Time_Value(rot).get_rot_string() << " <= " <<  cjd->get_sub_job_starting_ROT().get_rot_string() << " mode will stay " << (recording?"recording":"playing") << endl;
	  }
	} // if (eVLBI and useful switch msg in queue

	    
	    
	int i;//counter
	    
	Data_Message *data_msg = 0;
	Finish_ROT_Clock_Message *fcm = 0;
	Clock_Message_Entry *entry = 0;
	Connection *target;
	    
	//check for alarm ROT clock Msg
	while(this->action_req_in_cmd_queue(SU_Action_Values::Alarm))
	  {
	    //check it's for us and to load next set of polys - remove msg from queue
	    if(!this->check_alarm()) {
	      cout << "check_alarm failed" << endl;
	      break;
	    }
			  
	  }//end while alarm message in cmd_queue
	    
	    
	//check for data message from SU
	while(this->data_in_response_queue())
	  {
#ifdef DEBUG 
	    cout << "Received data msg - pass onto data handler."<< endl;
#endif
			  
	    data_msg = (Data_Message *)response_iter->contents()->get_msg();
	    //write msg to file
	    outFile.open(outFilename, ios::app);
	    if(outFile)
	      {
		debug_log_flag = true;
		data_msg->print(outFile);
		debug_log_flag = false;
		outFile.close();
	      }

#if 1
	    this->write_data_message(*data_msg);
#else
	    //pass message on to data handler
	    target = su_cmd->get_connection(DATA_HANDLER);
	    if(target)
	      data_msg->transmit(*target);
	    else
	      {
		this->do_abort();
		break;
	      }
#endif

	    if (data_msg->get_data_type() == SU_Table_Types::Sampler_Stats) {
	      cout << "Sampler stats in data response queue" << endl;
	      forward_data_msg_to_dsm(data_msg);
	    }

	    delete data_msg;
	    data_msg = 0;
	    delete response_queue.remove(response_iter);
	  }
	    
	//check for Servo Error message
	if(this->in_response_queue(SU_Action_Status::Servo_Error))
	  {
	    cout << "case running: SU_Action_Status::Servo_Error in response queue" << endl;
	    if(!this->set_disk_servo_error()) break;
	  }
		 
	//check for Average_statistics
	if(this->in_response_queue(SU_Action_Status::Average_Stats))
	  {
	    cout << "case running: SU_Action_Status::Average_Stats in response queue" << endl;
	    if(!this->do_disk_stats(lock_resyncs)) break;
	  }
	    
	//check for DPU Power monitor
	if(this->in_response_queue(SU_Action_Status::DPU_Cmd_Response))
	  {
	    data_msg = (Data_Message *)response_iter->contents()->get_msg();
	    //write msg to file
	    outFile.open(outFilename, ios::app);
	    if(outFile)
	      {
		debug_log_flag = true;
		data_msg->print(outFile);
		debug_log_flag = false;
		outFile.close();
	      }
			  

	    if (data_msg->get_data_type() == SU_Table_Types::Sampler_Stats) {
	      cout << "Sampler stats in CPU command response queue" << endl;
	      forward_data_msg_to_dsm(data_msg);
	    }

	    delete data_msg;
	    data_msg = 0;
	    delete response_queue.remove(response_iter);
	  }
	    
	//check for SU_Finished
	if(this->in_response_queue(SU_Action_Status::SU_Finished))
	  {
	    this->SU_finished(CCC_Finish_Codes::Normal_Finish);
#ifdef DEBUG 
	    cout << "Received SU_finished - return to mounted state."<< endl;
#endif
	    break;
	  }
	//check for fatal su error
	if(this->in_response_queue(SU_Action_Status::SU_Error))
	  {
#ifdef DEBUG 
	    cout << "Received SU_Error - return to mounted state."<< endl;
#endif
	    this->do_abort();
	    this->transmit_disk_status(SU_Control_SU_Status_Codes::Error);
	    int_32 code = 0xFFFFFFFF;//temp - SU_Error AS hasn't yet been defined
	    error_msg.set_su_error_code(code,SU_Control_Error_Codes::SU_Error_Received);
	    this->do_exit_to_mounted(SU_Control_Error_Codes::SU_Error_Received);
	    break;
	  }
	    
	//check for finish_ROT clock message
	while(this->action_req_in_cmd_queue(SU_Action_Values::Finish_ROT))
	  {
	    //check it's for us
			  
	    fcm = (Finish_ROT_Clock_Message *) cmd_iter->contents()->get_msg();
	    delete cmd_queue.remove(cmd_iter);//msg is not deleted!
			  
	    //iterate through its entries
	    entry = fcm->first_entry();
			  
	    for(i = 0; i < fcm->how_many(); ++i)
	      {
		if((entry->get_SU_array_code() != cjd->get_corr_job_ID()))
		  {
		    entry = fcm->next_entry(entry);
		  }
		else
		  {
		    break;//out of for loop
		  }
	      }
			  
	    if(i < fcm->how_many())
	      {
#ifdef DEBUG 
		cout << "Received finish_ROT clock message - Flushing queues and return to mounted state."<< endl;
#endif
		this->SU_finished(CCC_Finish_Codes::Finish_Clk_Msg);
		delete fcm; fcm = 0;
					
		Command_Message *cmd = 0;

		// Cancel Request Phase Calibration Data now.
		if (!(cmd = form_command(SU_Station_Unit_Cmds::Req_Phase_Cal_Data))
		    || !(aux_table = new Phase_Cal_Aux(0))
		    || !(gen_tab1 = new General_CCC_Table(SU_Table_Types::P_C_Data_Accum_Period, 0, aux_table))
		    || !(cmd->add_table(gen_tab1))
		    || !(this->transmit_to_SU(cmd)))
		  cerr << "Warning: Failed to send Req_Phase_Cal_Data to SU" << endl;
		delete cmd; cmd = 0;

		if (!((cmd = this->form_command(SU_Command_Queue_Commands::Flush_Queue)) 
		      && this->transmit_to_SU(cmd)))
		  cerr << "Warning: Failed to send Flush_Queue command to SU" << endl;
		delete cmd; cmd = 0;

		break;//out of while loop
	      }
	    delete fcm; fcm = 0;
	  }


	//check for Reconnect_eVLBI message in Enquire_SU_Control cmd


	if(this->in_cmd_queue(CCC_Action_Request::Enquire_SU_Control))
	  {
	    cout << "su_control: Enquire_SU_Control in cmd queue" << endl;
	    op_code = 0;
		
	    SU_Control_Enquiry_Aux *aux_table = 0;
	    aux_table = ((SU_Control_Enquiry_Aux *)((General_CCC_Table &)
						    ((Command_Message *)cmd_iter->contents()->get_msg())->
						    get_table(SU_Table_Types::CCC_SUC_Enquire)).get_aux_data());
	    op_code = (unsigned int)(aux_table->get_op_code());
	    op_code = op_code & 0XFF;
	    cout << "su_control: op_code = " << op_code << endl;
		
	    switch (op_code)
	      {
	      case Medium_Operation_Medium_Ops::Reconnect_eVLBI:
		if (!disk_unit.reconnect_eVLBI(recording, form_net2disk_command(-1))) cout << "Could not reconnect external station" << endl;
		break;
	      case Medium_Operation_Medium_Ops::ReStartTransfer:
		if (!disk_unit.restart_transfer()) cout << "Could not restart transfer" << endl;
		break;
	      default:
		break;	    
	      }
	  }
	    
	    
	if(peaking_thread) return 0;//will bypass clearing queues
	    
	break;
      }//end case
	  
    }//end switch
      
  this->clear_queues();
      
  if (prev_state == current_state) 
    {
      usleep(100000);
    }
  return 0;
}
