#include <su_control/parse_mk5.h>
#include <iostream>

using namespace std;

Command_Reply parse_command(const char* in) {
  assert(in);
  string tmp = in;
  const char* copy = tmp.c_str();
  bool query = tmp.find('?') != string::npos;
  int index = tmp.find( query ? '?' : '=');
  Command_Parameters params;
  bool stop = (index == string::npos);
  while (!stop) {
    int begin = index+1;
    index = tmp.find(':',begin);
    string white_spaced = "";
    if (index != string::npos) {
      white_spaced = tmp.substr(begin,index-begin);
    }
    else {
      index = tmp.find(';',begin);
      white_spaced = tmp.substr(begin, (index!=string::npos? index : tmp.length()) - begin);
      stop = true;
    }
    int start = white_spaced.find_first_not_of(' ');
    if (start != string::npos) {
      params.push_back( white_spaced.substr(start,white_spaced.find_last_not_of(' ')-start+1) );
    }
    else {
      params.push_back("");
    }
  }
  return Command_Reply(query,params);
}

Multi_Command_Reply parse_multi_command(const char* in) {
  Multi_Command_Reply response;
  char* copy = strdup(in);
  char* command_ptr = copy;
  while (command_ptr) {
    // save the begin of command
    char* single_command_ptr = command_ptr;

    // advance to next command and ensure that this command ends with '\0'
    command_ptr = strchr(command_ptr, ';');
    if (command_ptr) {
      *command_ptr = '\0';
      command_ptr++;
    }

    response.push_back(parse_command(single_command_ptr));
  }
  free(copy);
  return response;
}
