//peak_head.C

//SU_CONTROL application - Head peaking thread

//JIVE, October 1998

//_________________________________________________________________________

//for RCS

//$Header: /export/home/jive_cvs/JCCS/CVS_Repository/su_control/source/peak_head.C,v 3.7 2006/02/15 14:55:57 jive_cc Exp $

//$Locker:  $

//$Log: peak_head.C,v $
//Revision 3.7  2006/02/15 14:55:57  jive_cc
//FMO: use static_cast<>
//
//Revision 3.6  2005/12/23 13:16:55  verkout
//HV: Phew. This is the big thing. Merged all developments with both the port to Linux and the mods needed for a byte-order safe COF
//
//Revision 3.4.4.1  2005/10/25 15:02:12  verkout
//HV: Merge with main branch. May need fixes in order to compile on jaw0/HP-UX
//
//Revision 3.5  2005/06/17 08:18:06  jive_cc
//FMO copied rel20040831-p6 to HEAD
//
//Revision 3.4.2.1  2005/03/17 12:30:34  jive_cc
//FMO: improve head-logic (support tapes on high dims) and add couts
//
//Revision 3.4  2004/06/25 13:21:48  verkout
//gnu3.2 version: many many MANY way too many changes
//
//Revision 3.3  2003/08/13 10:28:06  jive_cc
//FMO: get the offset of the correct headgroup (there can be two now)
//
//Revision 3.2  2003/05/15 11:46:35  jive_cc
//Arpad: merged MarkV version into main
//
//Revision 3.1.2.2  2003/02/28 09:20:20  jive_cc
//arpad: turned on logging tape_handler and replayed_telescope
//
//Revision 3.1.2.1  2003/01/20 14:47:45  jive_cc
//Arpad: many changes, mainly cosmetic, replaced "tape" by "disk"
//
//Revision 3.1  2002/11/26 15:09:35  jive_cc
//FMO: optionally disable head position limits checking
//
//Revision 3.0  2002/04/17 14:45:45  jive_cc
//Included gnu branch
//
//Revision 1.21.2.4  2002/04/17 06:46:31  jive_cc
//FMO: use string interface of CJD
//
//Revision 1.21.2.3  2002/01/07 15:51:40  jive_cc
//Friso and Arpad: many many MANY pointers were explicitely set to zero after being deleted to avoid memory problems caused by double deletions
//
//Revision 1.21.2.2  2001/12/18 15:49:02  jive_cc
//Arpad: cleanup by Chris (version 1.22 on main branch)
//
//Revision 1.21.2.1  2001/12/13 11:26:01  jive_cc
//GNU Version
//
//Revision 1.21  2001/11/28 11:02:01  jive_cc
//CP added features bits in CJD
//
//Revision 1.20  2001/11/01 14:19:14  jive_cc
//(CJP) Head Peaking Logging.
//
//Revision 1.19  2001/06/14 09:37:12  jive_cc
//CP corrected administration of attempts
//
//Revision 1.18  2001/05/17 15:04:35  jive_cc
//CJP upgraded fishbone strategy
//
//Revision 1.17  2000/09/18 07:13:00  jive_cc
//(CJP) Large head peaking steps and updated output
//
//Revision 1.16  2000/06/20 11:42:06  jive_cc
//(CJP): Tape stop fixes
//
//Revision 1.15  2000/03/07 10:56:58  jive_cc
//(CJP) Remove check of track id after message iterator deleted
//
//Revision 1.14  2000/01/14 15:00:30  jive_cc
//(CJP) Increase peaking search window
//
//Revision 1.13  1999/08/30 09:46:42  jive_cc
//back to start footage once only
//
//Revision 1.12  1999/08/25 06:51:35  jive_cc
//(CJP) Added a little more info during peaking
//
//Revision 1.11  1999/07/23 12:24:12  pwm
//restrict # attempts to peak before aborting
//
//Revision 1.10  1999/07/09 15:12:20  jive_cc
//(CJP) Disabled log file of peaking
//
//Revision 1.9  1999/05/10 11:45:07  pwm
//cosmetic changes
//
//Revision 1.8  1999/04/29 17:11:18  pwm
//degugged on-the-fly peaking (hopefully)
//
//Revision 1.7  1999/03/04 17:17:22  pwm
//fixed deletion of Abort cmd
//
//Revision 1.6  1999/02/24 13:30:30  jive_cc
//more mods at jive
//
//Revision 1.5  1999/02/16 18:20:23  pwm
//changed is_header_good() to accept 1 good header, cosmetic changes
//

//___________________________________________________________________________

#include <su_control/peak_head.h>

using namespace std;
Peak_Head::Peak_Head(Thread_ID my_id, Thread_ID parent, Thread_Master *owner, 
		     Init_Proc *i_p, int nom_pos, int nom_pos_off, 
		     unsigned int head_nr, unsigned int logical_head_nr, 
		     bool restart, bool peaking)
  : Thread(my_id, parent, owner),
    _init_proc(i_p),
    _nominal_position(nom_pos),
    _nominal_position_offset(nom_pos_off),
    _head_nr(head_nr),
    _logical_head_nr(logical_head_nr)
{
  ofstream peakFile;
  
  if(peaking) current_state = peak_heads;
  else current_state = check_headers;
  _req_tpe_frm_hdr_id = 0;
  _number_attempts = 0;
  _total_number_attempts = 0;
  _req_tpe_frm_hdr_count = 0;
  _back_to_initial_footage = restart;
  _current_guess_position = _nominal_position + _nominal_position_offset;
  
  int_32 head_positions[4];
  _init_proc->get_su_status()->get_head_positions(head_positions);
  short hd_posn;
  hd_posn = (short)(head_positions[logical_head_nr]&0xffff);

  ///  if(abs(hd_posn) < MAX_HEAD_POSITION) _actual_position = hd_posn;
  int maxHeadPosition = MAX_HEAD_POSITION;
  if (getenv("DISABLE_PEAK_DIFF_LIMIT")) maxHeadPosition = 2*MAX_HEAD_POSITION;
  if(abs(hd_posn) < maxHeadPosition) _actual_position = hd_posn;
  
  header[0] = 0;
  header[1] = 0;
  header[2] = 0;
  
  if(_head_nr == 1)  
    {
      _track_nr = _init_proc->head1_best_track;
      cout << "peak_head: _head_nr = " << _head_nr << " , _track_nr = " << _track_nr << endl;
    }
  else 
    {
      _track_nr = _init_proc->head2_best_track;
      cout << "peak_head: _head_nr = " << _head_nr << " , _track_nr = " << _track_nr << endl;
    }
  
  initial_fishbone_direction = 1;
  
  // Read values from the feature bits string
  corr_head = -1;  // The actual head being correlated
  string feature_bits = _init_proc->cjd->get_feature_bits(1);
  if (!feature_bits.empty())
    {
      cout << "DEBUG: Corr Head feature bit set..."<< endl;
      if (isdigit(feature_bits[0]))
	{
	  corr_head = atoi(feature_bits.c_str());
	  if (corr_head > 1)
	    {
	      corr_head = -1;
	      cout << "Warning: Feature bit Active Head too large (" << corr_head << ")" << endl;
	    }
	} 
      else
	{
	  cout << "Warning: Bad value (" << corr_head << ") for Active Head feature bit [1]" << endl;
	}
    }
  
  peakFile.open(_init_proc->peakFilename, ios::app);
  if (peakFile)
    {
      if (peaking)
	{
	  peakFile << "Peaking head " << _head_nr << endl;
	}
      else
	{
	  peakFile << "On-the-fly peaking for head " << _head_nr << endl;
	}
      peakFile.close();
    }
}

Peak_Head::~Peak_Head(void)
{
   delete header[0];
   delete header[1];
   delete header[2];
   header[0] = 0;
   header[1] = 0;
   header[2] = 0;
}

int Peak_Head::run()
{ 
   if(cycle() < 0)
   {
      this->set_stat(Thread::terminating);
      _init_proc->peaking_thread = 0;
      _init_proc->transmit_tape_status();
      return -1;
   }
   else return 0;
}

int Peak_Head::quit()
{ 
   this->set_stat(Thread::terminating);
   return 0;
}
  

int Peak_Head::pre_state()
{
   //want to check for abort cmd, etc
   
   if(_init_proc->in_cmd_queue(CCC_Action_Request::Abort))
   {
      #ifdef DEBUG 
         cout << "(Peak_Head::pre_state) Received Abort Cmd" <<endl;
      #endif
      //abort_id = (unsigned int)((CCC_Msg *)cmd_iter->contents()->get_msg())->get_msg_id();
      _init_proc->do_abort();
      delete _init_proc->cmd_iter->contents()->get_msg();
      delete _init_proc->cmd_queue.remove(_init_proc->cmd_iter);
      return -1;
   }
   
   //also want to check for response to an abort - other threads can abort the su
   if(_init_proc->in_response_queue(SU_Action_Status::SU_Ops_Aborted))
   {
      return -1;
   }
	   
   
   //check for tape dismounted
   //if(this->do_tape_dismounted()) break;
   
   return 0;
}

int Peak_Head::do_state()
{
   Command_Message *cmd = 0;//outbound
   Action_Status *msg = 0; //outbound

   Table_Data *table1 = 0, *table2 = 0, *table3 = 0;
   
   Aux_Data *aux_table = 0;
   
   General_CCC_Table *gen_tab1 = 0, *gen_tab2 = 0, *gen_tab3 = 0;
      
   int the_peak_heads_time_out = 45;//seconds
   ieee_dbl the_standard_time_out = 120.0;//seconds - reset to zero upon sending a cmd to SU
   ofstream peakFile;
   
   //switch statement depending on current_state
   
   switch (current_state)
   {
      case (peak_heads) :
	 {
	    if(this->send_peak_heads_cmd(_current_guess_position, the_peak_heads_time_out))
	    {
	       ++_number_attempts;
	       ++_total_number_attempts;
	       current_state = request_headers;
	       cout << "peak_heads_cmds sent with arguments " << _nominal_position << ", " 
	       << _nominal_position_offset << ", " << the_peak_heads_time_out 
	       << ". Entering request_headers state" <<endl;
	       cout << "***Peak Head command requested (case peak_heads)" << _current_guess_position << ". Entering request_headers state" << endl;

	    }
	    else return -1;
             
	    //#ifdef DEBUG 
	    //cout << "peak_heads_cmds sent. Entering request_headers state" <<endl;
	    //#endif
	    break;
	 }
      
      case (request_headers) :
	 {
	    int_32 head_positions[4];
	    
	    //check for timeout
	    
	    if(_init_proc->check_timeout(the_peak_heads_time_out))
	    {
		 cout << "Peak_Head::do_state() [case request_headers) - timed out" << endl;
	       _init_proc->do_abort();
	       _init_proc->do_exit_to_mounted(SU_Control_Error_Codes::Timeout_Exception);
	       return -1;
	    }
	    
	    //check there is a response to peak heads cmd
	    
	    if(_init_proc->in_response_queue(SU_Action_Status::Heads_Peaked))
	    {
	       //need to check that this is response to "this" peak hd cmd
	       if(((CCC_Msg *)_init_proc->response_iter->contents()->get_msg())->get_request_id() != _peak_hd_cmd_id)
	       {
		  //not interested in this msg
		 cout << "Peak_Head::do_state() [case request_headers) - got Heads_Peaked, but not for us" << endl;
  		  break;
	       }
	       //else
	       
	       //record posn of headstacks in su_status
	       head_positions[0] = ((Heads_Peaked *)_init_proc->response_iter->contents()->get_msg())->get_hd1_pos();
	       head_positions[1] = ((Heads_Peaked *)_init_proc->response_iter->contents()->get_msg())->get_hd2_pos();
	       head_positions[2] = ((Heads_Peaked *)_init_proc->response_iter->contents()->get_msg())->get_hd3_pos();
	       head_positions[3] = ((Heads_Peaked *)_init_proc->response_iter->contents()->get_msg())->get_hd4_pos();
	       _init_proc->get_su_status()->set_head_positions(head_positions);

	       cout << "head_positions[0] = " << head_positions[0] << endl;
	       cout << "head_positions[1] = " << head_positions[1] << endl;
	       cout << "head_positions[2] = " << head_positions[2] << endl;
	       cout << "head_positions[3] = " << head_positions[3] << endl;
	       
	       short hd_posn;
	       ///050208fmo patch START
	       ///use my_head_nr i.s.o _head_nr
	       int my_head_nr = _head_nr;
	       if (_init_proc->swap_head)
		 {
		   my_head_nr = 3 - _head_nr;
		 }
	       hd_posn = (short)(head_positions[my_head_nr - 1]&0xffff);
	       cout << "***Peak Head command reported  " << hd_posn << endl;
	       cout << "my_head_nr = " << my_head_nr << endl;
	       cout << "_head_nr = " << _head_nr << endl;
	       peakFile.open(_init_proc->peakFilename, ios::app);
	       if (peakFile) {
		 peakFile << "Head " << my_head_nr << " peaked at " << hd_posn/10 
			  << " um" << endl;
		 peakFile.close();
	       }
	       ///050208fmo patch END

	       ///  if(abs(hd_posn) < MAX_HEAD_POSITION) _actual_position = hd_posn;
	       int maxHeadPosition = MAX_HEAD_POSITION;
	       if (getenv("DISABLE_PEAK_DIFF_LIMIT")) maxHeadPosition = 2*MAX_HEAD_POSITION;
	       if(abs(hd_posn) < maxHeadPosition) _actual_position = hd_posn;
	       
	       delete _init_proc->response_iter->contents()->get_msg();
	       delete _init_proc->response_queue.remove(_init_proc->response_iter);
	       
	       //form request tape frame header and send to su
	       
	       if(this->send_req_tpe_frm_hdr())
	       {
		  current_state = check_headers;
	          //#ifdef DEBUG 
	          //  cout << "req_tpe_frm_hdr_cmds sent. Entering check_headers state" <<endl;
	          //#endif
	       }
	       else return -1;
	    }//end if in response queue
	    break;
	 }
      
      case (check_headers) :
	 {
	    
	   // 10/02 CJP disabled
	   // //check for timeout
	   // if(_init_proc->check_timeout(the_standard_time_out))
	   // {
	   //    _init_proc->do_abort();
	   //    _init_proc->do_exit_to_mounted(SU_Control_Error_Codes::Timeout_Exception);
	   //    return -1;
	   // }
	    
	    //check for responses to request tape frame header cmds
	    while(_init_proc->in_response_queue(SU_Action_Status::Medium_Frame_Hdr_Data))
	    {
	       if(((CCC_Msg *)_init_proc->response_iter->contents()->get_msg())->get_request_id() == _req_tpe_frm_hdr_id)
	       {
		  cout << "received header" << endl;
		  //decrement request_medium_frame_header count
		  --_req_tpe_frm_hdr_count;
		  
		  //_init_proc->headerFile.open(_init_proc->headerFilename, ios::app);
		  //if(_init_proc->headerFile)
		  //{
		  //  debug_log_flag = true;
		    //  _init_proc->response_iter->contents()->get_msg()->print(_init_proc->headerFile);
		  //   debug_log_flag = false;
		  //   _init_proc->headerFile.close();
		  //}
		  
		  //store header
		  delete header[_req_tpe_frm_hdr_count];
		  header[_req_tpe_frm_hdr_count] = (Medium_Frame_Header_Data *)
		                                   (_init_proc->response_iter->contents()->get_msg());
		  delete (_init_proc->response_queue.remove(_init_proc->response_iter));//does not owm msg
	       }
	       else //not interested in this message
	       {
		  //break; //see comment below
		  delete (_init_proc->response_iter->contents()->get_msg());
		  delete (_init_proc->response_queue.remove(_init_proc->response_iter));//does not owm msg
		  //this means that overall only one head can be peaked at a time - is this a problem????
	       }
	    }
	    
	    if(_req_tpe_frm_hdr_count <= 0 )
	    {
	       _req_tpe_frm_hdr_count = 0;
	       
	       //check headers
	       
	       if(this->is_header_good())
	       {
		  if(_init_proc->current_state == Init_Proc::running) _init_proc->do_auto_tracking(0, true);
		  return -1;//ie exit thread
	       }
	       //else
	       this->do_head_not_peaked();
	       
	       //if abs calculated head position is > 800 micron then want to start afresh
	       ///if(abs(_calculated_position) > MAX_HEAD_POSITION)
	       int maxHeadPosition = MAX_HEAD_POSITION;
	       if (getenv("DISABLE_PEAK_DIFF_LIMIT")) maxHeadPosition = 2*MAX_HEAD_POSITION;
	       if(abs(_calculated_position) > maxHeadPosition)
	       {
	          #ifdef DEBUG 
	            cout << "head not peaked & new head position out of range - restarting procedure"
	                 <<endl;
	          #endif
	          _number_attempts = 0;
	          _back_to_initial_footage = false;
	          if(this->send_peak_heads_cmd(_current_guess_position, the_peak_heads_time_out))
	          {
	             ++_number_attempts;
	             ++_total_number_attempts;
	             current_state = request_headers;
		     ///cout << "peak_heads_cmds sent with arguments " << _nominal_position << ", " 
		     ///<< _nominal_position_offset << ", " << the_peak_heads_time_out 
		     ///<< ". Entering request_headers state" << endl;
		     cout << "***Peak Head command requested (case check_headers-1)" << _current_guess_position << ". Entering request_headers state" << endl;

	          }
	          else return -1;
	          
	          #ifdef DEBUG 
	            cout << "peak_heads_cmds sent. Entering request_headers state" <<endl;
	          #endif
	          break;
	        }
	       
	        if(_total_number_attempts == MAX_PEAK_HEAD_ATTEMPTS && _back_to_initial_footage)
	        {
	          #ifdef DEBUG 
	            cout << "head not peaked - returning to initial footage. Entering wait_for_footage state"
	                 <<endl;
	          #endif
		    //_number_attempts = 0;
		  _back_to_initial_footage = false;//do this once only??????
	       	  //stop dpu
	       	  if(!_init_proc->start_dpu(false)) return -1;
	       	  //return to nominal footage
	       	  if(!this->go_to_start_footage()) return -1;
	       	  current_state = wait_for_footage;
		  break;
	        }
		else if(_total_number_attempts > MAX_PEAK_HEAD_ATTEMPTS * 2)//ie 12
		  {
		    //give up
		    #ifdef DEBUG 
	               cout << "unable to peak head - giving up" << endl;
	            #endif
		    peakFile.open(_init_proc->peakFilename, ios::app);
		    if (peakFile) {
		      peakFile << "Unable to peak head - giving up" << endl;
		      peakFile.close();
		    }
		    _init_proc->do_abort();
		    _init_proc->do_exit_to_mounted(SU_Control_Error_Codes::Peak_Heads_Exception);
		    return -1;
		  }
		    
	       
	        if(this->send_peak_heads_cmd(_calculated_position, the_peak_heads_time_out))
	        {
		  ++_number_attempts;
		  ++_total_number_attempts;
		  current_state = request_headers;
		  //#ifdef DEBUG 
	          //  cout << "head not peaked - sending a new peak_head cmd. Entering request_headers state"
	          //       <<endl;
	          //#endif
		  ///cout << "peak_heads_cmds sent with arguments " << _calculated_position << ", " 
		  ///<< the_peak_heads_time_out 
		  ///<< ". Entering request_headers state" <<endl;
		  cout << "***Peak Head command requested (case check_headers-2)" << _calculated_position << ". Entering request_headers state" << endl;

	        }
	        else return -1;
	    }
	    else break;// wait for another message
	 }//end case (check_headers)
	 
      case (wait_for_footage) :
	 {
	 	//wait for tape_at_footage AS
	 	if(_init_proc->in_response_queue(SU_Action_Status::Tape_At_Footage))
	 	{
	 	   delete _init_proc->response_iter->contents()->get_msg();
	 	   delete _init_proc->response_queue.remove(_init_proc->response_iter);
	 	   //if(!_init_proc->set_dpuspeed(true)) return -1; 
	 	   if(!_init_proc->start_dpu(true)) return -1;
	 	   if(this->send_peak_heads_cmd(_calculated_position, the_peak_heads_time_out))
	 	   {
	 	      ++_number_attempts;
	 	      ++_total_number_attempts;
	 	      current_state = request_headers;
		      #ifdef DEBUG 
	                 cout << "Tape at start footage - sending a new peak_head cmd. Entering request_headers state" <<endl;
			 ///cout << "peak_heads_cmds sent with arguments " << _calculated_position << ", " 
			 ///<< the_peak_heads_time_out 
			 ///<< ". Entering request_headers state" << endl;
			 cout << "***Peak Head command requested (case wait_for_footage)" << _calculated_position << ". Entering request_headers state" << endl;
	              #endif
	           }
	           else return -1;
	        }
	        break;
	}
	 
   }//end switch
   
   return 0;
}

//______________________________________________________________________

bool Peak_Head::send_peak_heads_cmd(const int head_position, unsigned int the_peak_heads_time_out)
{
   head_pstion head_pos[1];//to define head positions
   ofstream peakFile;

   #ifdef DEBUG 
     cout << " Requested head_position (microns) = " << head_position / 10 << endl;
   #endif
   
   peakFile.open(_init_proc->peakFilename, ios::app);
   if (peakFile) {
     peakFile << "Requested head " << _head_nr << " position = " 
	      << head_position / 10 << " um" << endl;
     peakFile.close();
   }

   ///050207fmo patch START
   ///head_pos[0][0] = _head_nr;//head # 
   if (!_init_proc->swap_head)
     {
       head_pos[0][0] = _head_nr;//head # 
       head_pos[0][2] = _track_nr;//peaks on track track_nr
     }
   else
     {
       head_pos[0][0] = 3 - _head_nr;
       if (_track_nr >= 36) head_pos[0][2] = _track_nr - 36;//peaks on track track_nr
     }
   ///050207fmo patch END
   head_pos[0][1] = head_position;//in units of 0.1 micron
   //   head_pos[0][2] = _track_nr;//peaks on track track_nr
   head_pos[0][3] = 230;//movement range in 0.1 micron
   cout << "Peak_Head::send_peak_heads_cmd() - head_pos[0][0...3] = " << head_pos[0][0] << "," << head_pos[0][1] << "," << head_pos[0][2] << "," << head_pos[0][3] << endl;
   
   Command_Message *cmd = 0;
   Table_Data *table1 = 0;
   Peak_Heads_1_Aux *aux_table = 0; 
   General_CCC_Table *gen_tab1 = 0;
   
   //form peak heads command and send to SU
   //temp send only Table_1 and aux table
   if(!(cmd = _init_proc->form_command(SU_Station_Unit_Cmds::Peak_Heads)) || 
      !(table1 = new Peak_Heads_1_Table(head_pos, 1)) ||
      !(aux_table = new Peak_Heads_1_Aux(the_peak_heads_time_out)) ||
      !(gen_tab1 = new General_CCC_Table(SU_Table_Types::Tape_Hd_Peak_Param, table1, aux_table)) ||
      !(cmd->add_table(gen_tab1)) 
     ) 
   {
      delete gen_tab1; 
      delete table1; 
      delete aux_table;
      delete cmd;
      gen_tab1 = 0;
      table1 = 0;
      aux_table;
      cmd = 0;


      _init_proc->do_abort();
      _init_proc->do_exit_to_mounted(SU_Control_Error_Codes::Memory_Allocation_Exception);
      return false;
   }
   else
   {
      _peak_hd_cmd_id = (unsigned int)cmd->get_msg_id();
      
      if(_init_proc->transmit_to_SU(cmd))
      {
	 delete cmd;
	 cmd = 0;
	 return true;
      }
      else
      {
	 delete cmd;
	 cmd = 0;
	 _init_proc->do_exit_to_mounted(SU_Control_Error_Codes::SU_Connection_Exception);
	 return false;
      }
   }
}

//________________________________________________________________________________________

bool Peak_Head::send_req_tpe_frm_hdr(void)
{
   Command_Message *cmd = 0;
   Table_Data *table1 = 0;
   General_CCC_Table *gen_tab1 = 0;
   
   cmd = _init_proc->form_command(SU_Station_Unit_Cmds::Req_Medium_Frme_Hdr);
   
   if(!cmd)
   {
      _init_proc->do_abort();
      _init_proc->do_exit_to_mounted(SU_Control_Error_Codes::Memory_Allocation_Exception);
      return false;
   }
   
   _req_tpe_frm_hdr_id = (unsigned int)cmd->get_msg_id();
   int index;
   _req_tpe_frm_hdr_count = 0;
   
   //if(_logical_head_nr == 0) index = 0; //ie get header from trm 0, 1, 2
   //else index = 32;//ie get header from trm 32, 33, 34
   
   // Request three valid headers from any TRM
   for(int i = 0; i < 3; ++i)
   {
      if((table1 = new Req_Medium_Frame_Header_Table(0xFFFFFFFF)) &&
	 (gen_tab1 = new General_CCC_Table(SU_Table_Types::Medium_Frame_Hd_Req, table1, 0)) && 
	 cmd->add_table(gen_tab1))
      {
	 if(_init_proc->transmit_to_SU(cmd))
	 {
	    ++_req_tpe_frm_hdr_count;
	    delete (cmd->remove_table(SU_Table_Types::Medium_Frame_Hd_Req));
	    table1 = 0;
	    gen_tab1 = 0;
	 }
	 else
	 {
	    delete cmd; 
	    cmd = 0;
	    table1 = 0;
	    gen_tab1 = 0;
	    _init_proc->do_exit_to_mounted(SU_Control_Error_Codes::SU_Connection_Exception);
	    return false;
	 }
      }
      else
      {
	 delete gen_tab1;
	 gen_tab1 = 0;
	 delete table1;
	 table1 = 0;
	 delete cmd; 
	 cmd = 0;
	 _init_proc->do_abort();
	 _init_proc->do_exit_to_mounted(SU_Control_Error_Codes::Memory_Allocation_Exception);
	 return false;
      }
   }
   
   delete cmd;
   cmd = 0;
   table1 = 0;
   gen_tab1 = 0;
   
   return true;
}

//___________________________________________________________________________________

void Peak_Head::do_head_not_peaked(void)
{
  //if(((Medium_Frame_Header_Data *) _init_proc->response_iter->contents()->get_msg())->get_track_number() != -1 &&
  if (this->get_dead_reckon_movement())
   {
      #ifdef DEBUG 
         cout << "head on readable track" <<endl;
      #endif
      // Restart the fish bone search. Change the initial direction
      // the search goes in to help avoid endless loops when you find
      // a good track one the first fishbone step but the requested
      // track is then not found
      _number_attempts = 0;
      if (initial_fishbone_direction)
	initial_fishbone_direction = 0;
      else
	initial_fishbone_direction = 1;
   }
   else
   {
      //not peaked on any readable track or one of correct pass - do a fishbone search
      //try moving head by a (track + guard_band) width which in VLBA == 48 microns
      //and in MkIII/IV == 55 microns - this implies that the allowed search range 
      //can reasonably == 40 microns
      
     // _total_number of attempts will be 1 or greater always. Adding
     // 1 and dividing by 2 ensures the sequence 1,2,3,4,5... becomes
     // 1,1,2,2,3...  So we then get step of equal size positive then
     // negative (the initial positive or negative step changes each
     // time we do a dead_reckon step

      if(_number_attempts % 2 == initial_fishbone_direction)
	_calculated_position = _current_guess_position
	                       + (400 * (_number_attempts/2)) + 400;
      else
	_calculated_position = _current_guess_position
	                       - (400 * (_number_attempts/2));
   }
}

//______________________________________________________________________________________________

bool Peak_Head::get_dead_reckon_movement(void)
{
   unsigned int aux_dat_0 = 0, aux_dat_1 = 0;
   //for now use first good header
   
   int i;
   for(i = 0; i < 3; ++i)
   {
      if(header[i] && header[i]->get_track_number() != -1) break;
   }
   
   if(i > 2 || header[i] == 0 || header[i]->get_track_number() == -1) return false;
   
   int_16 header_data[20];
   int diff = 0;//difference in reqd head pos
   unsigned long day, hours, mins, secs; 
   ieee_dbl systicks;
   Scan *next_scan;
  
   //get the actual header data
   
   if(header[i]->get_medium_frame_header(header_data))
   {

     aux_dat_0 |= (header_data[12]&0xff)<<24;
     aux_dat_0 |= (header_data[13]&0xff)<<16;
     aux_dat_0 |= (header_data[14]&0xff)<<8;
     aux_dat_0 |= (header_data[15]&0xff);
	 
     aux_dat_1 |= (header_data[16]&0xff)<<24;
     aux_dat_1 |= (header_data[17]&0xff)<<16;
     aux_dat_1 |= (header_data[18]&0xff)<<8;
     aux_dat_1 |= (header_data[19]&0xff);

      //get time codes
      if(_init_proc->the_tape_format == MkIIIA || _init_proc->the_tape_format == MkIV)//MK III or MK IV
      {
	 day = (header_data[4]&0xf) * 100 + ((header_data[5]>>4)&0xf) * 10 + (header_data[5]&0xf);
	       
	 hours = ((header_data[6]>>4)&0xf) * 10 + (header_data[6]&0xf);
	
	 mins = ((header_data[7]>>4)&0xf) * 10 +  (header_data[7]&0xf);
	 
	 secs = ((header_data[8]>>4)&0xf) * 10 + (header_data[8]&0xf);
	    
	 secs = secs + mins * 60 + hours * 60 * 60 + (day -1) * 86400;
	 
	 systicks = SYSTEM_RATE * secs;
      }
      
      if(_init_proc->the_tape_format == VLB)//vlba
      {
	       //the time code is in bcd code - see Mk IV Memo 230
	       unsigned long mjdd;	   /* Modified Julian date in days */
	       
	       //first get base date
	       int year = (int) _init_proc->cjd->get_obs_TOT_start().get_base_date();
	       int month = 1;//January
	       day = 1;
	       
	       mjdd = (((1461 * (year - (12 - month) / 10 + 4712)) / 4
			+ (306 * ((month + 9) % 12) + 5) / 10
			- (3 * ((year - (12 - month)/10 + 4900) / 100)) / 4
			+ day - 2399904));
	       //should return the mjd (in days) at 00.00 on 1/1/year - now get 3 least significant digits
	       mjdd = mjdd % 1000;
	       
	       //get MJD (days) from header - least significant 3 digits anyway!
	       day = ((header_data[4]>>4)&0xf) * 100 + 
		      (header_data[4]&0xf) * 10 + 
		      ((header_data[5]>>4)&0xf);
	       
	       //get elapsed days from mjdd
	       if (mjdd > day) day += 1000;

	       day = day - mjdd;
	       
	       //now get seconds into day
	       
	       secs = (header_data[5]&0xf) * 10000 + 
		      ((header_data[6]>>4)&0xf) * 1000 + 
		      (header_data[6]&0xf) * 100 + 
		      ((header_data[7]>>4)&0xf) * 10 + 
		      (header_data[7]&0xf); 
		  
	      systicks = SYSTEM_RATE * ((day * 86400) + secs);
      }
	 
      
      //look in other scans for a start/stop TOT with secs within range
      
      _init_proc->scans->iterator().reset();//point to first scan
      string this_pass = _init_proc->current_scan->get_pass_number();

      do{
	next_scan = &((Scan &) _init_proc->scans->iterator().current());
	
	//have to check that scans are of different passes
	string other_pass = next_scan->get_pass_number();
	
	if ((this_pass != other_pass) &&
	    next_scan->get_start_TOT() <= systicks && 
	    next_scan->get_stop_TOT() >= systicks)
	  {
	    diff = (int)_actual_position - static_cast<int>(next_scan->get_headgroup_offset(_logical_head_nr) * 10);
	    //in 0.1microns
 	    cout << "Found offset " << diff/10 << " micron on head pass " 
                 << other_pass << endl;
	    break;
	  }
      }while(_init_proc->scans->iterator().next());//if a next scan
      _init_proc->scans->iterator().reset();


      // Check we should be dead-reckoning on this headstack...
      if (corr_head >=0) { // == -1 if we should ignore it
	int recorded_headstack = (aux_dat_1 & 0xC0000000)>>30; // Grab the right bits
	if (recorded_headstack != corr_head) {
	  cout << "DEBUG: NOT dead-reckoniong on wrong recorded headstack"  << endl;
	  return false;
	}
      } 
	 
      if(diff == 0)
      {
	 cout << "Search unsuccessfull" << endl;
	 return false;//ie search unsuccessfull
      }
      if(abs(diff) > 4000)
	{
	  if (!getenv("DISABLE_PEAK_DIFF_LIMIT"))
	    {
	      cout << "diff is too great (>400um)" << endl;
	      return false;//diff is too great
	    }
	}
      _calculated_position = _nominal_position + diff;//in 0.1 micron units
      _current_guess_position = _calculated_position;
      return true;
   }
   else return false;
}

//______________________________________________________________________________________________

bool Peak_Head::is_header_good(void)const
{
   //obtain a majority vote  
   int i, j; //counter
   bool good[3];
   ofstream peakFile;
   
   for(i = 0; i < 3; ++i)
   {
      if(header[i] == 0 || header[i]->get_track_number() == -1) good[i] = false;
      else good[i] = true;
   }
   
   for(i = 0; i < 3; ++i)
   {
      if(good[i] == true) break;
   }
   
   if(i > 2 || good[i] == false) {
     cout << " No readable headers" << endl;
     peakFile.open(_init_proc->peakFilename, ios::app);
     if (peakFile) {
       peakFile << "No readable headers for head " << _head_nr << endl;
       peakFile.close();
     }

     return false;

   }
   
   int_16 header_data[20];
   unsigned int aux_dat_0 = 0, aux_dat_1 = 0;
   int track_nr;//track_nr is really the TRM I/P number!
   unsigned long day, hours, mins, secs = 31622400;//366 days!
   bool result = false;
   ieee_dbl start_TOT, end_TOT, systicks;
   string pass_number;
   
   for(i = 0; i < 3; ++i)
   {
      if(good[i] == false) continue;
      
      track_nr = (int)(header[i]->get_track_number());//TRM I/P
   		//small enough < 64 to convert safely
      //get the actual header data
      
      if(header[i]->get_medium_frame_header(header_data))
      {
	 aux_dat_0 = 0;
	 aux_dat_1 = 0;

	 aux_dat_0 |= (header_data[12]&0xff)<<24;
	 aux_dat_0 |= (header_data[13]&0xff)<<16;
	 aux_dat_0 |= (header_data[14]&0xff)<<8;
	 aux_dat_0 |= (header_data[15]&0xff);
	 
	 aux_dat_1 |= (header_data[16]&0xff)<<24;
	 aux_dat_1 |= (header_data[17]&0xff)<<16;
	 aux_dat_1 |= (header_data[18]&0xff)<<8;
	 aux_dat_1 |= (header_data[19]&0xff);
	       
          //check the_aux_data[NUM_CHANNELS][NUM_TRACKS][2] wrt header_data - taking into account the_mask[2]
	 //bitwise AND the_mask[0] & aux_dat_0 == the_aux_data[i][track_nr][0]
	 for(j = 0; j < NUM_CHANNELS; ++j)
	 {
	    if(((_init_proc->the_mask[0]&aux_dat_0)) == 
	       (_init_proc->the_mask[0]&_init_proc->the_aux_data[j][track_nr][0]) &&
	       ((_init_proc->the_mask[1]&aux_dat_1)) == 
	       (_init_proc->the_mask[1]&_init_proc->the_aux_data[j][track_nr][1]))
	    {
	       //a match!
	       result = true;
	       break;
	    }
	 }
	 
	 // Ignore headers from the "wrong" Headstack
	 if (corr_head >=0) { // == -1 if we should ignore it
	   int recorded_headstack = (aux_dat_1 & 0xC0000000)>>30; // Grab the right bits
	   cout << "DEBUG: This header is from headstack " << recorded_headstack << endl;

	   if (recorded_headstack != corr_head) {
	     result = false;
	     cout << "Rejecting Header from wrong recorded headstack (" 
		  << recorded_headstack << " | " << corr_head << ")" << endl;
	   } else {
	     cout << "DEBUG: Headstack number is the one we want" << endl;
	   }
	 }

	 if(result)
	 {
	    //ok the aux data matches, but how about the time code? -it must be within the scans range
	 
	    if(_init_proc->the_tape_format == MkIIIA || _init_proc->the_tape_format == MkIV)//MK III or MK IV
	    {
	       //the time code is in bcd code - see Mk IV Memo 230
	       
	       day = (header_data[4]&0xf) * 100 +
		      ((header_data[5]>>4)&0xf) * 10 +
		      (header_data[5]&0xf);
	       
	       hours = ((header_data[6]>>4)&0xf) * 10 + 
		       (header_data[6]&0xf);
		  	       
	       mins = ((header_data[7]>>4)&0xf) * 10 + 
		      (header_data[7]&0xf);
	       
	       secs = ((header_data[8]>>4)&0xf) * 10 + 
		      (header_data[8]&0xf);
	       
	       #ifdef DEBUG 
	           cout << "Day " << day << ", hour " << hours << ", min " 
			<< mins << ", sec " << secs << endl;
	       #endif
		   
	       peakFile.open(_init_proc->peakFilename, ios::app);
	       if (peakFile) {
		 peakFile << "Head " << _head_nr << ": Day " << day << ", hour "
			  << hours << ", min " << mins << ", sec " << secs 
			  << endl;
		 peakFile.close();
	       }
	       
	       secs = secs + mins * 60 + hours * 60 * 60 + (day -1) * 86400;
	       systicks = secs * SYSTEM_RATE;
	    }
	    
	    if(_init_proc->the_tape_format == VLB)//vlba
	    {
	       //the time code is in bcd code - see Mk IV Memo 230
	    
	       unsigned long mjdd;	   /* Modified Julian date in days */
	        
	       //first get base date
	       int year = (int) _init_proc->cjd->get_obs_TOT_start().get_base_date();
	       int month = 1;//January
	       day = 1;
	       
	       mjdd = (((1461 * (year - (12 - month) / 10 + 4712)) / 4
			+ (306 * ((month + 9) % 12) + 5) / 10
			- (3 * ((year - (12 - month)/10 + 4900) / 100)) / 4
			+ day - 2399904));
	       //should return the mjd (in days) at 00.00 on 1/1/year - now get 3 least significant digits
	       mjdd = mjdd % 1000;
	       
	       //get MJD (days) from header_data - least significant 3 digits anyway!
	       day = ((header_data[4]>>4)&0xf) * 100 + 
		      (header_data[4]&0xf) * 10 + 
		      ((header_data[5]>>4)&0xf);
	       
	       //get elapsed days from mjdd
	       if(mjdd > day)//ie if mjdd + days to date > 1000
	       {
		  day = day + 1000 - mjdd;
	       }
	       else
	       {
		  day = day - mjdd;
	       }
	       
	       //now get seconds into day
	       
	       secs = (header_data[5]&0xf) * 10000 + 
		      ((header_data[6]>>4)&0xf) * 1000 + 
		      (header_data[6]&0xf) * 100 + 
		      ((header_data[7]>>4)&0xf) * 10 + 
		      (header_data[7]&0xf); 
		  
	       systicks = SYSTEM_RATE * ((day * 86400) + secs);

	       #ifdef DEBUG 
	       cout << "Day " << day + 1 << ", sec " << secs << "  (" 
		    <<  Short_Time_Value(systicks).get_rot_string() 
		    << ")" << endl;
	       #endif
		      

	       peakFile.open(_init_proc->peakFilename, ios::app);
	       if (peakFile) {
		 peakFile << "Head " << _head_nr << ": Day " << day + 1 
			  << ", sec " << secs << "  (" 
			  <<  Short_Time_Value(systicks).get_rot_string() 
			  << ")" << endl;
		 peakFile.close();
	       }
	    }
	    
	    ///if(_init_proc->current_scan->get_pass_number(pass_number) &&
	    pass_number = _init_proc->current_scan->get_pass_number();
	    if (!pass_number.empty() && 
	       _init_proc->current_medium->get_pass_TOTs(pass_number, start_TOT, end_TOT))
	    {
              //#ifdef DEBUG
	      //cout << "      TOT is " << Short_Time_Value(systicks).get_rot_string() << endl;
	      //cout << "start_TOT is " << Short_Time_Value(start_TOT).get_rot_string() << endl;
	      //cout << "  end_TOT is " << Short_Time_Value(end_TOT).get_rot_string() << endl;
	      //cout << "pass_number = " << pass_number << endl;
              //#endif

	       if(start_TOT <= systicks && end_TOT >= systicks)
	       {
		 cout << "header data within pass " << pass_number << endl;
		 good[i] = true;

		 peakFile.open(_init_proc->peakFilename, ios::app);
		 if (peakFile) {
		   peakFile << "header data within pass " << pass_number << endl;
		   peakFile.close();
		 }

	       }
	       else
	       {
		 cout << "header data not within pass " << pass_number << endl;
		 good[i] = false;

		 peakFile.open(_init_proc->peakFilename, ios::app);
		 if (peakFile) {
		   peakFile << "header data not within pass " << pass_number 
			    << endl;
		   peakFile.close();
		 }
	       }
	    }
	    else
	    {
	       //a problem
	       #ifdef DEBUG 
	            cout << "Error in Peak_Head::is_header_good(). Wrong pass number" <<endl;
               #endif
	       good[i] = false;
	    }
	 }//end if aux data matches
	 else
	 {
	    good[i] = false;
	    cout << "Aux Data incorrect" << endl; 
	 }
      }//end if header_data
      else
      {
	cout << "No data for header " << i << endl;
	 good[i] = false;
      }
   }//end for each i (header)
   
   //now check if at least 2 of good are true
   int count = 0;
   for(i = 0; i < 3; ++i)
   {
      if(good[i] == true) ++count;
   }
   
   // At least two headers must be good
   if(count > 1)
   {
      #ifdef DEBUG 
         cout << "Head peaked" <<endl;
      #endif
      peakFile.open(_init_proc->peakFilename, ios::app);
      if (peakFile) {
	peakFile << "Head peaked" << endl;
	peakFile.close();
      }

      return true;
   }
   else {
     cout << "header data not within pass " << pass_number << endl;
     return false;
   }
}

//_____________________________________________________________________________________________

bool Peak_Head::go_to_start_footage(void)const
{
   int   the_initial_tape_direction = 1;
   short reqd_tape_ftg = (short)(_init_proc->current_scan->get_start_footage());
   
   if(_init_proc->current_scan->get_tape_direction() == forward) the_initial_tape_direction = 1;
   else the_initial_tape_direction = 0;
   
   int the_tape_ftg_time_out = 600;
   
   //now posn to reqd footage - if the_initial_tape_direction 
   //== 1 (fwd) then we want to add to the nominal start footage,
   // otherwise subtract
   
   if(_init_proc->current_scan->get_tape_direction() == forward)
   {
      reqd_tape_ftg = reqd_tape_ftg + TTT_OFFSET;
   }
   else
   {
      reqd_tape_ftg = reqd_tape_ftg - TTT_OFFSET;
   }
   
   if(_init_proc->pos_tape_to_footage(reqd_tape_ftg, the_tape_ftg_time_out)) return true;
   else return false;
} 
