//su_cmd.C
//
//SU_CONTROL application - SU_CONTROL command channel
//JIVE, May 1996

//_________________________________________________________________________

//for RCS

//$Header: /export/home/jive_cvs/JCCS/CVS_Repository/su_control/source/su_cmd.C,v 3.9 2009/03/20 07:24:10 jive_cc Exp $

//$Locker:  $

//$Log: su_cmd.C,v $
//Revision 3.9  2009/03/20 07:24:10  jive_cc
//BE: added/changed some communication between SU control and processing job
//
//Revision 3.8  2008/04/09 11:44:31  jive_cc
//BE: first version of mark5b control, also added the possibility to use the spare mk5b for production
//
//Revision 3.7  2007/10/05 11:28:06  jive_cc
//BE: station reconnect, also contains (1) auto bank switching (during configuration only), (2) reduced evlbi startup delay, (3) evlbi params in database are queried on-the-fly, (4) data handler DTD gathering using dummy data, (5) automatic data status monitor statup (for evlbi experiments), (6) unfinished spacecraft tracking mode
//
//Revision 3.6  2005/12/23 13:16:55  verkout
//HV: Phew. This is the big thing. Merged all developments with both the port to Linux and the mods needed for a byte-order safe COF
//
//Revision 3.4.4.1  2005/10/25 15:02:12  verkout
//HV: Merge with main branch. May need fixes in order to compile on jaw0/HP-UX
//
//Revision 3.5  2005/09/30 12:31:49  jive_cc
//Arpad: e-VLBI enabled version
//
//Revision 3.4  2004/06/25 13:21:48  verkout
//gnu3.2 version: many many MANY way too many changes
//
//Revision 3.3  2003/05/15 11:46:35  jive_cc
//Arpad: merged MarkV version into main
//
//Revision 3.0.2.2  2003/05/14 10:04:06  jive_cc
//Arpad: changed tape_handler to medium_handler, many cosmetic changes
//
//Revision 3.0.2.1  2003/01/13 15:09:26  jive_cc
//*** empty log message ***
//
//Revision 3.0  2002/04/17 14:45:45  jive_cc
//Included gnu branch
//
//Revision 1.19.4.1  2002/01/07 15:51:40  jive_cc
//Friso and Arpad: many many MANY pointers were explicitely set to zero after being deleted to avoid memory problems caused by double deletions
//
//Revision 1.19  1999/08/30 09:46:42  jive_cc
//back to start footage once only
//
//Revision 1.18  1999/03/02 15:13:14  pwm
//ignore pre initialisation msgs
//
//Revision 1.17  1999/02/16 18:21:03  pwm
//added poll delay
//
//Revision 1.16  1999/02/08 12:45:48  jive_cc
//various mods at jive
//
//Revision 1.15  1999/01/29 16:07:16  pwm
//Integrated peaking branch into root
//
//Revision 1.14  1999/01/13 15:06:02  pwm
//minor mod to for tape ops
//
//Revision 1.13  1999/01/13 14:14:26  pwm
//implemented tape operations
//
//Revision 1.12.2.3  1999/01/19 15:44:07  pwm
//added location_broker
//
//Revision 1.12.2.2  1998/11/19 15:33:28  pwm
//change in SU_Control_Status msg
//
//Revision 1.12.2.1  1998/10/09 16:45:36  pwm
//tidy up
//
//Revision 1.12  1998/08/26 21:08:58  jive_cc
//minor correction
//
//Revision 1.11  1998/08/26 21:04:22  jive_cc
//arghll!
//
//Revision 1.9  1998/07/15 09:12:50  jive_cc
//Changes to detecting rotclock host
//
//Revision 1.8  1998/07/01 12:21:15  pwm
//many minor corrections, updated transmit_tape_status() as reqd
//
//Revision 1.7  1998/06/30 12:41:48  jive_cc
//Added some more informative messages when TCP connections fail
//
//Revision 1.6  1998/05/25 13:01:58  jive_cc
//Use environment variable ROT_HOST by default for rotclock host. Defaults
//to ROTHOST in su_defs.h
//
//Revision 1.5  1998/02/23 16:03:48  klijn
//dded service to listen to ROT clock broadcasts
//
//Revision 1.4  1998/01/26 20:22:42  pwm
//added service manager
//
//Revision 1.3  1997/11/07 15:27:19  pwm
//Too many changes to list!
//
//Revision 1.2  97/06/09  18:30:10  18:30:10  pwm (Paul William Maguire)
//changes mainly reflecting changes in ccc_msg
//
//Revision 1.1  97/04/03  15:15:24  15:15:24  pwm (Paul William Maguire)
//Initial revision
//
//
//___________________________________________________________________________

#include <su_control/su_cmd.h>

   
using namespace std;
SU_Command_Channel::SU_Command_Channel(Thread_ID my_id, Thread_ID parent, Thread_Master *owner, unsigned int suid_code)
   :Thread(my_id, parent, owner),
    su_id(suid_code)
{
   init = false;
   su_controller = 0;
   pc_client = 0;
   sum_client = 0;
   th_server = 0;
   dh_client = 0;
   clk_client = 0;
   clkbrd_client = 0;
   pc_client_mgr = 0;
   sum_client_mgr = 0;
   th_server_mgr = 0;
   dh_client_mgr = 0;
   clk_client_mgr = 0;
   clkbrd_client_mgr = 0;
}

SU_Command_Channel::~SU_Command_Channel()
{
  cout << "~SU_Command_Channel" << endl;
}

void SU_Command_Channel::set_local_time(void)
{
   //set local time
   
   ieee_dbl sysclks;
   
   gettimeofday(&tod, &tzp);
     
   time_t t((long)(tod.tv_sec));
   
   tm *temp = gmtime(&t);
   sysclks = SYSTEM_RATE * (temp->tm_yday*24*60*60 + temp->tm_hour*60*60 + temp->tm_min*60 + temp->tm_sec);
   
   local_time.set_sysclks(sysclks);
   local_time.set_base_date(temp->tm_year < 90 ? 2000 + temp->tm_year : 1900 + temp->tm_year);
}
      
int SU_Command_Channel::run()
{  
   if(!init) return 1;
   
   this->handle_messages();
   
   return 0;
}

bool SU_Command_Channel::initialise(SU_Controller *suc)
{   
   Connection *target;
   su_controller = suc;
   
   //create the required service - in this case a client is required
   
   //connections to PROCESSOR_CONTROL - SU_CONTROL == client
   Service_ID su_command_channel_1("PROCESSOR_CONTROL_SERVICE", &All_EVN42_Msgs);
   //this is a client so its id doesn't matter / need be known
   
   if((pc_client = new Service_Client(su_command_channel_1)) &&
      (pc_client_mgr = new Service_Manager(*get_controller(), get_id(), *pc_client, pc_client_interface)) &&
      this->open_P_C_Connection())
   {
      pc_client->set_poll_delay(0, 1);
      pc_client_interface.set_receive(true); //ie handle incoming messages
      get_controller() -> add_thread(pc_client_mgr);
   }
   else
   {
      return false;
   }
   
   //define service identities 

   //connections to su_monitor - SU_CONTROL == client
   Service_ID su_command_channel_2("SU_MONITOR_SERVICE", &All_EVN42_Msgs);
   
   //connections to ROT_CLOCK - SU_CONTROL == client
   Service_ID su_command_channel_4("ROT_CLOCK_SERVICE", &All_EVN42_Msgs); 

   //connections to DATA_HANDLER_ - SU_CONTROL == client
   Service_ID su_command_channel_5("DATA_HANDLER_SERVICE", &All_EVN42_Msgs);
   
   //connections to ROT_CLOCK_PROXY - SU_CONTROL == client
   Service_ID su_command_channel_6("ROT_CLOCK_BRDCAST_SERVICE", &All_EVN42_Msgs); 
   
   //server for medium handlers - id depends on su_id
   Service_ID *su_command_channel_3 = location_if.get_service_id(suc_th_servtypes[su_id]);
   
   if(su_command_channel_3 &&
      (sum_client = new Service_Client(su_command_channel_2)) &&
      (sum_client_mgr = new Service_Manager(*get_controller(), get_id(), *sum_client, sum_client_interface)) &&
      this->open_SUM_Connection() &&
      (dh_client = new Service_Client(su_command_channel_5)) &&
      (dh_client_mgr = new Service_Manager(*get_controller(), get_id(), *dh_client, dh_client_interface)) &&
      (clk_client = new Service_Client(su_command_channel_4)) &&
      (clk_client_mgr = new Service_Manager(*get_controller(), get_id(), *clk_client, clk_client_interface)) &&
      su_command_channel_3 &&
      (th_server = new Service_Server(*su_command_channel_3)) &&
      (th_server_mgr = new Service_Manager(*get_controller(), get_id(), *th_server, th_server_interface)) &&
      (clkbrd_client = new Service_Client(su_command_channel_6)) &&
      (clkbrd_client_mgr = new Service_Manager(*get_controller(), get_id(), *clkbrd_client, clkbrd_client_interface))
      )
   {
      sum_client->set_poll_delay(0, 1);
      dh_client_interface.set_receive(true); //ie handle incoming messages
      get_controller() -> add_thread(dh_client_mgr);
      sum_client_interface.set_receive(true); //ie handle incoming messages
      get_controller() -> add_thread(sum_client_mgr);
      clk_client_interface.set_receive(true); //ie handle incoming messages
      get_controller() -> add_thread(clk_client_mgr);
      th_server->create_listener(Connection_ID::unix_sock);
      th_server_interface.set_receive(true); //ie handle incoming messages
      th_server_interface.set_server_handling(true);
      location_if.register_server(suc_th_servtypes[su_id], su_id);
      get_controller() -> add_thread(th_server_mgr);
      clkbrd_client_interface.set_receive(true); //ie handle incoming messages
      get_controller() -> add_thread(clkbrd_client_mgr);
      init = true;
   }
   else
   {
      target = this->get_connection(PROCESSOR_CONTROL);//safer than directly accessing class member
      
      if(target != 0) this->transmit_error(target, PROCESSOR_CONTROL_ID, 
					   SU_Control_Error_Codes::Command_Channel_Exception,
					   CCC_Action_Request::Init_SU_Control);
      //transmit error message to PROCESSOR_CONTROL 
      return init;
   }  
   
   if(!(this->open_ROT_CLOCK_Connection()))
   {
      //failed to open connections
      #ifdef DEBUG 
	  cout << "failed to open rotclock_conns. Exiting to mounted state" <<endl;
      #endif
      
      target = this->get_connection(PROCESSOR_CONTROL);//safer than directly accessing class member
      
      if(target != 0) this->transmit_error(target, PROCESSOR_CONTROL_ID, 
					   SU_Control_Error_Codes::ROT_Clock_Conn_Exception,
					   CCC_Action_Request::Init_SU_Control);
      //transmit error message to PROCESSOR_CONTROL 
      init = false;
   }
   return init;
}

bool SU_Command_Channel::open_P_C_Connection(void)
{
  Connection_ID *connid = location_if.find_server(PC_STAT);
   
  if(connid && pc_client->connect(*connid))return true;
  else
  {
    cerr << "Failed to connect to P_C" << endl;
    return false;
  }
}

bool SU_Command_Channel::open_SUM_Connection(void)
{
   Connection_ID *connid = location_if.find_server(SUM_STAT);
   
   if(connid && sum_client->connect(*connid)) return true;
   else 
   {
     cerr << "Failed to connect to SUM" << endl;
     return false;
   }
}

bool SU_Command_Channel::open_DATA_HANDLER_Connection(int servtype)
{
   Connection_ID *connid = location_if.find_server(servtype);
   
   if(connid && dh_client->connect(*connid)) return true;
   else 
   {
     cerr << "Failed to connect to Data Handler" << endl;
     return false;
   }
}

bool SU_Command_Channel::open_ROT_CLOCK_Connection(void)
{
   Connection_ID *connid = location_if.find_server(ROT_REQ);
   
   if(connid == 0 || (!clk_client->connect(*connid)))
   {
     cerr << "Failed to connect to ROT_CLOCK" << endl;
     return false;
   }
   
   connid = location_if.find_server(ROT_PROXY);
   
   if(connid && clkbrd_client->connect(*connid)) return true;
   else 
   {
     cerr << "Failed to connect to ROT_CLOCK_BRDCAST_SERVICE" << endl;
     return false;
   }
}

int SU_Command_Channel::shutdown()
{
   return 0;
}

int SU_Command_Channel::quit()
{
  cout << "SU_Command_Channel quit" << endl;
   location_if.remove_server(suc_th_servtypes[su_id], su_id);
   clkbrd_client_interface.set_quit(true);
   dh_client_interface.set_quit(true);
   pc_client_interface.set_quit(true);
   sum_client_interface.set_quit(true);
   th_server_interface.set_quit(true);
   clk_client_interface.set_quit(true);
   this->set_stat(Thread::terminating);
   return 0;
}

bool SU_Command_Channel::handle_messages(void)
{

   Incoming_Message_Info* info;             // Incoming message/connection tuple
   
   enquiry_flag = false;//if an Enquiry cmd has already been queued to su_controller in this cycle

   for (info = dh_client_interface.get_incoming_iter().first();
        info;
        info = dh_client_interface.get_incoming_iter().advance())
   {
      this->check_message(info);
      
      // Take the message info off the 'incoming' list to stop this message
      // being handled again.
      
      dh_client_interface.get_incoming_iter().drop();
   }//end for
   
   for (info = pc_client_interface.get_incoming_iter().first();
        info;
        info = pc_client_interface.get_incoming_iter().advance())
   {
      this->check_message(info);
      pc_client_interface.get_incoming_iter().drop();
   }
   
   for (info = sum_client_interface.get_incoming_iter().first();
        info;
        info = sum_client_interface.get_incoming_iter().advance())
   {
      this->check_message(info);
      sum_client_interface.get_incoming_iter().drop();
   }
   
   for (info = th_server_interface.get_incoming_iter().first();
        info;
        info = th_server_interface.get_incoming_iter().advance())
   {
      this->check_message(info);
      th_server_interface.get_incoming_iter().drop();
   }
   
   for (info = dh_client_interface.get_incoming_iter().first();
        info;
        info = dh_client_interface.get_incoming_iter().advance())
   {
      this->check_message(info);
      dh_client_interface.get_incoming_iter().drop();
   }
   
   for (info = clk_client_interface.get_incoming_iter().first();
        info;
        info = clk_client_interface.get_incoming_iter().advance())
   {
      this->check_message(info);
      clk_client_interface.get_incoming_iter().drop();
   }
   
   for (info = clkbrd_client_interface.get_incoming_iter().first();
        info;
        info = clkbrd_client_interface.get_incoming_iter().advance())
   {
      this->check_message(info);
      clkbrd_client_interface.get_incoming_iter().drop();
   }
   
   return true;
}

bool SU_Command_Channel::check_message(Incoming_Message_Info* info)
{
   Connection* temp_conn;
   CCC_Msg* ccc_msg;
   Action_Status* msg;
   Command_Message *cmd_msg;
   unsigned int action_code, msg_id, msg_type, cmd_code;
   
   temp_conn = info->get_conn();
   
   ccc_msg = (CCC_Msg*) info->get_msg();
   
   //get action_code
   action_code = (unsigned int) ccc_msg->get_action_code();
   
   //get _msg_id
   msg_id = (unsigned int)ccc_msg->get_msg_id();
   
   //now obtain destination of message
   Msg_Handler_ID destination = ccc_msg->get_receiver_id();
   
   //get source
   Msg_Handler_ID source = ccc_msg->get_sender_id();
	 
   msg_type = (unsigned int)ccc_msg->get_message_type();
   
   //determine if its an action status
   if(msg_type == SU_Message_Types::Action_Status)
   {
      //at this point not interested in action status
      delete ccc_msg;
      delete info;
      ccc_msg = 0;
      info = 0;
      return true;
   }
   if (su_controller->use_mark5) cout << "yesssss" << endl;
   
   //if SU_CONTROL not initalised (or not a disconnect cmd), return error msg, delete ccc_msg and continue
   if(!(su_controller->initiated()))
   {
      if(msg_type == SU_Message_Types::Action_Request && action_code > SU_Action_Masks::Command_Message)
      {
	 //get cmd_code
	 cmd_code = ((Command_Message *) ccc_msg)->get_command_code();
	 
	 if(cmd_code != CCC_Action_Request::Disconn_SU_Control)
	 {
	    this->transmit_error(temp_conn, source, SU_Control_Error_Codes::Initialised_Exception,
				 action_code, msg_id);//transmit error message to originator
	    delete ccc_msg;
	    delete info;
	    ccc_msg = 0;
	    info = 0;
	    return true;
	 }
      }
      else
      {
	 //this->transmit_error(temp_conn, source, SU_Control_Error_Codes::Initialised_Exception,
	 //		      action_code, msg_id);//transmit error message to originator
	 delete ccc_msg;
	 delete info;
	 ccc_msg = 0;
	 info = 0;
	 return true;
      }
   }
   
   //if command message
   if(msg_type == SU_Message_Types::Action_Request && action_code > SU_Action_Masks::Command_Message)
   {
      //cast object to cmd_msg
      cmd_msg = (Command_Message*) ccc_msg;
   }
   else
   {
      if(su_controller->queue_cmd(info))
      {
	 return true;
      }
      else
      {
	 this->transmit_error(temp_conn, destination, SU_Control_Error_Codes::Command_Queuing_Exception,
			      action_code, msg_id);//transmit error message to originator
	 delete ccc_msg;
	 delete info;
	 ccc_msg = 0;
	 info = 0;
	 return true;
      }
   }
	 
   //get cmd_code
   cmd_code = cmd_msg->get_command_code();
   switch (cmd_code) {
   case (CCC_Action_Request::Enquire_SU_Control) :
     {
       //if SU_control is not already allocated and such a message has not been queued already,
       //then que the cmd to su_controller, else
       //form and transmit SU Control Status msg - have to query su_controller for parameters

       //       if(!su_controller->get_allocation() && !enquiry_flag)
       if(!enquiry_flag)
	 {
	   if(su_controller->queue_cmd(info))
	     {
	       enquiry_flag = true;
	     }
	   else
	     {
	       this->transmit_error(temp_conn, source, SU_Control_Error_Codes::Command_Queuing_Exception,
				    action_code, msg_id);
	       delete ccc_msg;
	       delete info;
	       ccc_msg = 0;
	       info = 0;
	     }
	   break;
	 }
       

       unsigned int status;
       if (su_controller->use_mark5) status = su_controller->transmit_disk_status();
       else status = su_controller->transmit_tape_status();
       
       if(status == -1)//no conn to sum
	 {
	   status = 0;
	   if(su_controller->is_mounted())
	     {
	       status += SU_Control_SU_Status_Codes::Medium_Mounted;
	     }

	   if(su_controller->get_allocation())
	     {
	       status +=  SU_Control_SU_Status_Codes::SU_Allocated;
	     }
	 }
       
       int_32 head_positions[4];
       su_controller->get_head_positions(head_positions);
       char medium_bar_code[MAX_NR_BANKS][MEDIUM_ID_LEN];
       for (int bank = 0; bank < MAX_NR_BANKS; bank++) {
	 strncpy(medium_bar_code[bank],su_controller->get_barcode(bank),MEDIUM_ID_LEN);
       }
       if(msg = new SU_Control_Status(su_controller->get_suid_code(),
				      medium_bar_code,
				      DPUType,
				      su_controller->get_DPU_id(),
				      status,
				      su_controller->get_allocation() ? su_controller->get_job_id() : 0,
				      su_controller->num_head_stacks,
				      head_positions))
	 {
	   this->set_local_time();
	   msg->set_sender_id(su_controller->get_SUC_ID());
	   msg->set_receiver_id(source);
	   msg->set_ref_id(msg_id);
	   msg->set_local_time(local_time);
	   msg->set_time_stamp(time_stamp);
	   msg->transmit(*temp_conn);
	   delete msg;
	   msg = 0;
	 }
       else
	 {
	   this->transmit_error(temp_conn, source, SU_Control_Error_Codes::Memory_Allocation_Exception,
				action_code, msg_id);
	 }
       delete ccc_msg;
       delete info;
       ccc_msg = 0;
       info = 0;
       break;
       
     }//end case
   
   default :
     //Queue message for delivery to Initalisation & control
     if(su_controller->queue_cmd(info)) break;
     else
       {
	 this->transmit_error(temp_conn, destination, SU_Control_Error_Codes::Command_Queuing_Exception,
			      action_code, msg_id);//transmit error message to originator
	 delete ccc_msg;
	 delete info;
	 ccc_msg = 0;
	 info = 0;
       }
     break;
   }//end switch
   return true;
}//end method

Connection* SU_Command_Channel::get_connection(int target)
{
   switch (target) {
      case (PROCESSOR_CONTROL) :
	 return pc_client->poll(0, Service_Client::ready_to_send);
      
      case (SU_MONITOR) :
	 return sum_client->poll(0, Service_Client::ready_to_send);
	 
      case (DATA_HANDLER) :
	 return dh_client->poll(0, Service_Client::ready_to_send);

      case (ROT_CLOCK) :
	 return clk_client->poll(0, Service_Client::ready_to_send);
	 	    
      default :
	 return 0;
   }
}

      
void SU_Command_Channel::transmit_error(Connection* target, Msg_Handler_ID dest_ID, unsigned int error_code,
					unsigned int command_code, unsigned int ref_id)
{
      //transmit error message to target
         this->set_local_time();
         error_msg.set_error_code(error_code);
   	 error_msg.set_local_time(local_time);  
   	 error_msg.set_time_stamp(time_stamp);
         error_msg.set_su_id(su_controller->get_suid_code());
	 error_msg.set_job_id(su_controller->get_job_id());
	 error_msg.set_sender_id(su_controller->get_SUC_ID());
	 error_msg.set_receiver_id(dest_ID);
	 error_msg.set_action_code(command_code);
	 error_msg.set_ref_id(ref_id);
	 if(target != 0) error_msg.transmit(*target);
}

void SU_Command_Channel::close_medium_handler_conns(void)
{
   Connection* temp_conn;
   
   while(temp_conn = th_server->poll(0,Service_Client::ready_to_send))
   {
      th_server->disconnect(*(temp_conn->identity()));
   }
}


bool SU_Command_Channel::transmit_medium_handlers(CCC_Msg *msg)
{
   th_server->multicast(*msg);
   return true;
}

void SU_Command_Channel::close_data_handler_conn(void)
{
   dh_client->close_connections();
}

