//su_conn.C

//SU_CONTROL application - SU response channel
//JIVE, May 1996

//_________________________________________________________________________

//for RCS

//$Header: /export/home/jive_cvs/JCCS/CVS_Repository/su_control/source/su_conn.C,v 3.3 2008/04/09 11:44:31 jive_cc Exp $

//$Locker:  $

//$Log: su_conn.C,v $
//Revision 3.3  2008/04/09 11:44:31  jive_cc
//BE: first version of mark5b control, also added the possibility to use the spare mk5b for production
//
//Revision 3.2  2005/12/23 13:16:56  verkout
//HV: Phew. This is the big thing. Merged all developments with both the port to Linux and the mods needed for a byte-order safe COF
//
//Revision 3.1  2004/06/25 13:21:48  verkout
//gnu3.2 version: many many MANY way too many changes
//
//Revision 3.0  2002/04/17 14:45:46  jive_cc
//Included gnu branch
//
//Revision 1.18.4.1  2002/01/07 15:51:40  jive_cc
//Friso and Arpad: many many MANY pointers were explicitely set to zero after being deleted to avoid memory problems caused by double deletions
//
//Revision 1.18  1999/08/30 17:11:13  jive_cc
//minor mod
//
//Revision 1.17  1999/08/30 09:46:43  jive_cc
//back to start footage once only
//
//Revision 1.16  1999/02/08 12:45:49  jive_cc
//various mods at jive
//
//Revision 1.15  1999/01/29 16:07:16  pwm
//Integrated peaking branch into root
//
//Revision 1.14.2.1  1999/01/19 15:44:08  pwm
//added location_broker
//
//Revision 1.14  1998/09/02 07:16:39  jive_cc
//transmit error in initialisation
//
//Revision 1.13  1998/08/26 20:00:47  jive_cc
//added quit()
//
//Revision 1.11  1998/08/26 16:55:53  jive_cc
//not calling transp->closedown()
//
//Revision 1.10  1998/08/26 09:10:06  jive_cc
//mods to close down threads
//
//Revision 1.9  1998/07/01 12:22:30  pwm
//minor corrections
//
//Revision 1.8  1998/06/19 09:30:39  jive_cc
//minor mod
//
//Revision 1.7  1998/02/09 12:54:13  klijn
//change to close conn properly
//
//Revision 1.6  1998/01/26 20:22:41  pwm
//added service manager
//
//Revision 1.5  1997/12/16 17:12:59  pwm
//Attempt to close SU connection
//
//Revision 1.4  1997/11/27 19:45:07  pwm
//Temporary mod so as no to transmit initial abort cmd to SU
//
//Revision 1.3  1997/11/07 15:28:52  pwm
//various changes
//
//Revision 1.2  1997/06/09 18:32:21  pwm
//minor change
//
//Revision 1.1  97/04/03  15:16:54  15:16:54  pwm (Paul William Maguire)
//Initial revision
//

//___________________________________________________________________________

#include <su_control/su_conn.h>

 
using namespace std;
SU_Connection::SU_Connection(Thread_ID my_id, Thread_ID parent, Thread_Master *owner,\
			     SU_Command_Channel *comm1, Transparent_channel *comm2,
			     unsigned int suid_code)
   		:Thread(my_id, parent, owner), 
                 su_id(suid_code)
{
   su_controller = 0;
   su_cmd = comm1;
   transp = comm2;
   service = 0;
   su_client_mgr = 0;
   init = false;
}

SU_Connection::~SU_Connection()
{
  cout << "~SU_Connection" << endl;
}

void SU_Connection::set_local_time(void)
{
   //set local time
   
   ieee_dbl sysclks;
   
   gettimeofday(&tod, &tzp);
     
   time_t t((long)(tod.tv_sec));
   
   tm *temp = gmtime(&t);
   sysclks = SYSTEM_RATE * (temp->tm_yday*24*60*60 + temp->tm_hour*60*60 + temp->tm_min*60 + temp->tm_sec);
   
   local_time.set_sysclks(sysclks);
   local_time.set_base_date(temp->tm_year < 90 ? 2000 + temp->tm_year : 1900 + temp->tm_year);
}
      
int SU_Connection::run()
{
   if(!init) return 1;
   this->handle_su_response();
   return 0;
}

bool SU_Connection::initialise(SU_Controller *suc)
{  
   Command_Message* cmd;
   Connection *target;
   
   su_controller = suc;
      
   //create the required service - in this case a client is required
   
   //Service_ID su_conn("/tmp/dummysu_1", &All_EVN42_Msgs);
   //this is a client so its id doesn't matter / need be known
   Service_ID *su_conn = location_if.get_service_id(SU);
      //cout << *su_conn << endl;
   
   if(su_conn &&
      (service = new Service_Client(*su_conn)) &&
      (su_client_mgr = new Service_Manager(*get_controller(), get_id(), *service, su_client_interface)) &&
      this->open_SU_Connection())
   {
      ((iosockstream *)((this->get_connection(S_U))->channel()))->rdbuf()->linger(0,1);
      cout << "su_conn initialiseed ok" << endl;
      su_client_interface.set_receive(true); //ie handle incoming messages
      get_controller() -> add_thread(su_client_mgr);
      //send SU an abort operations command 
      if(cmd = new Command_Message(SU_Station_Unit_Cmds::Abort_SU_Ops)) //A16
      {
	 this->set_local_time();
	 cmd->set_local_time(local_time);  
	 cmd->set_time_stamp(time_stamp);
	 cmd->set_sender_id(su_controller->get_SUC_ID());
	 cmd->set_receiver_id(SUID);
	 target = this->get_connection(S_U);//safer than direct access
	 //cmd->transmit(*target);//A4
	 delete cmd;
	 cmd = 0;
	 init = true;
      }
      else transmit_error(SU_Control_Error_Codes::Memory_Allocation_Exception,
			  CCC_Action_Request::Init_SU_Control);
      //transmit error message to PROCESSOR_CONTROL - A1 && A13
   }
   else transmit_error(SU_Control_Error_Codes::SU_Connection_Exception,
		       CCC_Action_Request::Init_SU_Control);
   return init;
}

bool SU_Connection::re_initialise(void)
{  
   Connection_ID* connid = 0;
   Command_Message* cmd = 0;
   Connection *target;
   
   //to reinitialise
   if(init)
   {
      if(!(su_client_interface.get_opened_iter().first()))
      {
	 //then connection gone onto bad list
	 if((connid = su_client_interface.get_bad_iter().first()) &&
	    service->connect(*connid))
	 {
	    //then conn ok
	 }
	 else return false;
      }
      
      target = this->get_connection(S_U);//safer than direct access
      if(target == 0)
      {
	 transmit_error(SU_Control_Error_Codes::SU_Connection_Exception,
			  CCC_Action_Request::Init_SU_Control);
	 return false;
      }
      
      if(cmd = new Command_Message(SU_Station_Unit_Cmds::Abort_SU_Ops))
      {
	 this->set_local_time();
	 cmd->set_local_time(local_time);  
	 cmd->set_time_stamp(time_stamp);
	 cmd->set_sender_id(su_controller->get_SUC_ID());
	 cmd->set_receiver_id(SUID);
	 cmd->transmit(*target);
	 delete cmd;
	 cmd = 0;
	 return true;
      }
      else
      {
	 transmit_error(SU_Control_Error_Codes::Memory_Allocation_Exception,
			  CCC_Action_Request::Init_SU_Control);
	 return false;
      }
   }
   else return false;
}
   
bool SU_Connection::open_SU_Connection(void)
{
   Connection_ID* connid = location_if.find_server(SU, su_id);
   
   if(connid && service->connect(*connid))
   {
      cerr << "Connection to SU successful\n";
      return true; //A15
   }
   else
   {
     cerr << "Connection to SU unsuccessful\n";
     return false;
   }
}   


int SU_Connection::shutdown()
{
   return 0;
}

int SU_Connection::quit()
{
   su_client_interface.set_quit(true);
   delete service; service = 0;
   this->set_stat(Thread::terminating);
   transp->quit();
   return 0;
}

bool SU_Connection::handle_su_response(void)
{
   Incoming_Message_Info* info;             // Incoming message/connection tuple
   Connection* temp_conn;
   CCC_Msg* cccmsg;
   unsigned int action_code, msg_id;
   Connection* target;
   
   for (info = su_client_interface.get_incoming_iter().first();
        info;
        info = su_client_interface.get_incoming_iter().advance())
   {
      temp_conn = info->get_conn();
      cccmsg = (CCC_Msg*) info->get_msg();
      //get action_code
      action_code = (unsigned int)cccmsg->get_action_code();
      //get _msg_id
      msg_id = (unsigned int)cccmsg->get_msg_id();

      // Take the message info off the 'incoming' list to stop this message
      // being handled again.
      su_client_interface.get_incoming_iter().drop();
      
      Msg_Handler_ID destination = cccmsg->get_receiver_id();
      
      //two basic possibilities - either for SU_CONTROL or not
      if(su_controller->get_SUC_ID().ip_and_obj() == destination.ip_and_obj())
      {
	 if(!su_controller->queue_response(info)) 
	 {
	    transmit_error(SU_Control_Error_Codes::SU_Response_Queuing_Exception, action_code, msg_id);
	    //transmit error message to PROCESSOR_CONTROL
	    delete cccmsg;
	    delete info;
	    cccmsg = 0;
	    info = 0;
	 }
      }
      else
      {
	 //transmit message to destination
	 //requiring transmittting via transparent_commands service
	 target = transp->get_connection(destination);
	 if(target != 0)cccmsg->transmit(*target);
	 else cout << "WARNING : Transparent channel unable to transmit SU response" << endl;
	 delete cccmsg;
	 delete info;
	 cccmsg = 0;
	 info = 0;
      }
   }
   return true;

}//end method
	

Connection* SU_Connection::get_connection(int target)
{
   switch (target) {
      case (S_U) :
	 return service->poll(0, Service_Client::ready_to_send);
      default :
	 return 0;
   }
}
   
void SU_Connection::transmit_error(unsigned int error_code, unsigned int command_code, unsigned int ref_id)
{
   Connection *target;
 
   //transmit error message to PROCESSOR_CONTROL

   	 this->set_local_time();
         error_msg.set_error_code(error_code);
	 error_msg.set_local_time(local_time);  
 	 error_msg.set_time_stamp(time_stamp);

         error_msg.set_su_id(su_controller->get_suid_code());
	 error_msg.set_sender_id(su_controller->get_SUC_ID());
	 error_msg.set_job_id(su_controller->get_job_id());
	 error_msg.set_receiver_id(su_cmd->get_PC_Handle_ID());
	 error_msg.set_action_code(command_code);
	 error_msg.set_ref_id(ref_id);

	 target = su_cmd->get_connection(PROCESSOR_CONTROL);
	 if(target != 0) error_msg.transmit(*target);
}
