//su_control_body.C

//SU_CONTROL application - first cut

//JIVE, May 1996

//_________________________________________________________________________

//for RCS

//$Header: /export/home/jive_cvs/JCCS/CVS_Repository/su_control/source/su_control.C,v 3.6 2009/04/23 14:16:23 jive_cc Exp $

//$Locker:  $

//$Log: su_control.C,v $
//Revision 3.6  2009/04/23 14:16:23  jive_cc
//BE: prevent interaction with the mark5 if the station is a slave in disk based merlin cast
//
//Revision 3.5  2006/08/21 14:36:36  jive_cc
//kettenis: Fix some whitespace issues.
//
//Revision 3.4  2005/12/23 13:16:56  verkout
//HV: Phew. This is the big thing. Merged all developments with both the port to Linux and the mods needed for a byte-order safe COF
//
//Revision 3.3  2004/06/25 13:21:49  verkout
//gnu3.2 version: many many MANY way too many changes
//
//Revision 3.2  2004/05/03 15:26:37  jive_cc
//Arpad: added evlbi option
//
//Revision 3.1  2003/05/15 11:46:36  jive_cc
//Arpad: merged MarkV version into main
//
//Revision 3.0.2.1  2003/01/13 15:09:26  jive_cc
//*** empty log message ***
//
//Revision 3.0  2002/04/17 14:45:46  jive_cc
//Included gnu branch
//
//Revision 1.8.4.1  2002/01/07 15:51:41  jive_cc
//Friso and Arpad: many many MANY pointers were explicitely set to zero after being deleted to avoid memory problems caused by double deletions
//
//Revision 1.8  1999/02/17 20:20:49  pwm
//debugging
//
//Revision 1.7  1999/01/29 16:07:17  pwm
//Integrated peaking branch into root
//
//Revision 1.6.2.1  1999/01/19 15:44:08  pwm
//added location_broker
//
//Revision 1.6  1998/07/01 12:23:05  pwm
//minor correction
//
//Revision 1.5  1998/04/02 12:56:31  pwm
//Removed tape_id arg
//
//Revision 1.4  1998/02/23 16:08:05  klijn
//added tape_id to cmd line arg (temporary)su_control.C
//
//Revision 1.3  1998/01/26 20:20:22  pwm
//Added args to main
//
//Revision 1.2  1997/11/07 15:29:48  pwm
//minor changes in consttuctor of Init_Proc
//
//Revision 1.1  97/04/03  15:17:59  15:17:59  pwm (Paul William Maguire)
//Initial revision
//

//___________________________________________________________________________




#include <controllers/thread.h>
#include <su_control/su_conn.h>
#include <su_control/su_cmd.h>
#include <su_control/transp.h>
#include <su_control/init_proc.h>
#include <su_control/su_defs.h>

using namespace std;
int main(int argc, char *argv[])
{
   //assume PROCESSOR_CONTROL starts up some object SU_CONTROL with the su_id parameter
   
   unsigned int suid_code;
   bool disk = 0;
   bool evilBI = 0;
   bool merlin_slave = false;

   cout << "su_control: argc = " << argc << endl;
   cout << "su_control: argv = " << argv[0] << " " << argv[1] << " " << argv[2] << " " << argv[3] << endl; 
   switch(argc){
      case (1) :
	 {
	    suid_code = 1;
	    disk = 0;
	    evilBI = 0;
	 }
	 break;
      case (5) :
	merlin_slave = atoi(argv[4]);
      case (4) :
	 {
	    suid_code = atoi(argv[1]);
	    disk = atoi(argv[2]);
	    evilBI = atoi(argv[3]);
	    cout << "su_control: case(3), disk = " << disk << " evilBI = " << evilBI << endl;
	 }
	 break;	 
      default : 
	cout << "su_control: case default " << endl;
	return 2;
   }
   
   Thread_Master master;
   dbg_process_id = "SU_CONTROL";
   
   Init_Proc *in_proc = 0;
   SU_Command_Channel *comm1 = 0;   
   Transparent_channel *comm2 = 0;
   SU_Connection *comm3 = 0;
   
   if(!(comm1 = new SU_Command_Channel(master.new_thread_id(),0,&master, suid_code)) ||
      !(comm2 = new Transparent_channel(master.new_thread_id(),0,&master, comm1, suid_code)) ||
      !(comm3 = new SU_Connection(master.new_thread_id(),0,&master, comm1, comm2, suid_code)) ||
      !(in_proc = new Init_Proc(master.new_thread_id(),0,&master, suid_code, disk, evilBI, comm1, comm3)))
   {
      delete comm1;
      delete comm2;
      delete comm3;
      delete in_proc;
      comm1 = 0;
      comm2 = 0;
      comm3 = 0;
      in_proc = 0;
      return 2;
   }
   
   //initalise all channels, etc
   if(!(comm1->initialise(in_proc)) || !(comm2->initialise(in_proc, comm3)) || 
      !(comm3->initialise(in_proc)))
      {
	 //any opened connections are closed automatically in destructors
	 delete in_proc;
	 delete comm1;
	 delete comm2;
	 delete comm3;
	 comm1 = 0;
	 comm2 = 0;
	 comm3 = 0;
	 in_proc = 0;
	 return 2;
      }//== Open Connections
   
   in_proc->disk_unit.merlin_slave = merlin_slave;

   master.add_thread((Thread*) in_proc);
   master.add_thread((Thread*) comm1);
   master.add_thread((Thread*) comm2);
   master.add_thread((Thread*) comm3);
   
   while(! master.run());
   
   return 0;
}
