#include <su_control/su_controller.h>

using namespace std;

SU_Controller::SU_Controller() {
  cmd_iter = new Forward_List_Iter<Incoming_Message_Info *>(&cmd_queue);
}

SU_Controller::~SU_Controller() {
  delete cmd_iter;
}

bool SU_Controller::queue_cmd(Incoming_Message_Info* info) {
  if(cmd_queue.append(info) != -1) return true;
  else return false;
}

bool SU_Controller::in_cmd_queue(const unsigned int cmd_code) const {
  //check cmd_queue for message with cmd_code
  CCC_Msg *ccc_msg;
  Command_Message *cmd;
  
  if(cmd_iter->first() == 0) { //position iterator to first element if existant
    return false;
  }
  do {
    ccc_msg = (CCC_Msg *)((Incoming_Message_Info *)cmd_iter->contents())->get_msg();
    if(ccc_msg->get_message_type() == SU_Message_Types::Action_Request &&
       ccc_msg->get_action_code() > SU_Action_Masks::Command_Message) {
      cmd = (Command_Message *)ccc_msg;
      if(cmd->get_command_code() == cmd_code) return true;
    }
  } while (cmd_iter->advance());
  return false;
}

bool SU_Controller::action_req_in_cmd_queue(const unsigned int SU_action_value) const {
  //check cmd_queue for cjd message
  CCC_Msg *ccc_msg;
  
  if (cmd_iter->first() == 0) return false; //position iterator to first element if existant
   
  do {
    ccc_msg = (CCC_Msg *)((Incoming_Message_Info *)cmd_iter->contents())->get_msg();
    if (ccc_msg->get_message_type() == SU_Message_Types::Action_Request) {
      if (ccc_msg->get_action_code() == SU_action_value) return true;
    }
  } while (cmd_iter->advance());
  return false;
}

